// BinaryView.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "BinaryView.h"


// CBinaryView
IMPLEMENT_DYNCREATE(CBinaryView, CFormView)

CBinaryView::CBinaryView()
	: CFormView(CBinaryView::IDD)
{
	m_pDumpCtrl = NULL;

	memset(m_nNewData,0,8192);
	memset(m_nOldData,0,8192);

	m_spec_char = ".";
	m_format_tootip = _T("Address: %R Hex%n------ Data -------%nHex:%t%H%nDec:%t%D%nOct:%t%O%nBin:%t%B%nAscii:%t%A");
	m_offset_address = 0;

	m_bStyle [0] = TRUE; //Address in Control Bar
	m_bStyle [1] = TRUE; //Hex in Control Bar
	m_bStyle [2] = TRUE; //Dec in Control Bar
	m_bStyle [3] = TRUE; //Bin in Control Bar
	m_bStyle [4] = FALSE;//Oct in Control Bar
	m_bStyle [5] = TRUE; //Ascii in Control Bar
	m_bStyle [6] = TRUE; //Address in Control Bar
	m_bStyle [7] = TRUE; //Hex in Control Bar
	m_bStyle [8] = FALSE;//Dec in Control Bar
	m_bStyle [9] = FALSE; //Bin in Control Bar
	m_bStyle [10] = FALSE;//Oct in Control Bar
	m_bStyle [11] = TRUE; //Ascii in Control Bar
	m_bStyle [12] = TRUE; //Field's Name
	m_bStyle [13] = FALSE;//Word Data
	m_bStyle [14] = TRUE; //Separators
	m_bStyle [15] = FALSE;//Read Only
	m_bStyle [16] = FALSE;//Selecting Data
	m_bStyle [17] = FALSE; //Low to High Byte
	m_bStyle [18] = TRUE; //Track Mouse
	
	m_bEnable = TRUE; //Enable Window

	m_dwDataLength = 8192;

}

CBinaryView::~CBinaryView()
{
	if (m_pDumpCtrl) {
		delete m_pDumpCtrl;
	}
}

BOOL CBinaryView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////

void CBinaryView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, BTN_BIN_UPDATE, m_btnBinUpdate);
	DDX_Control(pDX, EDT_CREATE_NAME, m_edtCreateName);
	DDX_Control(pDX, EDT_DATA_SIZE, m_edtDataSize);
	DDX_Control(pDX, CBO_DATA_TYPE, m_cboDataType);
}

BEGIN_MESSAGE_MAP(CBinaryView, CFormView)
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
#if _MSC_VER >= 1400
	ON_BN_CLICKED(BTN_BIN_UPDATE, &CBinaryView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, &CBinaryView::OnEnChangeCreateName)
	ON_CBN_SELCHANGE(CBO_DATA_TYPE, &CBinaryView::OnCbnSelchangeStringType)
	ON_NOTIFY (UDM_PPDUMPCTRL_CHANGE_DATA, ID_DUMPCTRL, &CBinaryView::NotifyEditData)
	ON_EN_CHANGE(EDT_DATA_SIZE, &CBinaryView::OnEnChangeDataSize)
#else
	ON_BN_CLICKED(BTN_BIN_UPDATE, CBinaryView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, CBinaryView::OnEnChangeCreateName)
	ON_CBN_SELCHANGE(CBO_DATA_TYPE, CBinaryView::OnCbnSelchangeStringType)
	ON_NOTIFY (UDM_PPDUMPCTRL_CHANGE_DATA, ID_DUMPCTRL, CBinaryView::NotifyEditData)
	ON_EN_CHANGE(EDT_DATA_SIZE, CBinaryView::OnEnChangeDataSize)
#endif
END_MESSAGE_MAP()


// CBinaryView diagnostics
#ifdef _DEBUG
void CBinaryView::AssertValid() const { CFormView::AssertValid(); }
#ifndef _WIN32_WCE
void CBinaryView::Dump(CDumpContext& dc) const { CFormView::Dump(dc); }
#endif
#endif //_DEBUG


// CBinaryView message handlers
void CBinaryView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	m_btnBinUpdate.EnableWindow(FALSE);
	m_edtDataSize.EnableWindow(FALSE);

	m_nRegBinary = m_cboDataType.AddString(_T("REG_BINARY"));
	m_nRegFullRes = m_cboDataType.AddString(_T("REG_FULL_RESOURCE_DESCRIPTOR"));
	m_nRegResList = m_cboDataType.AddString(_T("REG_RESOURCE_LIST"));
	m_nRegResReq = m_cboDataType.AddString(_T("REG_RESOURCE_REQUIREMENTS_LIST"));
	m_nRegLink = m_cboDataType.AddString(_T("REG_LINK"));
	m_nRegQWord = m_cboDataType.AddString(_T("REG_QWORD"));

	m_cboDataType.EnableWindow(FALSE);

	m_edtDataSize.SetWindowTextA(_T("1"));

	if (m_pDumpCtrl == NULL) { 
		//
		CRect rect;
		CEdit * pEdit = (CEdit*)GetDlgItem(EDT_HEX_CTRL);
		pEdit->GetWindowRect(&rect);
		ScreenToClient(&rect);
		pEdit->ShowWindow(FALSE);

		m_pDumpCtrl = new CPPDumpCtrl;
		if (!m_pDumpCtrl) {
			return;
		}
		m_pDumpCtrl->Create(rect, this, ID_DUMPCTRL);
    }
	SetNewStyle();

	//Customize the drawing char for special characters
	m_pDumpCtrl->SetSpecialCharView(m_spec_char[0]);
	m_pDumpCtrl->SetNotify(this->m_hWnd);

	theApp.m_clsBin = (CBinaryView*)this;

}

void CBinaryView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	if (m_pDumpCtrl->GetSafeHwnd())
	{
		CRect rect,newRect;
		GetClientRect(rect);
		newRect = rect;
		newRect.top = rect.top+43;
		m_pDumpCtrl->MoveWindow(newRect);
	}
}

void CBinaryView::SetNewStyle()
{
	UINT nNewStyle = 0;
	UINT nStyle[] = {
		PPDUMP_BAR_ADDRESS,
		PPDUMP_BAR_HEX,
		PPDUMP_BAR_DEC,
		PPDUMP_BAR_BIN,
		PPDUMP_BAR_OCT,
		PPDUMP_BAR_ASCII,
		PPDUMP_FIELD_ADDRESS,
		PPDUMP_FIELD_HEX,
		PPDUMP_FIELD_DEC,
		PPDUMP_FIELD_BIN,
		PPDUMP_FIELD_OCT,
		PPDUMP_FIELD_ASCII,
		PPDUMP_NAMED_FIELDS,
		PPDUMP_WORD_DATA,
		PPDUMP_SEPARATOR_LINES,
		PPDUMP_READ_ONLY,
		PPDUMP_SELECTING_DATA,
		PPDUMP_DATA_LOW_HIGH,
		PPDUMP_TRACK_MOUSE_MOVE
					};
	for (int i = 0; i < 19; i++)
	{
		if (m_bStyle [i])
			nNewStyle |= nStyle [i];
	}
	m_pDumpCtrl->SetStyles(nNewStyle, TRUE);
}

void CBinaryView::SetNewValueData(UINT nAddr, UINT nValue)
{
	//Byte Data
	m_nOldData [nAddr] = m_nNewData [nAddr];
	m_nNewData [nAddr] = LOBYTE (nValue);
	m_pDumpCtrl->SetPointerData(m_dwDataLength, m_nNewData, m_nOldData, FALSE);
	m_btnBinUpdate.EnableWindow(TRUE);
	m_offset_address = nAddr;
//	m_pDumpCtrl->SetOffsetViewAddress(m_offset_address);
	m_pDumpCtrl->RedrawWindow();
}

void CBinaryView::NotifyEditData(NMHDR * pNMHDR, LRESULT * result)
{
	//User changed data
	*result = 0;
	NM_PPDUMP_CTRL * pNotify = (NM_PPDUMP_CTRL*)pNMHDR;
	SetNewValueData(pNotify->iAddress, pNotify->iValue);
}

BOOL CBinaryView::SetBinaryData(DWORD dwDataLength, BYTE* pData)
{
	if (dwDataLength > 8192) {
		return FALSE;
	}
	if (pData != NULL) {
		memcpy(m_nNewData, pData, dwDataLength);
		m_dwDataLength = dwDataLength;
		m_pDumpCtrl->SetPointerData(m_dwDataLength, m_nNewData, m_nOldData);
		SetNewStyle();
		return TRUE;
	}
	return FALSE;
}

void CBinaryView::OnBnClickedUpdate()
{
	BOOL bRet = FALSE;
	if (!m_bCreating) {
		if (m_dwRegType == REG_BINARY) {
			bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName, 
													m_nNewData, 
													(UINT)m_dwDataLength,
													REG_BINARY);
		}
		else if (m_dwRegType == REG_FULL_RESOURCE_DESCRIPTOR) {
			bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName, 
													m_nNewData, 
													(UINT)m_dwDataLength,
													REG_FULL_RESOURCE_DESCRIPTOR);
		}
		else if (m_dwRegType == REG_RESOURCE_LIST) {
			bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName, 
													m_nNewData, 
													(UINT)m_dwDataLength,
													REG_RESOURCE_LIST);
		}
		else if (m_dwRegType == REG_RESOURCE_REQUIREMENTS_LIST) {
			bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName, 
													m_nNewData, 
													(UINT)m_dwDataLength,
													REG_RESOURCE_REQUIREMENTS_LIST);
		}
		else if (m_dwRegType == REG_LINK) {
			bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName, 
													m_nNewData, 
													(UINT)m_dwDataLength,
													REG_LINK);
		}
		else if (m_dwRegType == REG_QWORD) {
			bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName, 
													m_nNewData, 
													(UINT)m_dwDataLength,
													REG_QWORD);
		}
		else if (m_dwRegType == REG_NONE) {
			;
		}
		else {
			return;
		}
	}
	else {
		CString csDataSize = _T("");
		m_edtDataSize.GetWindowText(csDataSize);

		m_nDataSize = atoi(csDataSize);
		if (m_nDataSize > 0) {
			//
			GetDlgItem(EDT_CREATE_NAME)->GetWindowText(m_csValueName);

			//
			BYTE *pData = new BYTE[m_nDataSize];
			for (int n=0; n<m_nDataSize; n++) {
				pData[n] = 0;
			}
			SetBinaryData(m_nDataSize,pData);

			if (m_cboDataType.GetCurSel() == m_nRegBinary) {
				bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
														m_csValueName, 
														pData, 
														(UINT)m_nDataSize,
														REG_BINARY);
			}
			else if (m_cboDataType.GetCurSel() == m_nRegFullRes) {
				bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
														m_csValueName, 
														pData, 
														(UINT)m_nDataSize,
														REG_FULL_RESOURCE_DESCRIPTOR);
			}
			else if (m_cboDataType.GetCurSel() == m_nRegResList) {
				bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
														m_csValueName, 
														pData, 
														(UINT)m_nDataSize,
														REG_RESOURCE_LIST);
			}
			else if (m_cboDataType.GetCurSel() == m_nRegResReq) {
				bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
														m_csValueName, 
														pData, 
														(UINT)m_nDataSize,
														REG_RESOURCE_REQUIREMENTS_LIST);
			}
			else if (m_cboDataType.GetCurSel() == m_nRegLink) {
				bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
														m_csValueName, 
														pData, 
														(UINT)m_nDataSize,
														REG_LINK);
			}
			else if (m_cboDataType.GetCurSel() == m_nRegQWord) {
				bRet = theApp.m_clsTV->m_ntReg.WriteValue(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
														m_csValueName, 
														pData, 
														(UINT)m_nDataSize,
														REG_QWORD);
			}

			delete [] pData;

		}
		else {
			return;
		}
	}

	if (bRet) {
		theApp.m_clsLV->m_xList.SetRedraw(FALSE);
		theApp.m_clsTV->ShowValues();
		for (int n=0; n<theApp.m_clsLV->m_xList.GetItemCount(); n++) {
			CString csText = theApp.m_clsLV->m_xList.GetItemText(n,0);
			if (csText == m_csValueName) {
				theApp.m_clsLV->m_xList.SetCurSel(n);
			}
		}
		theApp.m_clsLV->m_xList.SetRedraw(TRUE);
		m_btnBinUpdate.EnableWindow(FALSE);
		m_edtDataSize.EnableWindow(FALSE);
		m_cboDataType.EnableWindow(FALSE);
		m_edtCreateName.SetWindowText(_T(""));
	}
}

void CBinaryView::OnSetFocus(CWnd* pOldWnd)
{
	CFormView::OnSetFocus(pOldWnd);
	m_btnBinUpdate.EnableWindow(FALSE);
}

void CBinaryView::OnEnChangeCreateName()
{
	CString csValueName = _T("");
	m_edtCreateName.GetWindowTextA(csValueName);
	if (csValueName.IsEmpty()) {
		m_edtDataSize.EnableWindow(FALSE);
		m_cboDataType.EnableWindow(FALSE);
		m_btnBinUpdate.EnableWindow(FALSE);
		m_btnBinUpdate.SetWindowTextA(_T("Update"));
		m_bCreating = FALSE;
	}
	else {
		m_edtDataSize.EnableWindow(TRUE);
		m_cboDataType.EnableWindow(TRUE);
		m_btnBinUpdate.EnableWindow(TRUE);
		m_btnBinUpdate.SetWindowTextA(_T("Create"));
		m_bCreating = TRUE;
	}
}

void CBinaryView::OnCbnSelchangeStringType()
{
	// TODO: Add your control notification handler code here
}

void CBinaryView::OnEnChangeDataSize()
{
	CString csSize = _T("");
	m_edtDataSize.GetWindowTextA(csSize);
	if (csSize.IsEmpty()) {
		m_edtDataSize.SetWindowTextA(_T("1"));
	}
}
