// CcrsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "CcrsDlg.h"

#include "NtRegKeysDlg.h"

// CCcrsDlg dialog
IMPLEMENT_DYNAMIC(CCcrsDlg, CDialog)

CCcrsDlg::CCcrsDlg(int nCCRS, CWnd* pParent /*=NULL*/)
	: CDialog(CCcrsDlg::IDD, pParent)
{
	m_nCCRS = nCCRS;
	m_nSearchParams = 0;
	m_nCreateHidden = 0;
}

CCcrsDlg::~CCcrsDlg()
{
}

void CCcrsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, EDT_REG_KEY, m_edtRegKey);
	DDX_Control(pDX, EDT_REG_VALUE, m_edtRegValue);
	DDX_Control(pDX, EDT_NEW_KEY, m_edtNewRegKey);
	DDX_Control(pDX, EDT_NEW_VALUE, m_edtNewRegValue);
	DDX_Control(pDX, CHK_CREATE_HIDDEN, m_chkCreateHidden);
	DDX_Control(pDX, CHK_KEYS, m_chkKeys);
	DDX_Control(pDX, CHK_VALUES, m_chkValues);
	DDX_Control(pDX, CBO_REG_TYPES, m_cboRegTypes);
	DDX_Control(pDX, CHK_CASE_SENSITIVE, m_chkCaseSensitive);
	DDX_Control(pDX, BTN_REG_KEYS, m_btnBrowseKey);
}

BEGIN_MESSAGE_MAP(CCcrsDlg, CDialog)
#if _MSC_VER >= 1400
	ON_BN_CLICKED(BTN_REG_KEYS, &CCcrsDlg::OnBnClickedRegKeys)
	ON_BN_CLICKED(IDOK, &CCcrsDlg::OnBnClickedOk)
	ON_EN_CHANGE(EDT_NEW_VALUE, &CCcrsDlg::OnEnChangeNewValue)
	ON_BN_CLICKED(CHK_KEYS, &CCcrsDlg::OnBnClickedKeys)
	ON_BN_CLICKED(CHK_VALUES, &CCcrsDlg::OnBnClickedValues)
	ON_BN_CLICKED(CHK_CREATE_HIDDEN, &CCcrsDlg::OnBnClickedCreateHidden)
	ON_CBN_SELCHANGE(CBO_REG_TYPES, &CCcrsDlg::OnCbnSelchangeRegTypes)
	ON_BN_CLICKED(CHK_CASE_SENSITIVE, &CCcrsDlg::OnBnClickedCaseSensitive)
#else
	ON_BN_CLICKED(BTN_REG_KEYS, CCcrsDlg::OnBnClickedRegKeys)
	ON_BN_CLICKED(IDOK, CCcrsDlg::OnBnClickedOk)
	ON_EN_CHANGE(EDT_NEW_VALUE, CCcrsDlg::OnEnChangeNewValue)
	ON_BN_CLICKED(CHK_KEYS, CCcrsDlg::OnBnClickedKeys)
	ON_BN_CLICKED(CHK_VALUES, CCcrsDlg::OnBnClickedValues)
	ON_BN_CLICKED(CHK_CREATE_HIDDEN, CCcrsDlg::OnBnClickedCreateHidden)
	ON_CBN_SELCHANGE(CBO_REG_TYPES, CCcrsDlg::OnCbnSelchangeRegTypes)
	ON_BN_CLICKED(CHK_CASE_SENSITIVE, CCcrsDlg::OnBnClickedCaseSensitive)
#endif
END_MESSAGE_MAP()

// CCcrsDlg message handlers
BOOL CCcrsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// "\Registry\Machine\SOFTWARE\AnalyzIT\Settings\HiddenKey"
	m_csFromFullRegKeyPath = theApp.m_clsTV->m_ntReg.GetCurrentPath();

	m_cboRegTypes.AddString(_T("REG_BINARY"));
	m_cboRegTypes.AddString(_T("REG_DWORD"));
	m_cboRegTypes.AddString(_T("REG_EXPAND_SZ"));
	m_cboRegTypes.AddString(_T("REG_MULTI_SZ"));
	m_cboRegTypes.AddString(_T("REG_QWORD"));
	m_cboRegTypes.AddString(_T("REG_SZ"));
	m_cboRegTypes.SetCurSel(0);

	//
	m_btnBrowseKey.EnableWindow(TRUE);

	//
	m_csFromValueName = theApp.m_clsLV->m_xList.GetItemText(theApp.m_clsLV->m_xList.GetCurSel(),0);

	// Copy a Key
	if (m_nCCRS == 1) {
		//
		SetWindowText(_T("Copy a Key"));
		m_edtRegKey.EnableWindow(TRUE);
		m_edtRegKey.SetWindowText(m_csFromFullRegKeyPath);
		m_edtNewRegKey.EnableWindow(TRUE);
		m_edtNewRegKey.SetWindowText(_T(""));

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(_T(""));
		m_edtNewRegValue.EnableWindow(FALSE);
		m_edtNewRegValue.SetWindowText(_T(""));

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);
	}
	// Copy a Value
	else if (m_nCCRS == 2) {
		//
		SetWindowText(_T("Copy a Value"));
		m_edtRegKey.EnableWindow(TRUE);
		m_edtRegKey.SetWindowText(m_csFromFullRegKeyPath);
		m_edtNewRegKey.EnableWindow(TRUE);
		m_edtNewRegKey.SetWindowText(_T(""));

		m_edtRegValue.EnableWindow(TRUE);
		m_edtRegValue.SetWindowText(m_csFromValueName);
		m_edtNewRegValue.EnableWindow(TRUE);
		m_edtNewRegValue.SetWindowText(_T(""));

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);
	}
	// Create a Key
	else if (m_nCCRS == 3) {
		SetWindowText(_T("Create a Key"));
		m_edtRegKey.EnableWindow(FALSE);
		m_edtRegKey.SetWindowText(_T(""));
		m_edtNewRegKey.EnableWindow(TRUE);
		m_edtNewRegKey.SetWindowText(m_csFromFullRegKeyPath);

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(_T(""));
		m_edtNewRegValue.EnableWindow(FALSE);
		m_edtNewRegValue.SetWindowText(_T(""));

		m_chkCreateHidden.EnableWindow(TRUE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);
	}
	// Create a Hidden Key
	else if (m_nCCRS == 9) {
		SetWindowText(_T("Create a Hidden Key"));
		m_edtRegKey.EnableWindow(FALSE);
		m_edtRegKey.SetWindowText(_T(""));
		m_edtNewRegKey.EnableWindow(TRUE);
		m_edtNewRegKey.SetWindowText(m_csFromFullRegKeyPath);

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(_T(""));
		m_edtNewRegValue.EnableWindow(FALSE);
		m_edtNewRegValue.SetWindowText(_T(""));

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkCreateHidden.SetCheck(TRUE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);
	}
	// Create a Value
	else if (m_nCCRS == 4) {
		SetWindowText(_T("Create a Value"));
		m_edtRegKey.EnableWindow(FALSE);
		m_edtRegKey.SetWindowText(_T(""));
		m_edtNewRegKey.EnableWindow(TRUE);
		m_edtNewRegKey.SetWindowText(m_csFromFullRegKeyPath);

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(_T(""));
		m_edtNewRegValue.EnableWindow(TRUE);
		m_edtNewRegValue.SetWindowText(m_csFromValueName);

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);
	}
	// Search for a Key/ValueName/Value
	else if (m_nCCRS == 5) {
		SetWindowText(_T("Search for a Key/ValueName/Value"));
		m_edtRegKey.EnableWindow(TRUE);
		m_edtRegKey.SetWindowText(m_csFromFullRegKeyPath);
		m_edtNewRegKey.EnableWindow(FALSE);
		m_edtNewRegKey.SetWindowText(_T(""));

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(_T(""));
		m_edtNewRegValue.EnableWindow(TRUE);
		m_edtNewRegValue.SetWindowText(m_csFromValueName);

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkKeys.EnableWindow(TRUE);
		m_chkValues.EnableWindow(TRUE);
		m_chkCaseSensitive.EnableWindow(TRUE);

		m_chkKeys.SetCheck(1);
		m_chkValues.SetCheck(1);
		m_nSearchParams = 3;

		m_chkCaseSensitive.SetCheck(1);
		m_bCaseSensitive = TRUE;

		theApp.m_clsFS->m_lcFindSearch.DeleteAllItems();
		theApp.m_clsFS->DeleteAllColumns();

		theApp.m_clsFS->m_lcFindSearch.InsertColumn(0,_T("Key"),LVCFMT_LEFT,580);
		theApp.m_clsFS->m_lcFindSearch.InsertColumn(1,_T("ValueName"),LVCFMT_LEFT,100);
		theApp.m_clsFS->m_lcFindSearch.InsertColumn(2,_T("Value"),LVCFMT_LEFT,100);
	}
	else if (m_nCCRS == 6) {
		SetWindowText(_T("Rename a Key"));
		m_edtRegKey.EnableWindow(TRUE);
		m_edtRegKey.SetWindowText(m_csFromFullRegKeyPath);
		m_edtNewRegKey.EnableWindow(TRUE);
		m_edtNewRegKey.SetWindowText(m_csFromFullRegKeyPath);

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(_T(""));
		m_edtNewRegValue.EnableWindow(FALSE);
		m_edtNewRegValue.SetWindowText(_T(""));

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);
	}
	else if (m_nCCRS == 7) {
		SetWindowText(_T("Rename a Value"));
		m_edtRegKey.EnableWindow(FALSE);
		m_edtRegKey.SetWindowText(m_csFromFullRegKeyPath);
		m_edtNewRegKey.EnableWindow(FALSE);
		m_edtNewRegKey.SetWindowText(m_csFromFullRegKeyPath);

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(m_csFromValueName);
		m_edtNewRegValue.EnableWindow(TRUE);
		m_edtNewRegValue.SetWindowText(m_csFromValueName+_T(".New"));

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);

		m_btnBrowseKey.EnableWindow(FALSE);
	}
	// Find Hidden Key(s)
	else if (m_nCCRS == 8) {
		SetWindowText(_T("Find Hidden Key(s)"));
		m_edtRegKey.EnableWindow(FALSE);
		m_edtRegKey.SetWindowText(_T(""));
		m_edtNewRegKey.EnableWindow(TRUE);
		m_edtNewRegKey.SetWindowText(m_csFromFullRegKeyPath);

		m_edtRegValue.EnableWindow(FALSE);
		m_edtRegValue.SetWindowText(_T(""));
		m_edtNewRegValue.EnableWindow(FALSE);
		m_edtNewRegValue.SetWindowText(_T(""));

		m_chkCreateHidden.EnableWindow(FALSE);
		m_chkKeys.EnableWindow(FALSE);
		m_chkValues.EnableWindow(FALSE);
		m_chkCaseSensitive.EnableWindow(FALSE);
	
		theApp.m_clsFS->m_lcFindSearch.DeleteAllItems();
		theApp.m_clsFS->DeleteAllColumns();

		theApp.m_clsFS->m_lcFindSearch.InsertColumn(0,_T("Hidden Key(s)"),LVCFMT_LEFT,780);
	}

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CCcrsDlg::OnBnClickedRegKeys()
{
	m_csToFullRegKeyPath = _T("");
	CNtRegKeysDlg ntRegKeysDlg;
	if (ntRegKeysDlg.DoModal() == IDOK) {
		m_csToFullRegKeyPath = ntRegKeysDlg.m_ntReg.GetCurrentPath();
		m_edtNewRegKey.SetWindowText(m_csToFullRegKeyPath);
	}
}

void CCcrsDlg::OnBnClickedOk()
{
	m_edtNewRegValue.GetWindowText(m_csToValueName);
	m_edtNewRegKey.GetWindowText(m_csToFullRegKeyPath);
	OnOK();
}

void CCcrsDlg::OnEnChangeNewValue()
{
}

void CCcrsDlg::OnBnClickedKeys()
{
	if (m_chkKeys.GetCheck()) {
		m_nSearchParams++;
	}
	else {
		m_nSearchParams--;
	}
}

void CCcrsDlg::OnBnClickedValues()
{
	if (m_chkValues.GetCheck()) {
		m_nSearchParams+=2;
	}
	else {
		m_nSearchParams-=2;
	}
}

void CCcrsDlg::OnBnClickedCreateHidden()
{
	if (m_chkCreateHidden.GetCheck()) {
		m_nCreateHidden++;
	}
	else {
		m_nCreateHidden--;
	}
}

void CCcrsDlg::OnCbnSelchangeRegTypes()
{
	// TODO: Add your control notification handler code here
}

void CCcrsDlg::OnBnClickedCaseSensitive()
{
	m_bCaseSensitive = m_chkCaseSensitive.GetCheck();
}
