 // DWordView.cpp : implementation file
//

#include "StdAfx.h"
#include "NtRegEdit.h"
#include "DWordView.h"


// CDWordView
IMPLEMENT_DYNCREATE(CDWordView, CFormView)

CDWordView::CDWordView()
	: CFormView(CDWordView::IDD)
{
	m_csOriginalDecData = _T("");
}

CDWordView::~CDWordView()
{
}

void CDWordView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, EDT_DWORD_DATA, m_edtDWData);
	DDX_Control(pDX, BTN_UPDATE, m_btnUpdate);
	DDX_Control(pDX, EDT_CREATE_NAME, m_edtCreateName);
}

BEGIN_MESSAGE_MAP(CDWordView, CFormView)
	ON_WM_SIZE()
#if _MSC_VER >= 1400
	ON_EN_CHANGE(EDT_DWORD_DATA, &CDWordView::OnEnChangeDwordData)
	ON_BN_CLICKED(BTN_UPDATE, &CDWordView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, &CDWordView::OnEnChangeCreateName)
	ON_EN_UPDATE(EDT_DWORD_DATA, &CDWordView::OnEnUpdateDwordData)
#else
	ON_EN_CHANGE(EDT_DWORD_DATA, CDWordView::OnEnChangeDwordData)
	ON_BN_CLICKED(BTN_UPDATE, CDWordView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, CDWordView::OnEnChangeCreateName)
	ON_EN_UPDATE(EDT_DWORD_DATA, CDWordView::OnEnUpdateDwordData)
#endif
END_MESSAGE_MAP()


// CDWordView diagnostics
#ifdef _DEBUG
void CDWordView::AssertValid() const { CFormView::AssertValid(); }
#ifndef _WIN32_WCE
void CDWordView::Dump(CDumpContext& dc) const { CFormView::Dump(dc); }
#endif
#endif //_DEBUG


// CDWordView message handlers
void CDWordView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	m_btnUpdate.EnableWindow(FALSE);
	m_btnUpdate.SetWindowTextA(_T("Update"));
	m_bCreating = FALSE;

	theApp.m_clsDWord = (CDWordView*)this;
}

void CDWordView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here
}

BOOL CDWordView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Add your specialized code here and/or call the base class
	return CFormView::PreCreateWindow(cs);
}

void CDWordView::OnBnClickedUpdate()
{
	BOOL bOKContinue = FALSE;
	if (m_bCreating) {
		//
		m_edtCreateName.GetWindowTextA(m_csValueName);

		CString csDWData = _T("");
		m_edtDWData.GetWindowText(csDWData);
		DWORD dwData = (DWORD)atoi(csDWData);

		bOKContinue = theApp.m_clsTV->m_ntReg.WriteDword(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
												m_csValueName,
												dwData);
	}
	else {
		//
		m_edtDWData.GetWindowText(m_csOriginalDecData);
		bOKContinue = theApp.m_clsTV->m_ntReg.WriteDword(m_csValueName, (DWORD)atoi(m_csOriginalDecData));
	}

	if (bOKContinue) {
		//
		theApp.m_clsLV->m_xList.SetRedraw(FALSE);
		theApp.m_clsTV->ShowValues();
		for (int n=0; n<theApp.m_clsLV->m_xList.GetItemCount(); n++) {
			CString csText = theApp.m_clsLV->m_xList.GetItemText(n,0);
			if (csText == m_csValueName) {
				theApp.m_clsLV->m_xList.SetCurSel(n);
			}
		}
		theApp.m_clsLV->m_xList.SetRedraw(TRUE);
		//
		m_edtCreateName.SetWindowTextA(_T(""));
		m_btnUpdate.EnableWindow(FALSE);
	}
}

void CDWordView::OnEnChangeDwordData()
{
	CString csDWData = _T("");
	m_edtDWData.GetWindowText(csDWData);
	if (m_csOriginalDecData == csDWData) {
		CString csValueName = _T("");
		m_edtCreateName.GetWindowTextA(csValueName);
		if (csValueName.IsEmpty()) {
			m_btnUpdate.EnableWindow(FALSE);
		}
		else {
			m_btnUpdate.EnableWindow(TRUE);
		}
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
	}

	if (m_bCreating) {
		m_btnUpdate.SetWindowTextA(_T("Create"));
	}
	else {
		m_btnUpdate.SetWindowTextA(_T("Update"));
	}
}

void CDWordView::OnEnChangeCreateName()
{
	CString csValueName = _T("");
	m_edtCreateName.GetWindowTextA(csValueName);
	if (csValueName.IsEmpty()) {
		CString csDWData = _T("");
		m_edtDWData.GetWindowText(csDWData);
		if (m_csOriginalDecData == csDWData) {
			m_btnUpdate.EnableWindow(FALSE);
		}
		else {
			m_btnUpdate.EnableWindow(TRUE);
		}
		m_btnUpdate.SetWindowTextA(_T("Update"));
		m_bCreating = FALSE;
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
		m_btnUpdate.SetWindowTextA(_T("Create"));
		m_bCreating = TRUE;
	}
}

void CDWordView::OnEnUpdateDwordData()
{
	CString csDWData = _T("");
	m_edtDWData.GetWindowText(csDWData);
	if (m_csOriginalDecData == csDWData) {
		m_btnUpdate.EnableWindow(FALSE);
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
	}
}
