// FindSearchView.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "TokenEx.h"
#include "FindSearchView.h"


// CFindSearchView

IMPLEMENT_DYNCREATE(CFindSearchView, CFormView)

CFindSearchView::CFindSearchView()
	: CFormView(CFindSearchView::IDD)
{
}

CFindSearchView::~CFindSearchView()
{
}

void CFindSearchView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, LC_FIND_SEARCH, m_lcFindSearch);
}

BEGIN_MESSAGE_MAP(CFindSearchView, CFormView)
	ON_WM_SIZE()
#if _MSC_VER >= 1400
	ON_NOTIFY(NM_DBLCLK, LC_FIND_SEARCH, &CFindSearchView::OnNMDblclkFindSearch)
#else
	ON_NOTIFY(NM_DBLCLK, LC_FIND_SEARCH, CFindSearchView::OnNMDblclkFindSearch)
#endif
END_MESSAGE_MAP()


// CFindSearchView diagnostics

#ifdef _DEBUG
void CFindSearchView::AssertValid() const
{
	CFormView::AssertValid();
}

#ifndef _WIN32_WCE
void CFindSearchView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif
#endif //_DEBUG


// CFindSearchView message handlers

void CFindSearchView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	m_lcFindSearch.InsertColumn(0,_T("Key"),LVCFMT_LEFT,580);
	m_lcFindSearch.InsertColumn(1,_T("ValueName"),LVCFMT_LEFT,100);
	m_lcFindSearch.InsertColumn(2,_T("Value"),LVCFMT_LEFT,100);

	m_lcFindSearch.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT|LVS_EX_INFOTIP);

	theApp.m_clsFS = (CFindSearchView*)this;
}

void CFindSearchView::OnSize(UINT nType, int cx, int cy)
{
	CFormView::OnSize(nType, cx, cy);

	if (m_lcFindSearch.GetSafeHwnd())
	{
		CRect rect;
		GetClientRect(rect);
		m_lcFindSearch.MoveWindow(rect);
	}
}

void CFindSearchView::DeleteAllColumns (void)
{
	int nColumnCount = m_lcFindSearch.GetHeaderCtrl()->GetItemCount();
	// Delete all of the columns.
	for (int i=0;i < nColumnCount; i++) {
		m_lcFindSearch.DeleteColumn(0);
	}
}
void CFindSearchView::OnNMDblclkFindSearch(NMHDR *pNMHDR, LRESULT *pResult)
{
	NMLISTVIEW* pLc = reinterpret_cast<NMLISTVIEW*>(pNMHDR);

	if (pLc->iItem < 0) {
		*pResult = 0;
		return;
	}

	if (pLc->iSubItem < 0) {
		*pResult = 0;
		return;
	}

	CString csTmp = m_lcFindSearch.GetItemText(pLc->iItem, 0);
	theApp.m_clsTV->TraverseTree(csTmp);

	if (theApp.m_clsTV->m_ntReg.SetKey(csTmp,FALSE,TRUE)) {
		//
		theApp.m_clsTV->ShowValues();

		Sleep(50);

		// Select List control item (if any)
		csTmp = m_lcFindSearch.GetItemText(pLc->iItem, 1);
		for (int n=0; n<theApp.m_clsLV->m_xList.GetItemCount(); n++) {
			CString csItem = theApp.m_clsLV->m_xList.GetItemText(n,0);
			if (csItem.CompareNoCase(csTmp) == 0) {
				theApp.m_clsLV->m_xList.SetCurSel(n);
				break;
			}
		}
	}

	*pResult = 0;
}

