// MStringView.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "MStringView.h"

#include "TokenEx.h"

// CMStringView
IMPLEMENT_DYNCREATE(CMStringView, CFormView)

CMStringView::CMStringView()
	: CFormView(CMStringView::IDD)
{
}

CMStringView::~CMStringView()
{
}

void CMStringView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, EDT_MSTRINGS, m_edtMSData);
	DDX_Control(pDX, BTN_UPDATE, m_btnUpdate);
	DDX_Control(pDX, EDT_CREATE_NAME, m_edtCreateName);
}

BEGIN_MESSAGE_MAP(CMStringView, CFormView)
#if _MSC_VER >= 1400
	ON_EN_CHANGE(EDT_MSTRINGS, &CMStringView::OnEnChangeMSData)
	ON_BN_CLICKED(BTN_UPDATE, &CMStringView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, &CMStringView::OnEnChangeCreateName)
#else
	ON_EN_CHANGE(EDT_MSTRINGS, CMStringView::OnEnChangeMSData)
	ON_BN_CLICKED(BTN_UPDATE, CMStringView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, CMStringView::OnEnChangeCreateName)
#endif
END_MESSAGE_MAP()


// CMStringView diagnostics
#ifdef _DEBUG
void CMStringView::AssertValid() const { CFormView::AssertValid(); }
#ifndef _WIN32_WCE
	void CMStringView::Dump(CDumpContext& dc) const { CFormView::Dump(dc); }
#endif
#endif //_DEBUG


// CMStringView message handlers
void CMStringView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	m_btnUpdate.EnableWindow(FALSE);
	m_btnUpdate.SetWindowTextA(_T("Update"));
	m_bCreating = FALSE;

	theApp.m_clsMString = (CMStringView*)this;
}

void CMStringView::OnEnChangeMSData()
{
	CString csData = _T("");
	m_edtMSData.GetWindowText(csData);
	if (m_csOriginalData == csData) {
		CString csValueName = _T("");
		m_edtCreateName.GetWindowTextA(csValueName);
		if (csValueName.IsEmpty()) {
			m_btnUpdate.EnableWindow(FALSE);
		}
		else {
			m_btnUpdate.EnableWindow(TRUE);
		}
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
	}

	if (m_bCreating) {
		m_btnUpdate.SetWindowTextA(_T("Create"));
	}
	else {
		m_btnUpdate.SetWindowTextA(_T("Update"));
	}
}

void CMStringView::OnBnClickedUpdate()
{
	CString csData = _T("");
	m_edtMSData.GetWindowText(csData);

	CTokenEx tok;
	tok.Split(csData,_T("\r\n"));
	CStringArray& csaData = tok.GetCStringArray();

	BOOL bOKContinue = FALSE;
	if (m_bCreating) {
		//
		m_edtCreateName.GetWindowTextA(m_csValueName);
		bOKContinue = theApp.m_clsTV->m_ntReg.WriteMultiString(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
																m_csValueName, csaData);
	}
	else {
		bOKContinue = theApp.m_clsTV->m_ntReg.WriteMultiString(m_csValueName, csaData);
	}

	if (bOKContinue) {
		//
		theApp.m_clsLV->m_xList.SetRedraw(FALSE);
		theApp.m_clsTV->ShowValues();
		for (int n=0; n<theApp.m_clsLV->m_xList.GetItemCount(); n++) {
			CString csText = theApp.m_clsLV->m_xList.GetItemText(n,0);
			if (csText == m_csValueName) {
				theApp.m_clsLV->m_xList.SetCurSel(n);
			}
		}
		theApp.m_clsLV->m_xList.SetRedraw(TRUE);
		m_edtCreateName.SetWindowTextA(_T(""));
		m_btnUpdate.EnableWindow(FALSE);
	}
}

void CMStringView::OnEnChangeCreateName()
{
	CString csValueName = _T("");
	m_edtCreateName.GetWindowTextA(csValueName);
	if (csValueName.IsEmpty()) {
		CString csData = _T("");
		m_edtMSData.GetWindowText(csData);
		if (m_csOriginalData == csData) {
			m_btnUpdate.EnableWindow(FALSE);
		}
		else {
			m_btnUpdate.EnableWindow(TRUE);
		}
		m_btnUpdate.SetWindowTextA(_T("Update"));
		m_bCreating = FALSE;
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
		m_btnUpdate.SetWindowTextA(_T("Create"));
		m_bCreating = TRUE;
	}
}
