// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "NtRegEdit.h"

#include "NtRegistry.h"
#include "TokenEx.h"

#include "StdioFileEx.h"

#include "NtRegEditTreeView.h"
#include "NtRegEditView.h"
#include "BinaryView.h"
#include "DWordView.h"
#include "MStringView.h"
#include "StringView.h"
#include "FindSearchView.h"

#include "CcrsDlg.h"

#include "OptGeneralDlg.h"
#include "OptTreeDlg.h"
#include "OptListDlg.h"

#include "MainFrm.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CMainFrame
IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_DESTROY()
#if _MSC_VER >= 1400
	ON_COMMAND(ID_EDIT_COPY, &CMainFrame::OnCopyKeyValue)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, &CMainFrame::OnUpdateCopyKeyValue)
	ON_COMMAND(ID_NEW_KEY, &CMainFrame::OnCreateKey)
	ON_UPDATE_COMMAND_UI(ID_NEW_KEY, &CMainFrame::OnUpdateCreateKey)
	ON_COMMAND(ID_NEW_HIDDENKEY, &CMainFrame::OnCreateHiddenKey)
	ON_UPDATE_COMMAND_UI(ID_NEW_HIDDENKEY, &CMainFrame::OnUpdateCreateHiddenKey)
	ON_COMMAND(ID_EDIT_SEARCH, &CMainFrame::OnSearch)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SEARCH, &CMainFrame::OnUpdateSearch)
	ON_COMMAND(ID_EDIT_DELETE, &CMainFrame::OnDeleteKeyValue)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELETE, &CMainFrame::OnUpdateDeleteKeyValue)
	ON_COMMAND(ID_EDIT_DELETERECURSIVELY, &CMainFrame::OnRecursivelyKey)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELETERECURSIVELY, &CMainFrame::OnUpdateRecursivelyKey)
	ON_COMMAND(ID_EDIT_FINDHIDDEN, &CMainFrame::OnKeysFindhiddenkeys)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FINDHIDDEN, &CMainFrame::OnUpdateKeysFindhiddenkeys)
	ON_COMMAND(ID_EDIT_RENAME, &CMainFrame::OnRenameKeyValue)
	ON_UPDATE_COMMAND_UI(ID_EDIT_RENAME, &CMainFrame::OnUpdateRenameKeyValue)
	ON_COMMAND(ID_VIEW_REFRESH, &CMainFrame::OnKeysRefresh)
	ON_UPDATE_COMMAND_UI(ID_VIEW_REFRESH, &CMainFrame::OnUpdateKeysRefresh)
	ON_COMMAND(ID_NEW_BIN_VALUE, &CMainFrame::OnNewBinary)
	ON_UPDATE_COMMAND_UI(ID_NEW_BIN_VALUE, &CMainFrame::OnUpdateNewBinary)
	ON_COMMAND(ID_NEW_DW_VALUE, &CMainFrame::OnNewDword)
	ON_UPDATE_COMMAND_UI(ID_NEW_DW_VALUE, &CMainFrame::OnUpdateNewDword)
	ON_COMMAND(ID_NEW_SZ_VALUE, &CMainFrame::OnNewSzValue)
	ON_UPDATE_COMMAND_UI(ID_NEW_SZ_VALUE, &CMainFrame::OnUpdateNewSzValue)
	ON_COMMAND(ID_NEW_SZE_VALUE, &CMainFrame::OnNewSzeValue)
	ON_UPDATE_COMMAND_UI(ID_NEW_SZE_VALUE, &CMainFrame::OnUpdateNewSzeValue)
	ON_COMMAND(ID_NEW_SZM_VALUE, &CMainFrame::OnNewSzmValue)
	ON_UPDATE_COMMAND_UI(ID_NEW_SZM_VALUE, &CMainFrame::OnUpdateNewSzmValue)
	ON_COMMAND(ID_FILE_EXPORT, &CMainFrame::OnFileExport)
	ON_UPDATE_COMMAND_UI(ID_FILE_EXPORT, &CMainFrame::OnUpdateFileExport)
	ON_COMMAND(ID_FILE_IMPORT, &CMainFrame::OnFileImport)
	ON_UPDATE_COMMAND_UI(ID_FILE_IMPORT, &CMainFrame::OnUpdateFileImport)
	ON_COMMAND(ID_EDIT_PERMISSIONS, &CMainFrame::OnEditPermissions)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PERMISSIONS, &CMainFrame::OnUpdateEditPermissions)

	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, &CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, &CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, &CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, &CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_APP_SETTINGS, &CMainFrame::OnAppSettings)
	ON_UPDATE_COMMAND_UI(ID_APP_SETTINGS, &CMainFrame::OnUpdateAppSettings)
	ON_COMMAND(ID_NEW_QW_VALUE, &CMainFrame::OnNewQword)
	ON_UPDATE_COMMAND_UI(ID_NEW_QW_VALUE, &CMainFrame::OnUpdateNewQwordValue)
	ON_COMMAND(ID_NTREG_CONNECT, &CMainFrame::OnNtregConnect)
	ON_UPDATE_COMMAND_UI(ID_NTREG_CONNECT, &CMainFrame::OnUpdateNtregConnect)
	ON_COMMAND(ID_NTREG_REFRESH, &CMainFrame::OnNtregRefresh)
	ON_UPDATE_COMMAND_UI(ID_NTREG_REFRESH, &CMainFrame::OnUpdateNtregRefresh)
	ON_COMMAND(ID_NTREG_DISCONNECT, &CMainFrame::OnNtregDisconnect)
	ON_UPDATE_COMMAND_UI(ID_NTREG_DISCONNECT, &CMainFrame::OnUpdateNtregDisconnect)
#else
	ON_COMMAND(ID_EDIT_COPY, CMainFrame::OnCopyKeyValue)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, CMainFrame::OnUpdateCopyKeyValue)
	ON_COMMAND(ID_NEW_KEY, CMainFrame::OnCreateKey)
	ON_UPDATE_COMMAND_UI(ID_NEW_KEY, CMainFrame::OnUpdateCreateKey)
	ON_COMMAND(ID_NEW_HIDDENKEY, CMainFrame::OnCreateHiddenKey)
	ON_UPDATE_COMMAND_UI(ID_NEW_HIDDENKEY, CMainFrame::OnUpdateCreateHiddenKey)
	ON_COMMAND(ID_EDIT_SEARCH, CMainFrame::OnSearch)
	ON_UPDATE_COMMAND_UI(ID_EDIT_SEARCH, CMainFrame::OnUpdateSearch)
	ON_COMMAND(ID_EDIT_DELETE, CMainFrame::OnDeleteKeyValue)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELETE, CMainFrame::OnUpdateDeleteKeyValue)
	ON_COMMAND(ID_EDIT_DELETERECURSIVELY, CMainFrame::OnRecursivelyKey)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DELETERECURSIVELY, CMainFrame::OnUpdateRecursivelyKey)
	ON_COMMAND(ID_EDIT_FINDHIDDEN, CMainFrame::OnKeysFindhiddenkeys)
	ON_UPDATE_COMMAND_UI(ID_EDIT_FINDHIDDEN, CMainFrame::OnUpdateKeysFindhiddenkeys)
	ON_COMMAND(ID_EDIT_RENAME, CMainFrame::OnRenameKeyValue)
	ON_UPDATE_COMMAND_UI(ID_EDIT_RENAME, CMainFrame::OnUpdateRenameKeyValue)
	ON_COMMAND(ID_VIEW_REFRESH, CMainFrame::OnKeysRefresh)
	ON_UPDATE_COMMAND_UI(ID_VIEW_REFRESH, CMainFrame::OnUpdateKeysRefresh)
	ON_COMMAND(ID_NEW_BIN_VALUE, CMainFrame::OnNewBinary)
	ON_UPDATE_COMMAND_UI(ID_NEW_BIN_VALUE, CMainFrame::OnUpdateNewBinary)
	ON_COMMAND(ID_NEW_DW_VALUE, CMainFrame::OnNewDword)
	ON_UPDATE_COMMAND_UI(ID_NEW_DW_VALUE, CMainFrame::OnUpdateNewDword)
	ON_COMMAND(ID_NEW_SZ_VALUE, CMainFrame::OnNewSzValue)
	ON_UPDATE_COMMAND_UI(ID_NEW_SZ_VALUE, CMainFrame::OnUpdateNewSzValue)
	ON_COMMAND(ID_NEW_SZE_VALUE, CMainFrame::OnNewSzeValue)
	ON_UPDATE_COMMAND_UI(ID_NEW_SZE_VALUE, CMainFrame::OnUpdateNewSzeValue)
	ON_COMMAND(ID_NEW_SZM_VALUE, CMainFrame::OnNewSzmValue)
	ON_UPDATE_COMMAND_UI(ID_NEW_SZM_VALUE, CMainFrame::OnUpdateNewSzmValue)
	ON_COMMAND(ID_FILE_EXPORT, CMainFrame::OnFileExport)
	ON_UPDATE_COMMAND_UI(ID_FILE_EXPORT, CMainFrame::OnUpdateFileExport)
	ON_COMMAND(ID_FILE_IMPORT, CMainFrame::OnFileImport)
	ON_UPDATE_COMMAND_UI(ID_FILE_IMPORT, CMainFrame::OnUpdateFileImport)
	ON_COMMAND(ID_EDIT_PERMISSIONS, CMainFrame::OnEditPermissions)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PERMISSIONS, CMainFrame::OnUpdateEditPermissions)

	// Global help commands
	ON_COMMAND(ID_HELP_FINDER, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_APP_SETTINGS, CMainFrame::OnAppSettings)
	ON_UPDATE_COMMAND_UI(ID_APP_SETTINGS, CMainFrame::OnUpdateAppSettings)
	ON_COMMAND(ID_NEW_QW_VALUE, CMainFrame::OnNewQword)
	ON_UPDATE_COMMAND_UI(ID_NEW_QW_VALUE, CMainFrame::OnUpdateNewQwordValue)
	ON_COMMAND(ID_NTREG_CONNECT, CMainFrame::OnNtregConnect)
	ON_UPDATE_COMMAND_UI(ID_NTREG_CONNECT, CMainFrame::OnUpdateNtregConnect)
	ON_COMMAND(ID_NTREG_REFRESH, CMainFrame::OnNtregRefresh)
	ON_UPDATE_COMMAND_UI(ID_NTREG_REFRESH, CMainFrame::OnUpdateNtregRefresh)
	ON_COMMAND(ID_NTREG_DISCONNECT, CMainFrame::OnNtregDisconnect)
	ON_UPDATE_COMMAND_UI(ID_NTREG_DISCONNECT, CMainFrame::OnUpdateNtregDisconnect)
#endif
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

// CMainFrame construction/destruction
CMainFrame::CMainFrame()
{
	m_bKeyPressed = FALSE;
	m_bValuePressed = FALSE;

	theApp.m_bSaveWindowPos = TRUE;

	m_csaRegTypeStr.Add(_T(" "));
	m_csaRegTypeStr.Add(_T("="));
	m_csaRegTypeStr.Add(_T("=hex(2):"));
	m_csaRegTypeStr.Add(_T("=hex:"));
	m_csaRegTypeStr.Add(_T("=dword:"));
	m_csaRegTypeStr.Add(_T("=dword:"));
	m_csaRegTypeStr.Add(_T("=hex(6):"));
	m_csaRegTypeStr.Add(_T("=hex(7):"));
	m_csaRegTypeStr.Add(_T("=hex(8):"));
	m_csaRegTypeStr.Add(_T("=hex(9):"));
	m_csaRegTypeStr.Add(_T("=hex(10):"));
	m_csaRegTypeStr.Add(_T("=hex(b):"));
	//
	// the rest is NtRegEdit format...
	m_csaRegTypeStr.Add(_T("="));
	m_csaRegTypeStr.Add(_T("=exp:"));
	m_csaRegTypeStr.Add(_T("=bin:"));
	m_csaRegTypeStr.Add(_T("=dw:"));
	m_csaRegTypeStr.Add(_T("=dwbe:"));
	m_csaRegTypeStr.Add(_T("=link:"));
	m_csaRegTypeStr.Add(_T("=multi:"));
	m_csaRegTypeStr.Add(_T("=reslist:"));
	m_csaRegTypeStr.Add(_T("=fullres:"));
	m_csaRegTypeStr.Add(_T("=reqlist:"));
	m_csaRegTypeStr.Add(_T("=qword:"));

	m_crText = RGB(255,255,255);
	m_crBG = RGB(240,240,240);
	m_crShadow = RGB(0,0,0);
	m_bBold = FALSE;
	m_bBoldHidden = FALSE;
	m_bColors = FALSE;

	m_crHKCRColors = RGB(0,0,0);
	m_crHKCUColors = RGB(0,0,0);
	m_crHKLMColors = RGB(0,0,0);
	m_crHKUColors = RGB(0,0,0);
	m_crHKCCColors = RGB(0,0,0);

	m_crSZ = RGB(0,0,0);
	m_crEXPAND_SZ = RGB(0,0,0);
	m_crBINARY = RGB(0,0,0);
	m_crDWORD = RGB(0,0,0);
	m_crDWORD_BIG_ENDIAN = RGB(0,0,0);
	m_crLINK = RGB(0,0,0);
	m_crMULTI_SZ = RGB(0,0,0);
	m_crRESOURCE_LIST = RGB(0,0,0);
	m_crFULL_RESOURCE_DESCRIPTOR = RGB(0,0,0);
	m_crRESOURCE_REQUIREMENTS_LIST = RGB(0,0,0);
	m_crQWORD = RGB(0,0,0);

	CNtRegistry reg;
	if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings"),TRUE,TRUE))
	{
		m_csAppDir = reg.ReadString(_T("Path"),_T("ERR"));
		m_csAppLogDir = reg.ReadString(_T("Logs"),_T("ERR"));
		m_csTempDir = reg.ReadString(_T("Temp"),_T("ERR"));
		bFoundDirs = TRUE;
		m_dwMaxLogFileSize = reg.ReadDword(_T("MaxLogFileSize"),0);

		m_crText = reg.ReadColor(_T("TextColor"),RGB(255,255,255));
		m_crBG = reg.ReadColor(_T("BGColor"),RGB(240,240,240));
		m_crShadow = reg.ReadColor(_T("ShadowColor"),RGB(0,0,0));

		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE))
		{
			reg.ReadSize(_T("VSize"),&m_sListView);
			m_bUseTreeColors = reg.ReadBool(_T("UseTreeColors"),FALSE);

			if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl\\ItemColors"),TRUE,TRUE))
			{
				m_crSZ = reg.ReadColor(_T("SZ"),RGB(0,0,0));
				m_crEXPAND_SZ = reg.ReadColor(_T("EXPAND_SZ"),RGB(0,0,0));
				m_crBINARY = reg.ReadColor(_T("BINARY"),RGB(0,0,0));
				m_crDWORD = reg.ReadColor(_T("DWORD"),RGB(0,0,0));
				m_crDWORD_BIG_ENDIAN = reg.ReadColor(_T("DWORD_BIG_ENDIAN"),RGB(0,0,0));
				m_crLINK = reg.ReadColor(_T("LINK"),RGB(0,0,0));
				m_crMULTI_SZ = reg.ReadColor(_T("MULTI_SZ"),RGB(0,0,0));
				m_crRESOURCE_LIST = reg.ReadColor(_T("RESOURCE_LIST"),RGB(0,0,0));
				m_crFULL_RESOURCE_DESCRIPTOR = reg.ReadColor(_T("FULL_RESOURCE_DESCRIPTOR"),RGB(0,0,0));
				m_crRESOURCE_REQUIREMENTS_LIST = reg.ReadColor(_T("RESOURCE_REQUIREMENTS_LIST"),RGB(0,0,0));
				m_crQWORD = reg.ReadColor(_T("QWORD"),RGB(0,0,0));
			}
		}

		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\TreeCtrl"),TRUE,TRUE))
		{
			reg.ReadSize(_T("VSize"),&m_sTreeView);
			m_bBold = reg.ReadBool(_T("UseBold"),FALSE);
			m_bBoldHidden = reg.ReadBool(_T("UseBoldHidden"),FALSE);
			m_bColors = reg.ReadBool(_T("UseColor"),FALSE);

			if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\TreeCtrl\\KeyColors"),TRUE,TRUE))
			{
				if (m_bColors)
				{
					m_crHKCRColors = reg.ReadColor(_T("HKCR"), RGB(0,0,0));
					m_crHKCUColors = reg.ReadColor(_T("HKCU"), RGB(0,0,0));
					m_crHKLMColors = reg.ReadColor(_T("HKLM"), RGB(0,0,0));
					m_crHKUColors = reg.ReadColor(_T("HKU"), RGB(0,0,0));
					m_crHKCCColors = reg.ReadColor(_T("HKCC"), RGB(0,0,0));
				}
			}
		}
	}

	if (!bFoundDirs)
	{
		char szCurDir[256];
		GetCurrentDirectory(256,szCurDir);
		m_csAppDir.Format(_T("%s"),szCurDir);
		m_csAppLogDir.Format(_T("%s\\Logs"),m_csAppDir);
		m_csNtRegEditFile.Format(_T("%s\\NtRegEdit.exe"),m_csAppDir);
		m_dwMaxLogFileSize = 250000;
	}
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	CStatusBarCtrl& sb = m_wndStatusBar.GetStatusBarCtrl();
	sb.SetIcon(0, (HICON)::LoadImage(AfxGetResourceHandle(), MAKEINTRESOURCE(IDR_MAINFRAME), IMAGE_ICON, 16, 16, 0));

	// TODO: Delete these three lines if you don't want the toolbar to be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	m_coolmenu.Install(this);
	static UINT toolbars[] = {IDR_MAINFRAME}; 
	m_coolmenu.LoadToolbars(toolbars, 1);

	// Make the status bar a bit bigger (to fit the controls)
	m_wndStatusBar.GetStatusBarCtrl().SetMinHeight(23);
	m_wndStatusBar.SetPaneWidth(0,0);

//	AddTextPane(IDS_PANE_TEXT_1,1,_T("Domain\\User"),150); 
//	AddTextPane(IDS_PANE_TEXT_2,1,_T("NtRegEdit"),500); 
	AddTextPane(IDS_PANE_TEXT_1,1,_T("Native Registry Editor - by Daniel Madden"),650); 

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) ) {
		return FALSE;
	}

	cs.style = WS_OVERLAPPED | WS_CAPTION	  | FWS_ADDTOTITLE
			 | WS_THICKFRAME | WS_MINIMIZEBOX | WS_MAXIMIZEBOX 
			 | WS_SYSMENU;

	cs.style &= ~(LONG) FWS_ADDTOTITLE;
	cs.lpszName = "Native Registry Editor - by Daniel Madden";

	return TRUE;
}

void CMainFrame::OnDestroy()
{
	CFrameWnd::OnDestroy();


	CNtRegistry reg;
	if (reg.SetKey(HKEY_CURRENT_USER,_T("SOFTWARE\\NtRegEdit\\Settings"),TRUE,TRUE))
	{
		reg.WriteBool(_T("AlwaysOnTop"),theApp.m_bWindowOnTop);
		reg.WriteBool(_T("SaveWindowPos"),theApp.m_bSaveWindowPos);
		reg.WriteBool(_T("CheckOSType"),theApp.m_bCheckOSType);
		reg.WriteBool(_T("CheckIsUserAdmin"),theApp.m_bCheckIsUserAdmin);

		//reg.WriteColor(_T("TextColor"),m_crText);
		//reg.WriteColor(_T("BGColor"),m_crBG);
		//reg.WriteColor(_T("ShadowColor"),m_crShadow);

		reg.WriteString("Path",m_csAppDir);
		reg.WriteString("Logs",m_csAppLogDir);
		reg.WriteDword("MaxLogFileSize",m_dwMaxLogFileSize);

		if (theApp.m_bSaveWindowPos)
		{
			if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\WindowPlacement"),TRUE,TRUE))
			{
				WINDOWPLACEMENT wp;
				wp.length = sizeof wp;

				CWnd* pWnd= AfxGetMainWnd();
				if(pWnd->GetWindowPlacement(&wp))
				{
					wp.flags = 0;
					if (pWnd->IsZoomed())
						wp.flags |= WPF_RESTORETOMAXIMIZED;

					reg.WriteDword(_T("wp.bottom"),wp.rcNormalPosition.bottom);
					reg.WriteDword(_T("wp.flags"),wp.flags);
					reg.WriteDword(_T("wp.left"),wp.rcNormalPosition.left);
					reg.WriteDword(_T("wp.right"),wp.rcNormalPosition.right);
					reg.WriteDword(_T("wp.showCmd"),wp.showCmd);
					reg.WriteDword(_T("wp.top"),wp.rcNormalPosition.top);
					reg.WriteDword(_T("wp.ptMaxPosition.x"),wp.ptMaxPosition.x);
					reg.WriteDword(_T("wp.ptMaxPosition.y"),wp.ptMaxPosition.y);
					reg.WriteDword(_T("wp.ptMinPosition.x"),wp.ptMinPosition.x);
					reg.WriteDword(_T("wp.ptMinPosition.y"),wp.ptMinPosition.y);
				}
			}
		}

		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ValueViews"),TRUE,TRUE))
		{
			TVisualObject *pObject = (TVisualObject*)theApp.m_dwaTVisualObject.GetAt(2);
			CWnd* cwSafe = pObject->GetSafeWnd();
			CRect rect;
			cwSafe->GetWindowRect(rect);
			m_sValueViews = rect.Size();
			reg.WriteSize(_T("VSize"),&m_sValueViews);
		}

		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE))
		{
			TVisualObject *pObject = (TVisualObject*)theApp.m_dwaTVisualObject.GetAt(1);
			CWnd* cwSafe = pObject->GetSafeWnd();
			CRect rect;
			cwSafe->GetWindowRect(rect);
			m_sListView = rect.Size();
			reg.WriteSize(_T("VSize"),&m_sListView);
		}

		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\TreeCtrl"),TRUE,TRUE))
		{
			TVisualObject *pObject = (TVisualObject*)theApp.m_dwaTVisualObject.GetAt(0);
			CWnd* cwSafe = pObject->GetSafeWnd();
			CRect rect;
			cwSafe->GetWindowRect(rect);
			m_sTreeView = rect.Size();
			reg.WriteSize(_T("VSize"),&m_sTreeView);
		}
	}
	else
	{
		MessageBox(_T("Unable to save Settings!"),_T("Error Reading Registry"),MB_OK|MB_ICONERROR);
	}

	m_Framework.Destroy();
	theApp.m_dwaTVisualObject.RemoveAll();
}


// CMainFrame diagnostics
#ifdef _DEBUG
void CMainFrame::AssertValid() const { CFrameWnd::AssertValid(); }
void CMainFrame::Dump(CDumpContext& dc) const { CFrameWnd::Dump(dc); }
#endif //_DEBUG


// CMainFrame message handlers
BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	TVisualObject *pSplitter = new TVisualObject(1,"Viewer", 1, 2, pContext);
	m_pTreeView = new TVisualObject(2,0,0,pContext, RUNTIME_CLASS(CNtRegEditTreeView), m_sTreeView);
	TVisualObject *pView2 = new TVisualObject(3,0,1,2,1,pContext);
	m_pNestedListView = new TVisualObject(4,0,0,pContext,RUNTIME_CLASS(CNtRegEditView),m_sListView);
	TVisualObject *pNestedView2 = new TVisualObject(5,1,0,pContext,RUNTIME_CLASS(TTabWnd),m_sValueViews,TVisualObject::TOS_TABTOP);
	m_pNestedStringView = new TVisualObject(6,"String View", pContext, RUNTIME_CLASS(CStringView));
	m_pNestedBinaryView = new TVisualObject(7,"Binary View", pContext, RUNTIME_CLASS(CBinaryView));
	m_pNestedDWordView = new TVisualObject(8,"DWord View", pContext, RUNTIME_CLASS(CDWordView));
	m_pNestedMStringView = new TVisualObject(9,"Multi-String View", pContext, RUNTIME_CLASS(CMStringView));
	m_pNestedFSView = new TVisualObject(10,"Find/Search Results", pContext, RUNTIME_CLASS(CFindSearchView));

	m_Framework.Add(pSplitter);
	m_Framework.Add(pSplitter, m_pTreeView);
	m_Framework.Add(pSplitter, pView2);
	m_Framework.Add(pView2, m_pNestedListView);
	m_Framework.Add(pView2, pNestedView2);
	m_Framework.Add(pNestedView2, m_pNestedBinaryView);
	m_Framework.Add(pNestedView2, m_pNestedDWordView);
	m_Framework.Add(pNestedView2, m_pNestedMStringView);
	m_Framework.Add(pNestedView2, m_pNestedStringView);
	m_Framework.Add(pNestedView2, m_pNestedFSView);

	m_Framework.Create(this);

	TVisualFrameworkIterator it(m_Framework);
	while (!it.End()) {
		//
		TVisualObject *pObject = it.Get();
		it++;
	}

	// Below is to get the size of the windows
	// so that when the app starts it can set
	// the size of the controls (where the user left it).
	theApp.m_dwaTVisualObject.Add((DWORD)m_pTreeView);
	theApp.m_dwaTVisualObject.Add((DWORD)m_pNestedListView);
	theApp.m_dwaTVisualObject.Add((DWORD)pNestedView2);
	theApp.m_dwaTVisualObject.Add((DWORD)m_pNestedBinaryView);
	theApp.m_dwaTVisualObject.Add((DWORD)m_pNestedDWordView);
	theApp.m_dwaTVisualObject.Add((DWORD)m_pNestedMStringView);
	theApp.m_dwaTVisualObject.Add((DWORD)m_pNestedStringView);
	theApp.m_dwaTVisualObject.Add((DWORD)m_pNestedFSView);

	theApp.m_clsFramework = &m_Framework;

	theApp.m_clsMainFrm = (CMainFrame*)this;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
void CMainFrame::AddTextPane(UINT unID, int nPosition, CString csString, int nLength) 
{
	BOOL bRet = m_wndStatusBar.AddPane(unID,nPosition);
	if(!bRet){
		AfxMessageBox(_T("Pane index out of range\nor pane with same ID already exists in the status bar"), MB_ICONERROR);
		return;
	}

	int nIndex = m_wndStatusBar.CommandToIndex(unID);
	if (nIndex == -1)
		return;

	m_wndStatusBar.SetPaneWidth(nIndex, nLength);
	m_wndStatusBar.SetPaneText(nPosition,csString);
	m_wndStatusBar.SetPaneStyle(nPosition,SBPS_NOBORDERS);
}

//////////////////////////////////////////////////////////////////////////
void CMainFrame::RemovePane(int nPosition) 
{
	if( nPosition < 0 || nPosition > 20 )
		return;

	if(!m_wndStatusBar.RemovePane(
		m_wndStatusBar.GetItemID(nPosition))
		)
	{
		CString s;
		s.Format(_T("Pane %d was not found in the status bar \nor must be at least one of them."), nPosition);
		AfxMessageBox(s, MB_ICONERROR);
	}
}

//////////////////////////////////////////////////////////////////////////
void CMainFrame::DisablePane(int nPosition) 
{
	if( nPosition < 0 || nPosition > 20 )
		return;
	
	UINT nID, nStyle;
	int cxWidth;
	
	m_wndStatusBar.GetPaneInfo(nPosition, nID, nStyle, cxWidth);
	
	BOOL bDisabled = ((nStyle&SBPS_DISABLED) == 0);

	m_wndStatusBar.SetPaneStyle(nPosition,
								//nID,
								bDisabled 
									? nStyle | SBPS_DISABLED 
									: nStyle & ~SBPS_DISABLED
								//`cxWidth
								);
}

//////////////////////////////////////////////////////////////////////////



void CMainFrame::EnableBinaryView(BOOL bEnable)
{
//	theApp.m_clsFramework->EnableTab(m_pNestedBinaryView, bEnable);
	theApp.m_clsLV->m_xList.SetFocus();
}

void CMainFrame::EnableDWordView(BOOL bEnable)
{
//	theApp.m_clsFramework->EnableTab(m_pNestedDWordView, bEnable);
	theApp.m_clsLV->m_xList.SetFocus();
}

void CMainFrame::EnableMStringView(BOOL bEnable)
{
//	theApp.m_clsFramework->EnableTab(m_pNestedMStringView, bEnable);
	theApp.m_clsLV->m_xList.SetFocus();
}

void CMainFrame::EnableStringView(BOOL bEnable)
{
//	theApp.m_clsFramework->EnableTab(m_pNestedStringView, bEnable);
	theApp.m_clsLV->m_xList.SetFocus();
}

void CMainFrame::EnableFSView(BOOL bEnable)
{
//	theApp.m_clsFramework->EnableTab(m_pNestedFSView, bEnable);
	theApp.m_clsLV->m_xList.SetFocus();
}

void CMainFrame::OnCopyKeyValue()
{
	if (m_bKeyPressed) {
		//
		CCcrsDlg dlgCopy(1);
		if (dlgCopy.DoModal() == IDOK) {
			//
			CString csTest = _T("TEST");
			// Get the length of the key we are copying FROM
			int nLength = dlgCopy.m_csFromFullRegKeyPath.GetLength();
			if (nLength <= dlgCopy.m_csToFullRegKeyPath.GetLength()) {
				csTest = dlgCopy.m_csToFullRegKeyPath.Left(nLength);
			}

			// Get the length of the key we are copying FROM
			if (dlgCopy.m_csToFullRegKeyPath.IsEmpty()) {
				MessageBox(_T("You MUST have a Key to copy to!"),_T("Error: No Key"),MB_OK|MB_ICONERROR);
				return;
			}
			else if (dlgCopy.m_csFromFullRegKeyPath == csTest) {
				MessageBox(_T("You are NOT allowed to copy below the same key!"),_T("Information: Below Same Key"),MB_OK|MB_ICONINFORMATION);
				return;
			}
			else if (dlgCopy.m_csFromFullRegKeyPath.CompareNoCase(dlgCopy.m_csToFullRegKeyPath) == 0) {
				MessageBox(_T("You are NOT allowed to copy to the same key!"),_T("Information: Same Key"),MB_OK|MB_ICONINFORMATION);
				return;
			}

			BOOL bRecursively = FALSE;
			if (MessageBox(_T("Would like to copy ALL subkeys too??"),_T("Question: Recursive Copy"),MB_YESNO|MB_ICONQUESTION) == IDYES) {
				bRecursively = TRUE;
			}

			if (theApp.m_clsTV->m_ntReg.CopyKeys(dlgCopy.m_csFromFullRegKeyPath, dlgCopy.m_csToFullRegKeyPath, bRecursively)) {
				CMainFrame::OnKeysRefresh();
				//MessageBox("Keys have been Copied!!");
			}
			else {
				MessageBox("CopyKeys() Failed!!");
			}
		}
	}
	else if (m_bValuePressed) {
		CCcrsDlg dlgCopy(2);
		if (dlgCopy.DoModal() == IDOK) {
			//
			if (dlgCopy.m_csFromFullRegKeyPath.CompareNoCase(dlgCopy.m_csToFullRegKeyPath) == 0 && 
				dlgCopy.m_csFromValueName.CompareNoCase(dlgCopy.m_csToValueName) == 0) {
				MessageBox(_T("You are NOT allowed to copy to the same value!"),_T("Information: Same Value"),MB_OK|MB_ICONINFORMATION);
				return;
			}

			if (!theApp.m_clsTV->m_ntReg.CopyValues(dlgCopy.m_csFromFullRegKeyPath, 
												   dlgCopy.m_csToFullRegKeyPath, 
												   dlgCopy.m_csFromValueName, 
												   dlgCopy.m_csToValueName)) {
			//	MessageBox("Value has been Copied!!");
			//}
			//else {
				MessageBox("CopyValues() Failed!!");
			}
		}
	}
}

void CMainFrame::OnUpdateCopyKeyValue(CCmdUI *pCmdUI)
{
	CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot || 
		tc.GetParentItem(theApp.m_clsTV->m_hItem) == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnCreateKey()
{
	//
	CCcrsDlg dlgCreate(3);
	if (dlgCreate.DoModal() == IDOK) {
		//
		if (theApp.m_clsTV->m_ntReg.CreateKey(dlgCreate.m_csToFullRegKeyPath)) {
			CMainFrame::OnKeysRefresh();
			MessageBox("Key has been Created!!");
		}
		else {
			MessageBox("CreateKey() Failed!!");
		}
	}
}

void CMainFrame::OnUpdateCreateKey(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) { 
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnCreateHiddenKey()
{
	//
	CCcrsDlg dlgCreate(9);
	if (dlgCreate.DoModal() == IDOK) {
		//
		if (theApp.m_clsTV->m_ntReg.CreateHiddenKey(dlgCreate.m_csToFullRegKeyPath)) {
			CMainFrame::OnKeysRefresh();
			MessageBox("Hidden Key has been Created!!");
		}
		else {
			MessageBox("CreateHiddenKey() Failed!!");
		}
	}
}

void CMainFrame::OnUpdateCreateHiddenKey(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) { 
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnSearch()
{
	CCcrsDlg dlgSearch(5);
	if (dlgSearch.DoModal() == IDOK) {
		//
		CWaitCursor wc;
		CStringArray csaSearch;
		if (theApp.m_clsTV->m_ntReg.Search( dlgSearch.m_csToValueName, 
											dlgSearch.m_csFromFullRegKeyPath, 
											csaSearch,
											dlgSearch.m_nSearchParams,
											dlgSearch.m_bCaseSensitive)) {
			theApp.m_clsMainFrm->EnableFSView(TRUE);
			theApp.m_clsFramework->SetActivePane(theApp.m_clsMainFrm->m_pNestedFSView);
			theApp.m_clsMainFrm->EnableDWordView(FALSE);
			theApp.m_clsMainFrm->EnableMStringView(FALSE);
			theApp.m_clsMainFrm->EnableStringView(FALSE);
			theApp.m_clsMainFrm->EnableBinaryView(FALSE);

			CTokenEx tok;
			for (int n=0; n<csaSearch.GetSize(); n++) {
				CString csTmp = csaSearch.GetAt(n);
				csTmp.TrimRight(_T("]"));
				int nLBrace = csTmp.Find("[");
				if (nLBrace == -1) {
					// It is just a Key
					theApp.m_clsFS->m_lcFindSearch.InsertItem(theApp.m_clsFS->m_lcFindSearch.GetItemCount(),csTmp);
				}
				else {
					int nItem = 0;
					CString csKey = csTmp.Left(nLBrace);
					CString csVName = _T("");
					nItem = theApp.m_clsFS->m_lcFindSearch.InsertItem(theApp.m_clsFS->m_lcFindSearch.GetItemCount(),csKey);
					int nLCRBrace = csTmp.Find("]:[");
					if (nLCRBrace == -1) {
						csVName = csTmp.Mid(nLBrace+1);
						theApp.m_clsFS->m_lcFindSearch.SetItemText(nItem,1,csVName);
					}
					else {
						csVName = csTmp.Mid(nLBrace+1,nLCRBrace-nLBrace-1);
						theApp.m_clsFS->m_lcFindSearch.SetItemText(nItem,1,csVName);
						CString csValue = _T("");
						csValue = csTmp.Mid(nLCRBrace+3);
						theApp.m_clsFS->m_lcFindSearch.SetItemText(nItem,2,csValue);
					}
				}
			}
		}
		else {
			MessageBox("Search() Failed!!");
		}
	}
}

void CMainFrame::OnUpdateSearch(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) { 
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnDeleteKeyValue()
{
	if (m_bKeyPressed) {
		//
		if (MessageBox(_T("Are you sure you want to delete this Key??"),_T("Delete Key"),MB_YESNO|MB_ICONQUESTION) == IDYES) {
			CWaitCursor wc;
			CString csKey = theApp.m_clsTV->m_ntReg.GetCurrentPath();
			BOOL bOk = theApp.m_clsTV->m_ntReg.DeleteKey(csKey);
			if (bOk) {
				CTreeCtrl &tc = theApp.m_clsTV->GetTreeCtrl();
				tc.DeleteItem(tc.GetSelectedItem());
				theApp.m_clsTV->CurrentSubKeyRefresh();
			}
		}
	}
	else if (m_bValuePressed) {
		//
		if (MessageBox(_T("Are you sure you want to delete this Value??"),_T("Delete Value"),MB_YESNO|MB_ICONQUESTION) == IDYES) {
			CWaitCursor wc;
			CString csValue = theApp.m_clsLV->m_xList.GetItemText(theApp.m_clsLV->m_xList.GetCurSel(),0);
			if (theApp.m_clsTV->m_ntReg.DeleteValue(csValue)) {
				theApp.m_clsTV->ShowValues();
			}
		}
	}
}

void CMainFrame::OnUpdateDeleteKeyValue(CCmdUI *pCmdUI)
{
	CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();

	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot || 
		tc.GetParentItem(theApp.m_clsTV->m_hItem) == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		if (theApp.m_clsTV->m_ntReg.GetSubKeyCount() == 0 && m_bKeyPressed) {
			pCmdUI->Enable(TRUE);
		}
		else if (theApp.m_clsTV->m_ntReg.GetSubKeyCount() > 0 && m_bKeyPressed) {
			pCmdUI->Enable(FALSE);
		}
		else {
			pCmdUI->Enable(TRUE);
		}
	}
}

void CMainFrame::OnRecursivelyKey()
{
	//
	if (MessageBox(_T("Are you sure you want to delete this Key and ALL Subkeys??"),_T("Recursively Delete Keys"),MB_YESNO|MB_ICONQUESTION) == IDYES) {
		//
		CWaitCursor wc;
		CString csKey = theApp.m_clsTV->m_ntReg.GetCurrentPath();
		BOOL bOk = theApp.m_clsTV->m_ntReg.DeleteKeysRecursive(csKey);
		if (bOk) {
			CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();
			tc.DeleteItem(tc.GetSelectedItem());
			theApp.m_clsTV->CurrentSubKeyRefresh();
		}
	}
}

void CMainFrame::OnUpdateRecursivelyKey(CCmdUI *pCmdUI)
{
	CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot || 
		tc.GetParentItem(theApp.m_clsTV->m_hItem) == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		if (theApp.m_clsTV->m_ntReg.GetSubKeyCount() > 0 && m_bKeyPressed) {
			pCmdUI->Enable(TRUE);
		}
		else if (theApp.m_clsTV->m_ntReg.GetSubKeyCount() == 0 && m_bKeyPressed) {
			pCmdUI->Enable(FALSE);
		}
		else {
			pCmdUI->Enable(m_bKeyPressed);
		}
	}
}

void CMainFrame::OnKeysFindhiddenkeys()
{
	CCcrsDlg dlgFind(8);
	if (dlgFind.DoModal() == IDOK) {
		//
		CStringArray csaFind;
		CString csKey = theApp.m_clsTV->m_ntReg.GetCurrentPath();
		if (csKey != _T("ERR")) {
			//
			CWaitCursor wc;
			if (theApp.m_clsTV->m_ntReg.FindHiddenKeys(csKey,TRUE,csaFind)) {
				//
				EnableFSView(TRUE);
				theApp.m_clsFramework->SetActivePane(m_pNestedFSView);
				EnableDWordView(FALSE);
				EnableMStringView(FALSE);
				EnableStringView(FALSE);
				EnableBinaryView(FALSE);

				for (int n=0; n<csaFind.GetSize(); n++) {
					CString csKey = csaFind.GetAt(n);
					theApp.m_clsFS->m_lcFindSearch.InsertItem(theApp.m_clsFS->m_lcFindSearch.GetItemCount(),csKey);
				}
			}
			else {
				MessageBox("FindHiddenKeys() Failed!!");
			}
		}
	}
}

void CMainFrame::OnUpdateKeysFindhiddenkeys(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnRenameKeyValue()
{
	CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();
	if (m_bKeyPressed) {
		//
		CCcrsDlg dlgRename(6);
		if (dlgRename.DoModal() == IDOK) {
			//
			CString csReplacementKey = _T("");
			CString csNewKey = _T("");
			int nSize = dlgRename.m_csToFullRegKeyPath.GetLength();
			int nSlash = dlgRename.m_csToFullRegKeyPath.ReverseFind('\\');
			if (nSlash != -1) {
				csReplacementKey = dlgRename.m_csToFullRegKeyPath.Right(nSize-(nSlash+1));
				csNewKey = dlgRename.m_csToFullRegKeyPath.Left(nSlash);
			}
			else {
				csReplacementKey = dlgRename.m_csToFullRegKeyPath;
				csNewKey = csReplacementKey;
			}
			//
			if (!theApp.m_clsTV->m_ntReg.RenameKey(dlgRename.m_csFromFullRegKeyPath,csReplacementKey)) {
				MessageBox("RenameKey() Failed!!");
				return;
			}
			
			HTREEITEM hRenamed = tc.GetSelectedItem();
			if (hRenamed) {
				tc.SelectItem(tc.GetParentItem(hRenamed));
				theApp.m_clsTV->m_ntReg.SetKey(csNewKey,FALSE,TRUE);
				CMainFrame::OnKeysRefresh();
				theApp.m_clsTV->ShowValues();
			}
		}
	}
	else if (m_bValuePressed) {
		//
		CCcrsDlg dlgRename(7);
		if (dlgRename.DoModal() == IDOK) {
			//
			if (!theApp.m_clsTV->m_ntReg.RenameValue(dlgRename.m_csFromValueName,dlgRename.m_csToValueName)) {
				MessageBox("RenameValue() Failed!!");
				return;
			}
			theApp.m_clsTV->ShowValues();
		}
	}
}

void CMainFrame::OnUpdateRenameKeyValue(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();
		if (tc.GetParentItem(theApp.m_clsTV->m_hItem) == theApp.m_clsTV->m_hRoot &&
			m_bKeyPressed) {
			pCmdUI->Enable(FALSE);
		}
		else {
			pCmdUI->Enable(TRUE);
		}
	}
}

BOOL CMainFrame::SearchForTreeNode(HTREEITEM hItem, CString csNode)
{
	CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();
	HTREEITEM hNextItem;
	HTREEITEM hChildItem = tc.GetChildItem(hItem);
	CString csChild = tc.GetItemText(hChildItem);
	if (csChild.CompareNoCase(csNode) == 0) {
		return TRUE;
	}
	else {
		//
		HTREEITEM hSibling = tc.GetNextSiblingItem(hChildItem);
		while (hSibling != NULL)
		{
			CString csSibling = tc.GetItemText(hSibling);
			if (csSibling.CompareNoCase(csNode) == 0) {
				return TRUE;
			}
			hNextItem = tc.GetNextItem(hSibling, TVGN_NEXT);
			hSibling = hNextItem;
		}
	}
	return FALSE;
}

void CMainFrame::OnKeysRefresh()
{
	CTreeCtrl& tc = theApp.m_clsTV->GetTreeCtrl();
	HTREEITEM hSelItem = tc.GetSelectedItem();

	CString csNode = tc.GetItemText(hSelItem);

	HTREEITEM hRoot = tc.GetRootItem();
	HTREEITEM hParent = tc.GetParentItem(hSelItem);

	//
	if (hParent == NULL) {
		return;
	}

	COLORREF crTextColor;
	if (hParent == hRoot) {
		crTextColor = theApp.m_clsTV->GetItemColor(hSelItem);
	}
	else {
		crTextColor = theApp.m_clsTV->GetItemColor(hParent);
	}

	HTREEITEM hItem = hParent;

	//
	CString csFullKey = theApp.m_clsTV->GetTreePath(hItem);

	//
	theApp.m_clsTV->SetRedraw(FALSE);

	//
	if (tc.ItemHasChildren(hItem)) {
		//
		if (theApp.m_clsTV->m_ntReg.SetKey(csFullKey,FALSE,TRUE)) {
			//
			CStringArray csaKeys;
			HTREEITEM hLastItem = NULL;
			BOOL bOk = FALSE;
			theApp.m_clsTV->m_ntReg.GetSubKeyList(csaKeys);
			for (int n=0; n<csaKeys.GetSize(); n++) {
				//
				csNode = csaKeys.GetAt(n);
				if (!SearchForTreeNode(hItem,csNode)) {
					//
					CString csKey(csFullKey);
					csKey += _T("\\");
					csKey += csaKeys.GetAt(n);

					bOk = theApp.m_clsTV->m_ntReg.SetKey(csKey,FALSE,TRUE);

					int nIcon = 5;
					if (theApp.m_clsTV->m_ntReg.m_bHidden) { nIcon = 0; }

					HTREEITEM hNewItem = tc.InsertItem(csaKeys.GetAt(n),nIcon,nIcon,hItem);
					theApp.m_clsTV->SetItemColor(hNewItem,crTextColor);
					if (bOk && theApp.m_clsTV->m_ntReg.GetSubKeyCount() > 0) {
						tc.InsertItem(FAKEDITEM,5,5,hNewItem,TVI_LAST);
					}
					tc.SortChildren(hNewItem);
				}
			}
			tc.SortChildren(hItem);
		}
		tc.SortChildren(hItem);
		tc.Expand(hItem, TVE_EXPAND);
		tc.SelectItem(hItem);
	}
//	theApp.m_clsTV->CurrentSubKeyRefresh();
	tc.SetRedraw(TRUE);

}

void CMainFrame::OnUpdateKeysRefresh(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(TRUE);
	}
}

void CMainFrame::OnNewBinary()
{
	theApp.m_clsFramework->SetActivePane(theApp.m_clsMainFrm->m_pNestedBinaryView);
}

void CMainFrame::OnUpdateNewBinary(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(m_bValuePressed);
	}
}

void CMainFrame::OnNewDword()
{
	//
	theApp.m_clsFramework->SetActivePane(theApp.m_clsMainFrm->m_pNestedDWordView);
}

void CMainFrame::OnUpdateNewDword(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(m_bValuePressed);
	}
}

void CMainFrame::OnNewSzValue()
{
	theApp.m_clsFramework->SetActivePane(theApp.m_clsMainFrm->m_pNestedStringView);
}

void CMainFrame::OnUpdateNewSzValue(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(m_bValuePressed);
	}
}

void CMainFrame::OnNewSzeValue()
{
	//
	theApp.m_clsFramework->SetActivePane(theApp.m_clsMainFrm->m_pNestedStringView);
}

void CMainFrame::OnUpdateNewSzeValue(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(m_bValuePressed);
	}
}

void CMainFrame::OnNewSzmValue()
{
	//
	theApp.m_clsFramework->SetActivePane(theApp.m_clsMainFrm->m_pNestedMStringView);
}

void CMainFrame::OnUpdateNewSzmValue(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(m_bValuePressed);
	}
}

void CMainFrame::SaveKeysValuesToFile(FILE* fRegFile)
{

	BOOL bRecursiveExport = FALSE;
	if (theApp.m_clsTV->m_ntReg.GetSubKeyCount() > 0) {
		if (MessageBox("Would you like to recursively Export ALL Subkeys/Values?","Full Recursive Export",MB_YESNO|MB_ICONQUESTION) == IDYES) {
			bRecursiveExport = TRUE;
		}
	}

	CString csCurPath = theApp.m_clsTV->m_ntReg.GetCurrentPath();

	CString csSID = _T("");
	theApp.m_clsTV->m_ntReg.LookupSID(csSID);

	CString csRootPath = _T("");
	csRootPath.Format(_T("\\Registry\\User\\%s"), csSID);

	HKEY hKey=NULL;
	CString csRootKey = _T("");
	if (csCurPath.Left(csRootPath.GetLength()) == csRootPath) {
		if (m_bNtRegFile) {
			csRootKey = _T("HKCU\\");
		}
		else {
			csRootKey = _T("HKEY_CURRENT_USER\\");
		}
		hKey = HKEY_CURRENT_USER;
	}
	else if (csCurPath.Left(14) == _T("\\Registry\\User")) {
		if (m_bNtRegFile) {
			csRootKey = _T("HKU\\");
		}
		else {
			csRootKey = _T("HKEY_USERS\\");
		}
		csRootPath = _T("\\Registry\\User");
		hKey = HKEY_USERS;
	}
	else if (csCurPath.Left(68) == _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current")) {
		if (m_bNtRegFile) {
			csRootKey = _T("HKCC\\");
		}
		else {
			csRootKey = _T("HKEY_CURRENT_CONFIG\\");
		}
		csRootPath = _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current");
		hKey = HKEY_CURRENT_CONFIG;
	}
	else if (csCurPath.Left(34) == _T("\\Registry\\Machine\\SOFTWARE\\Classes")) {
		if (m_bNtRegFile) {
			csRootKey = _T("HKCR\\");
		}
		else {
			csRootKey = _T("HKEY_CLASSES_ROOT\\");
		}
		csRootPath = _T("\\Registry\\Machine\\SOFTWARE\\Classes");
		hKey = HKEY_CLASSES_ROOT;
	}
	else if (csCurPath.Left(17) == _T("\\Registry\\Machine")) {
		if (m_bNtRegFile) {
			csRootKey = _T("HKLM\\");
		}
		else {
			csRootKey = _T("HKEY_LOCAL_MACHINE\\");
		}
		csRootPath = _T("\\Registry\\Machine");
		hKey = HKEY_LOCAL_MACHINE;
	}

	CString csPath = _T("");
	if (csCurPath.GetLength() > csRootPath.GetLength()) {
		csPath = csCurPath.Mid(csRootPath.GetLength()+1);
	}
	else {
		csPath = csCurPath;
	}

	csRootPath += _T("\\");
	csRootPath += csPath;

	csRootKey += csPath;

	if (theApp.m_clsTV->m_ntReg.IsKeyHidden(csRootPath) && m_bNtRegFile) {
		csRootKey += _T("*");
	}

	CString csRoot = _T("\r\n[");
	csRoot += csRootKey;
	csRoot += _T("]\r\n");

	// [HKEY_CURRENT_USER\AppTest]
	fwrite(csRoot,sizeof(char),csRoot.GetLength(),fRegFile);

	SaveKeysValuesToFileRecursive(hKey,csRootPath,csRootKey,fRegFile,bRecursiveExport);
}

void CMainFrame::SaveKeysValuesToFileRecursive(HKEY hKey, CString csRootPath, 
											   CString csRootKey, FILE* fRegFile,
											   BOOL bRecursiveExport)
{
	CNtRegistry ntReg;
	ntReg.InitNtRegistry();

	if (ntReg.SetKey(hKey,csRootPath,FALSE,TRUE)) {
		//
		DWORD dwRegType = 0;
		DWORD dwValue = 0;
		UINT uiLength = 0;
		UCHAR* pucValue = NULL;
		CString csTmpValue = _T("");
		CString csValue = _T("");
		CString csHex = _T("");
		CString csValueName = _T("");
		CStringArray csaMString;
		CStringArray csaValues;

		//
		csaValues.RemoveAll();
		if (ntReg.GetValueList(csaValues)) {
			//
			//
			for (int i=0; i<csaValues.GetSize(); i++) {
				//
				BOOL bMultiLines = FALSE;
				int nLength = 0;

				//
				csValueName = csaValues.GetAt(i);
				int nSize = 0;
				dwRegType = ntReg.GetValueInfo(csValueName, nSize);
				
				CString csValueFmt = _T("");
				if (csValueName == _T("")) {
					if (m_bNtRegFile) {
						csValueFmt.Format(_T("%s"),m_csaRegTypeStr.GetAt(dwRegType+11));
					}
					else {
						csValueFmt.Format(_T("@%s"),m_csaRegTypeStr.GetAt(dwRegType));
					}
				}
				else {
					if (m_bNtRegFile) {
						csValueFmt.Format(_T("\"%s\"%s"),csValueName,m_csaRegTypeStr.GetAt(dwRegType+11));
					}
					else {
						csValueFmt.Format(_T("\"%s\"%s"),csValueName,m_csaRegTypeStr.GetAt(dwRegType));
					}
				}
				
				int a=0, b=0;
				switch(dwRegType) {
					//
					case REG_NONE:
						break;

					case REG_SZ:
						if (m_bNtRegFile) {
							csValueFmt += _T("str:");
							csValueFmt += ntReg.ReadString(csRootPath,csValueName,_T("ERR"));
							csValueFmt += _T("\r\n");
						}
						else {
							csValueFmt += _T("\"");
							csValueFmt += ntReg.ReadString(csRootPath,csValueName,_T("ERR"));
							csValueFmt += _T("\"\r\n");
						}
						break;

					case REG_EXPAND_SZ:
						csTmpValue = csValueFmt;
						csValueFmt = _T("");
						csValue = ntReg.ReadString(csRootPath,csValueName,_T("ERR"));
						nLength = csValue.GetLength();
						for (b=0; b<nLength; b++) {
							csHex.Format(_T("%x,"),csValue[b]);
							csTmpValue += csHex;
							if (csTmpValue.GetLength() >= 75) {
								csTmpValue += _T("\\\r\n  ");
								csValueFmt += csTmpValue;
								csTmpValue = _T("");
							}
							csTmpValue += _T("00,");
						}
						csTmpValue.TrimRight(",");
						csValueFmt += csTmpValue;
						csValueFmt += _T("\r\n");
						break;

					case REG_MULTI_SZ:
						csTmpValue = csValueFmt;
						csValueFmt = _T("");
						ntReg.ReadMultiString(csRootPath,csValueName,csaMString);
						for (a=0; a<csaMString.GetSize(); a++) {
							csValue = csaMString.GetAt(a);
							for (int b=0; b<csValue.GetLength(); b++) {
								csHex.Format(_T("%x,"),csValue[b]);
								csTmpValue += csHex;
								if (csTmpValue.GetLength() >= 75) {
									csTmpValue += _T("\\\r\n  ");
									csValueFmt += csTmpValue;
									csTmpValue = _T("");
								}
								csTmpValue += _T("00,");
							}
							csTmpValue += _T("00,00,");
						}
						csTmpValue.TrimRight(",");
						csValueFmt += csTmpValue;
						csValueFmt += _T("\r\n");
						csaMString.RemoveAll();
						break;

					case REG_DWORD:
					case REG_DWORD_BIG_ENDIAN:
						dwValue = ntReg.ReadDword(csRootPath,csValueName,0);
						csValue.Format(_T("%08x\r\n"),dwValue);
						csValueFmt += csValue;
						break;

					case REG_LINK:
					case REG_RESOURCE_LIST:
					case REG_FULL_RESOURCE_DESCRIPTOR:
					case REG_RESOURCE_REQUIREMENTS_LIST:
					case REG_QWORD:
					case REG_BINARY:
						csTmpValue = csValueFmt;
						csValueFmt = _T("");
						pucValue = ntReg.ReadBinary(csRootPath,csValueName,uiLength);
						for (b=0; b<(int)uiLength; b++) {
							csHex.Format(_T("%02x,"),pucValue[b]);
							csTmpValue += csHex;
							if (csTmpValue.GetLength() >= 75) {
								csTmpValue += _T("\\\r\n  ");
								csValueFmt += csTmpValue;
								csTmpValue = _T("");
								bMultiLines = TRUE;
							}
						}
						csTmpValue.TrimRight(",");
						csValueFmt += csTmpValue;
						csValueFmt += _T("\r\n");
						break;
				}

				//
				fwrite(csValueFmt,sizeof(char),csValueFmt.GetLength(),fRegFile);
			}
		}

		if (bRecursiveExport) {
			CStringArray csaSubKeys;
			if (ntReg.GetSubKeyList(csaSubKeys)) {
				//
				CString csTmpRootPath = csRootPath;
				CString csTmpRootKey = csRootKey;
				for (int n=0; n<csaSubKeys.GetSize(); n++) {
					//
					CString csSubKeyName = csaSubKeys.GetAt(n);

					csRootPath = csTmpRootPath;
					csRootKey = csTmpRootKey;

					// \Registry\User\<SID>\AppTest\...
					csRootPath += _T("\\");
					csRootPath += csSubKeyName;
					
					// HKEY_CURRENT_USER\AppTest\...
					csRootKey += _T("\\");
					csRootKey += csSubKeyName;

					//
					// [HKEY_CURRENT_USER\AppTest\...]
					CString csRoot = _T("\r\n[");
					csRoot += csRootKey;
					if (theApp.m_clsTV->m_ntReg.IsKeyHidden(csRootPath) && m_bNtRegFile) {
						csRoot += _T("*");
					}
					csRoot += _T("]\r\n");

					// [HKEY_CURRENT_USER\AppTest]
					fwrite(csRoot,sizeof(char),csRoot.GetLength(),fRegFile);

					//
					SaveKeysValuesToFileRecursive(hKey,csRootPath,csRootKey,fRegFile,bRecursiveExport);
				}
			}
		}
	}
}

void CMainFrame::OnFileExport()
{
	// Common dialog box structure
	OPENFILENAME ofn;

	// maximum common dialog buffer size
	char bigBuff[2048] = "";

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);

	ofn.Flags |= OFN_EXPLORER | OFN_HIDEREADONLY | 
				 OFN_OVERWRITEPROMPT;// | OFN_PATHMUSTEXIST;

	// Modify OPENFILENAME members directly to point to bigBuff
	ofn.lpstrFile = bigBuff;
	ofn.nMaxFile = sizeof(bigBuff);

	CString csCurDir;
	char szCurDir[256];
	GetCurrentDirectory(255,szCurDir);

	csCurDir.Format("%s", szCurDir);
	ofn.lpstrInitialDir = csCurDir;
	ofn.lpstrTitle = _T("Export Registry File");
	ofn.lpstrFilter = "Native Registry Files (*.neg)\0*.neg\0Registry Files (*.reg)\0*.reg\0\0";

	CString csFile = _T("");
	if (GetOpenFileName(&ofn))
	{ 
		csFile = ofn.lpstrFile;
		CString csExt = csFile.Right(4);
		csExt.MakeLower();

		m_bNtRegFile = TRUE;
		if (csExt != _T(".neg") && csExt != _T(".reg")) {
			csFile += _T(".neg");
		}

		FILE* fReg = NULL;
		fReg = fopen(csFile,"w");
		if (fReg != NULL) {
			CString csHeader;
			if (csExt == _T(".neg")) {
				m_bNtRegFile = TRUE;
				csHeader.Format(_T("Native Registry Editor Version %i.%i.%i.%i\r\n\r\n"),MAJ_VER,MIN_VER,BLD_VER,PRI_VER);
				csHeader += _T("; by Daniel Madden (DMadden1961@yahoo.com)\r\n");
				fwrite(csHeader,sizeof(char),csHeader.GetLength(),fReg);
			}
			else if (csExt == _T(".reg")) {
				m_bNtRegFile = FALSE;
				csHeader.Format(_T("Windows Registry Editor Version 5.00\r\n\r\n; Saved by NtRegEdit Version %i.%i.%i.%i\r\n"),MAJ_VER,MIN_VER,BLD_VER,PRI_VER);
				csHeader += _T("; by Daniel Madden (DMadden1961@yahoo.com)\r\n");
				fwrite(csHeader,sizeof(char),csHeader.GetLength(),fReg);
			}
			SaveKeysValuesToFile(fReg);
			fclose(fReg);
		}
	}
}

void CMainFrame::OnUpdateFileExport(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(TRUE);
}

CString CMainFrame::GetRegistryPath(CString csKey, CStringArray& csaKeyPath)
{
	CString csSID = _T("");
	theApp.m_clsTV->m_ntReg.LookupSID(csSID);

	CString csRootPath = _T(""), csKeyPath = _T("");
	csRootPath.Format(_T("\\Registry\\User\\%s"), csSID);

	CString csFullPath = csRootPath;

	if (csKey.Left(19) == _T("HKEY_LOCAL_MACHINE\\")) {
		csFullPath = _T("\\Registry\\Machine");
		csRootPath = csKey.Mid(19);
	}
	else if (csKey.Left(11) == _T("HKEY_USERS\\")) {
		csFullPath = _T("\\Registry\\User");
		csRootPath = csKey.Mid(11);
	}
	else if (csKey.Left(18) == _T("HKEY_CLASSES_ROOT\\")) {
		csFullPath = _T("\\Registry\\Machine\\SOFTWARE\\Classes");
		csRootPath = csKey.Mid(18);
	}
	else if (csKey.Left(20) == _T("HKEY_CURRENT_CONFIG\\")) {
		csFullPath = _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current");
		csRootPath = csKey.Mid(20);
	}
	else if (csKey.Left(5) == _T("HKLM\\")) {
		csFullPath = _T("\\Registry\\Machine");
		csRootPath = csKey.Mid(19);
	}
	else if (csKey.Left(4) == _T("HKU\\")) {
		csFullPath = _T("\\Registry\\User");
		csRootPath = csKey.Mid(11);
	}
	else if (csKey.Left(5) == _T("HKLM\\")) {
		csFullPath = _T("\\Registry\\Machine\\SOFTWARE\\Classes");
		csRootPath = csKey.Mid(18);
	}
	else if (csKey.Left(5) == _T("HKLM\\")) {
		csFullPath = _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current");
		csRootPath = csKey.Mid(20);
	}
	else {
		if (csKey.Left(5) == _T("HKCU\\")) {
			csRootPath = csKey.Mid(5);
		}
		else { // HKEY_CURRENT_USER
			csRootPath = csKey.Mid(18);
		}
	}
	csaKeyPath.Add(csFullPath);

	csFullPath += _T("\\");
	csFullPath += csRootPath;


	CTokenEx tok;
	tok.Split(csRootPath,_T("\\"));
	for (int n=0; n<tok.m_csaAddIt.GetSize(); n++) {
		csaKeyPath.Add(tok.m_csaAddIt.GetAt(n));
	}

	return csFullPath;
}

DWORD CMainFrame::BreakdownLineInfo(CString csLine, CString& csValueName, int& nDataStarts)
{
	int nStrType = 0;
	DWORD dwReturn = REG_NONE;

	// We have the "Known" possible values in an array already,
	// so let's use them to check with :-)
	for (dwReturn=1; dwReturn<(DWORD)m_csaRegTypeStr.GetSize(); dwReturn++) {
		//
		// This is so when we look for a string type 
		// we search for the right type
		CString csTmpType = m_csaRegTypeStr.GetAt((int)dwReturn);
		if (dwReturn == 12 && m_bNtRegFile) {
			csTmpType += _T("str:");
		}
		else if (dwReturn == 1) {
			csTmpType += _T("\"");
		}

		nStrType = csLine.Find(csTmpType);
		if (nStrType != -1) {
			break;
		}
	}

	// Let's convert this to the word "Default"
	if (csLine.Left(2) == _T("@=")) {
		csValueName = _T("(Default)");
	}
	else if (csLine.Left(1) == _T("=")) {
		// _VC80_
		csValueName = _T("(Default)");
	}
	else { // Or ... NOT
		csValueName = csLine.Mid(1,nStrType-2);
	}

	//
	if (dwReturn > 11) {
		// _VC80_
		dwReturn-=11;
		if (dwReturn == REG_SZ) { 
			nDataStarts = nStrType+5; 
		}
		else if (dwReturn == REG_EXPAND_SZ) { 
			nDataStarts = nStrType+5; 
		}
		else if (dwReturn == REG_BINARY) { 
			nDataStarts = nStrType+5; 
		}
		else if (dwReturn == REG_DWORD) { 
			nDataStarts = nStrType+4; 
		}
		else if (dwReturn == REG_DWORD_BIG_ENDIAN) { 
			nDataStarts = nStrType+6; 
		}
		else if (dwReturn == REG_LINK) { 
			nDataStarts = nStrType+6; 
		}
		else if (dwReturn == REG_MULTI_SZ) { 
			nDataStarts = nStrType+7; 
		}
		else if (dwReturn == REG_RESOURCE_LIST) { 
			nDataStarts = nStrType+9; 
		}
		else if (dwReturn == REG_FULL_RESOURCE_DESCRIPTOR) { 
			nDataStarts = nStrType+9; 
		}
		else if (dwReturn == REG_RESOURCE_REQUIREMENTS_LIST) { 
			nDataStarts = nStrType+9; 
		}
		else if (dwReturn == REG_QWORD) { 
			nDataStarts = nStrType+7; 
		}
	}
	else {
		if (dwReturn == REG_SZ) { 
			nDataStarts = nStrType+2; 
		}
		else if (dwReturn == REG_EXPAND_SZ) { 
			nDataStarts = nStrType+8; 
		}
		else if (dwReturn == REG_BINARY) { 
			nDataStarts = nStrType+5; 
		}
		else if (dwReturn == REG_DWORD) { 
			nDataStarts = nStrType+7; 
		}
		else if (dwReturn == REG_DWORD_BIG_ENDIAN) { 
			nDataStarts = nStrType+7; 
		}
		else if (dwReturn == REG_LINK) { 
			nDataStarts = nStrType+8; 
		}
		else if (dwReturn == REG_MULTI_SZ) { 
			nDataStarts = nStrType+8; 
		}
		else if (dwReturn == REG_RESOURCE_LIST) { 
			nDataStarts = nStrType+8; 
		}
		else if (dwReturn == REG_FULL_RESOURCE_DESCRIPTOR) { 
			nDataStarts = nStrType+8; 
		}
		else if (dwReturn == REG_RESOURCE_REQUIREMENTS_LIST) { 
			nDataStarts = nStrType+9; 
		}
		else if (dwReturn == REG_QWORD) { 
			nDataStarts = nStrType+8; 
		}
	}

	return dwReturn;
}

void CMainFrame::ImportRegistryFiles(CString csFileName)
{
	CStdioFileEx sfRegFile;
	TRY
	{
		sfRegFile.Open(LPCTSTR(csFileName),CFile::modeRead | CFile::typeText);
	}
	CATCH( CFileException, e )
	{
		CString csError = _T("");
		csError.Format(_T("File could not be opened: %s"), e->m_cause);
		MessageBox(csError,_T("Import Error"), MB_OK|MB_ICONERROR);
		return;
	}
	END_CATCH

	CNtRegistry ntReg;
	ntReg.InitNtRegistry();

	//
	DWORD dwRegType = 0;
	int nDataStarts = 0;
	
	CTokenEx tok;
	UCHAR ucData[8192];

	CString csValueName = _T("");
	CString csFullKey = _T("");
	CString csData = _T("");

	BOOL bNextLine = FALSE;
	BOOL bKeyFound = FALSE;
	BOOL bHiddenKey = FALSE;

	CString csLine = _T("");
	while (sfRegFile.ReadString(csLine)) {
		//
		if (csLine.Left(3) == _T("[HK")) {
			//
			csLine.TrimLeft("[");
			csLine.TrimRight("]");

			CStringArray csaKeyPath;
			CString csFullPath = GetRegistryPath(csLine,csaKeyPath);

			if (csFullPath.Right(1) == "*") {
				// User wants to create a "Hidden" Key ...
				bHiddenKey = TRUE;
			}

			if (!ntReg.KeyExists(csFullPath)) {
				//
				csFullKey = csaKeyPath.GetAt(0);
				for (int n=1; n<csaKeyPath.GetSize(); n++) {
					//
					csFullKey += _T("\\");
					csFullKey += csaKeyPath.GetAt(n);
					if (n == (csaKeyPath.GetSize()-1) && csFullKey.Right(1) == "*") {
						CString csTmp = csFullKey;
						csFullKey = csTmp.Left(csTmp.GetLength()-1);
						if (!ntReg.CreateHiddenKey(csFullKey)) {
							//
							sfRegFile.Close();
							return;
						}
					}
					else if (!ntReg.SetKey(csFullKey,TRUE,TRUE)) {
						//
						sfRegFile.Close();
						return;
					}
					theApp.m_clsTV->TraverseTree(csFullKey);
				}
			}
			else {
				//
				if (!ntReg.SetKey(csFullPath,TRUE,TRUE)) {
					//
					sfRegFile.Close();
					return;
				}
				theApp.m_clsTV->TraverseTree(csFullKey);
			}
			bKeyFound = TRUE;
			nDataStarts = 0;
			dwRegType = REG_NONE;
			csData = _T("");
		}
		else if ((csLine.Left(2) == _T("@=") || 
				 csLine.Left(1) == _T("=") || 
				 csLine.Left(1) == _T("\"")) && 
				 bKeyFound) {
			//
			memset(ucData,0,8192);
			dwRegType = BreakdownLineInfo(csLine, csValueName, nDataStarts);
			
#if _MSC_VER >= 1400
			csLine.Trim();		// _VC80_
#else
			csLine.TrimLeft();
			csLine.TrimRight();
#endif
			csData = csLine.Mid(nDataStarts);
			if (csLine.Right(1) == _T("\\")) {
				bNextLine = TRUE;
				csData.TrimRight(_T("\\"));
			}
			else {
				// SetValue in Registry
				bNextLine = FALSE;
#if _MSC_VER >= 1400
				csData.Trim();		// _VC80_
#else
				csData.TrimLeft();
				csData.TrimRight();
#endif
				csData.TrimRight(_T("\""));

				BOOL bError = FALSE;
				switch (dwRegType) {
					case REG_SZ:
						bError = ntReg.WriteString(csFullKey,csValueName,csData);
						break;

					case REG_EXPAND_SZ:
						//
						{
							CString csNewData = _T("");
							CString csTmpData = _T("");
 							int nCtr = 0;
							tok.Split(csData,_T(","));
							for (int n=0; n<tok.m_csaAddIt.GetSize(); n++) {
								int nDec = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n));
								if (nDec != 0) {
									csNewData.Format(_T("%c"),nDec); 
									csNewData += csTmpData;
								}
							}
							bError = ntReg.WriteExpandString(csFullKey,csValueName,csNewData);
						}
						break;

					case REG_DWORD:
					case REG_DWORD_BIG_ENDIAN:
						{
							DWORD dwData = theApp.Hex2Dec(csData);
							bError = ntReg.WriteDword(csFullKey,csValueName,dwData);
						}
						break;

					case REG_MULTI_SZ:
						//
						{
							CStringArray csaData;
							CString csNewData = _T("");
							CString csTmpData = _T("");
							int nCtr = 0;
							tok.Split(csData,_T(","));
							for (int n=0; n<tok.m_csaAddIt.GetSize(); n++) {
								int nDec = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n));
								if (nDec != 0) {
									csNewData.Format(_T("%c"),nDec); 
									csNewData += csTmpData;
								}
								else {
									if ((n+1) < tok.m_csaAddIt.GetSize()) {
										int nDec2 = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n+1));
										if (nDec2 == 0 && csNewData != _T("")) {
											csaData.Add(csNewData);
											csNewData = _T("");
										}
									}
								}
							}
							bError = ntReg.WriteMultiString(csFullKey,csValueName,csaData);
						}
						break;

					case REG_BINARY:
					case REG_LINK:
					case REG_RESOURCE_LIST:
					case REG_FULL_RESOURCE_DESCRIPTOR:
					case REG_RESOURCE_REQUIREMENTS_LIST:
					case REG_QWORD:
						//
						{
							int nCtr = 0;
							tok.Split(csData,_T(","));
							for (int n=0; n<tok.m_csaAddIt.GetSize(); n++) {
								int nDec = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n));
								ucData[nCtr++] = nDec;
							}
							UINT uiLength = (UINT)nCtr+1;
							bError = ntReg.WriteValue(csFullKey, csValueName, ucData, (ULONG)uiLength, dwRegType);
						}
						break;
				}
			}
		}
		else {
			//
			memset(ucData,0,8192);
			if (bNextLine) {
				//
#if _MSC_VER >= 1400
				csLine.Trim();		// _VC80_
#else
				csLine.TrimLeft();
				csLine.TrimRight();
#endif
				if (csLine.Right(1) != _T("\\")) {
					//
					bNextLine = FALSE;
#if _MSC_VER >= 1400
					csData.Trim();		// _VC80_
#else
					csData.TrimLeft();
					csData.TrimRight();
#endif
					csData.TrimRight(_T("\""));

					BOOL bError = FALSE;
					csData += csLine;

					// SetValue in Registry
					switch (dwRegType) {
						case REG_SZ:
							bError = ntReg.WriteString(csFullKey,csValueName,csData);
							break;

						case REG_EXPAND_SZ:
							//
							{
								CString csNewData = _T("");
								CString csTmpData = _T("");
								int nCtr = 0;
								tok.Split(csData,_T(","));
								for (int n=0; n<tok.m_csaAddIt.GetSize(); n++) {
									int nDec = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n));
									if (nDec != 0) {
										csTmpData.Format(_T("%c"),nDec); 
										csNewData += csTmpData;
									}
								}
								bError = ntReg.WriteExpandString(csFullKey,csValueName,csNewData);
							}
							break;

						case REG_DWORD:
						case REG_DWORD_BIG_ENDIAN:
							{
								DWORD dwData = theApp.Hex2Dec(csData);
								bError = ntReg.WriteDword(csFullKey,csValueName,dwData);
							}
							break;

						case REG_MULTI_SZ:
							//
							{
								CStringArray csaData;
								CString csNewData = _T("");
								CString csTmpData = _T("");
								int nCtr = 0;
								tok.Split(csData,_T(","));
								for (int n=0; n<tok.m_csaAddIt.GetSize(); n++) {
									int nDec = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n));
									if (nDec != 0) {
										csTmpData.Format(_T("%c"),nDec); 
										csNewData += csTmpData;
									}
									else {
										if ((n+1) < tok.m_csaAddIt.GetSize()) {
											int nDec2 = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n+1));
											if (nDec2 == 0 && csNewData != _T("")) {
												csaData.Add(csNewData);
												csNewData = _T("");
											}
										}
									}
								}
								bError = ntReg.WriteMultiString(csFullKey,csValueName,csaData);
							}
							break;

						case REG_BINARY:
						case REG_LINK:
						case REG_RESOURCE_LIST:
						case REG_FULL_RESOURCE_DESCRIPTOR:
						case REG_RESOURCE_REQUIREMENTS_LIST:
						case REG_QWORD:
							//
							{
								int nCtr = 0;
								tok.Split(csData,_T(","));
								for (int n=0; n<tok.m_csaAddIt.GetSize(); n++) {
									int nDec = theApp.Hex2Dec(tok.m_csaAddIt.GetAt(n));
									ucData[nCtr++] = nDec;
								}
								UINT uiLength = (UINT)nCtr+1;
								bError = ntReg.WriteValue(csFullKey, csValueName, ucData, (ULONG)uiLength, dwRegType);
							}
							break;
					}
				}
				else {
					csData += csLine;
#if _MSC_VER >= 1400
					csLine.Trim();		// _VC80_
#else
					csLine.TrimLeft();
					csLine.TrimRight();
#endif
					csData.TrimRight(_T("\\"));
				}
			}
			else {
				bKeyFound = FALSE;
			}
		}
	}
}


void CMainFrame::OnFileImport()
{
	// Common dialog box structure
	OPENFILENAME ofn;

	// maximum common dialog buffer size
	char bigBuff[2048] = "";

	ZeroMemory(&ofn, sizeof(OPENFILENAME));
	ofn.lStructSize = sizeof(OPENFILENAME);

	ofn.Flags |= OFN_EXPLORER | OFN_HIDEREADONLY | 
				 OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST;

	// Modify OPENFILENAME members directly to point to bigBuff
	ofn.lpstrFile = bigBuff;
	ofn.nMaxFile = sizeof(bigBuff);

	CString csCurDir;
	char szCurDir[256];
	GetCurrentDirectory(255,szCurDir);

	csCurDir.Format("%s", szCurDir);
	ofn.lpstrInitialDir = csCurDir;
	ofn.lpstrTitle = _T("Import to Registry File");
	ofn.lpstrFilter = "Native Registry Files (*.neg)\0*.neg\0Registry Files (*.reg)\0*.reg\0\0";

	CString csFile = _T("");
	if (GetOpenFileName(&ofn))
	{ 
		csFile = ofn.lpstrFile;
		CString csExt = csFile.Right(4);
		csExt.MakeLower();

		m_bNtRegFile = TRUE;
		if (csExt != _T(".reg") && csExt != _T(".neg")) {
			m_bNtRegFile = TRUE;
			csFile += _T(".neg");
		}
		else if (csExt == _T(".reg")) {
			m_bNtRegFile = FALSE;
		}
		ImportRegistryFiles(csFile);
	}
}

void CMainFrame::OnUpdateFileImport(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(TRUE);
}

void CMainFrame::OnEditPermissions()
{
	theApp.m_clsTV->m_ntReg.ShowPermissionsDlg(this->GetSafeHwnd());
}

void CMainFrame::OnUpdateEditPermissions(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(TRUE);
}

void CMainFrame::OnAppSettings()
{
	CSAPrefsDialog dlg;

	COptGeneralDlg optGeneral;
	COptTreeDlg optTree;
	COptListDlg optList;

	dlg.AddPage(optGeneral, "General");
	dlg.AddPage(optList, "List Control");//, &optPktAn);
	dlg.AddPage(optTree, "Tree Control");//, &optPktAn);
//	dlg.AddPage(optHex, "Hex Control", &optPktAn);

	dlg.SetTitle("NtRegEdit - Application Settings");
	dlg.SetConstantText("NtRegEdit");

	CNtRegistry ntReg;
	{
		if (ntReg.SetKey(HKEY_CURRENT_USER,"Software\\NtRegEdit\\Settings",FALSE,TRUE))
		{
			m_crText = ntReg.ReadColor("TextColor",RGB(255,255,255));
			m_crBG = ntReg.ReadColor("BGColor",RGB(240,240,240));
			m_crShadow = ntReg.ReadColor("ShadowColor",RGB(0,0,0));
		}
		else
		{
			m_crText=RGB(255,255,255);
			m_crBG=RGB(240,240,240);
			m_crShadow=RGB(0,0,0);
		}
	}

	dlg.SetConstantTextColor(m_crText);
	dlg.SetConstantBGColor(m_crBG);
	dlg.SetConstantShadowColor(m_crShadow);

	//// if we set this to true, it will call UpdateData on the current page,
	//// before switching pages and the page switch will only happen if
	//// UpdateData succeeds.
	//dlg.SetValidateBeforeChangingPages(true);
	//dlg1.m_iComboSelection  = m_iComboSetting;

	if (dlg.DoModal()==IDOK)
	{
		//m_iComboSetting = dlg1.m_iComboSelection;
	}
}

void CMainFrame::OnUpdateAppSettings(CCmdUI *pCmdUI)
{
	pCmdUI->Enable(TRUE);
}

void CMainFrame::OnNewQword()
{
	//
	theApp.m_clsFramework->SetActivePane(theApp.m_clsMainFrm->m_pNestedBinaryView);
}

void CMainFrame::OnUpdateNewQwordValue(CCmdUI *pCmdUI)
{
	if (theApp.m_clsTV->m_hItem == theApp.m_clsTV->m_hRoot) {
		pCmdUI->Enable(FALSE);
	}
	else {
		pCmdUI->Enable(m_bValuePressed);
	}
}

void CMainFrame::OnNtregConnect()
{
	////
	//if (theApp.ConnectNtRegistry(_T("<SYSTEM_NAME>"),HKEY_LOCAL_MACHINE)) {
	//	//
	//	theApp.m_clsTV->InitTree();
	//}
}

void CMainFrame::OnUpdateNtregConnect(CCmdUI *pCmdUI)
{
	//pCmdUI->Enable((BOOL)!theApp.m_clsTV->m_ntReg.m_hMachineReg);
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnNtregRefresh()
{
	//theApp.m_clsTV->InitTree();
}

void CMainFrame::OnUpdateNtregRefresh(CCmdUI *pCmdUI)
{
	//pCmdUI->Enable((BOOL)theApp.m_clsTV->m_ntReg.m_hMachineReg);
	pCmdUI->Enable(FALSE);
}

void CMainFrame::OnNtregDisconnect()
{
	//if (theApp.m_clsTV->m_ntReg.m_hMachineReg) {
	//	theApp.m_clsTV->m_ntReg.NtClose(theApp.m_clsTV->m_ntReg.m_hMachineReg);
	//	theApp.m_clsTV->m_ntReg.m_hMachineReg = 0x0;
	//	theApp.m_clsTV->m_ntReg.m_csMachineName = _T("");
	//}
}

void CMainFrame::OnUpdateNtregDisconnect(CCmdUI *pCmdUI)
{
	//pCmdUI->Enable((BOOL)theApp.m_clsTV->m_ntReg.m_hMachineReg);
	pCmdUI->Enable(FALSE);
}
