// MainFrm.h : interface of the CMainFrame class
//

#pragma once

#include "VisualFx.h"
#include "CoolMenu.h"

#include "ExtStatusControlBar.h"

class CMainFrame : public CFrameWnd
{
	
protected: // create from serialization only
	CMainFrame();
	DECLARE_DYNCREATE(CMainFrame)

// Attributes
public:

	TVisualFramework m_Framework;
	TVisualObject	*m_pTreeView;
	TVisualObject	*m_pNestedListView;
	TVisualObject	*m_pNestedFormView;
	TVisualObject	*m_pNestedBinaryView;
	TVisualObject	*m_pNestedDWordView;
	TVisualObject	*m_pNestedMStringView;
	TVisualObject	*m_pNestedStringView;
	TVisualObject	*m_pNestedFSView;

	BOOL			m_bKeyPressed;
	BOOL			m_bValuePressed;
	BOOL			bFoundDirs;

	BOOL			m_bNtRegFile;

	CStringArray	m_csaRegTypeStr;

	CString			m_csNtRegEditFile;
	CString m_csDir, m_csFile, m_csAppLogDir;
	CString m_csBinDir, m_csBinFile, m_csAppDir;
	CString m_csTempDir;

	DWORD			m_dwMaxLogFileSize;

	COLORREF m_crText, m_crBG, m_crShadow;

	COLORREF m_crHKCRColors;
	COLORREF m_crHKCUColors;
	COLORREF m_crHKLMColors;
	COLORREF m_crHKUColors;
	COLORREF m_crHKCCColors;

	COLORREF m_crSZ;
	COLORREF m_crEXPAND_SZ;
	COLORREF m_crBINARY;
	COLORREF m_crDWORD;
	COLORREF m_crDWORD_BIG_ENDIAN;
	COLORREF m_crLINK;
	COLORREF m_crMULTI_SZ;
	COLORREF m_crRESOURCE_LIST;
	COLORREF m_crFULL_RESOURCE_DESCRIPTOR;
	COLORREF m_crRESOURCE_REQUIREMENTS_LIST;
	COLORREF m_crQWORD;

	BOOL	m_bUseTreeColors;

	BOOL m_bBold;
	BOOL m_bBoldHidden;
	BOOL m_bColors;
	BOOL m_bSaveFile;

	CSize m_sValueViews;
	CSize m_sListView;
	CSize m_sTreeView;


// Operations
public:

	void AddTextPane(UINT unID, int nPosition, CString csString, int nLength);
	void DisablePane(int nPosition);
	void RemovePane(int nPosition);

	BOOL SearchForTreeNode(HTREEITEM hItem, CString csNode);

	void SaveKeysValuesToFile(FILE* fRegFile);
	void SaveKeysValuesToFileRecursive(HKEY hKey, CString csRootPath, 
									   CString csRootKey, FILE* fRegFile,
									   BOOL bRecursiveExport);
	CString GetRegistryPath(CString csKey, CStringArray& csaKeyPath);
	void ImportRegistryFiles(CString csFileName);
	DWORD BreakdownLineInfo(CString csLine, CString& csValueName, int& nDataStarts);


	void EnableBinaryView(BOOL bEnable);
	void EnableDWordView(BOOL bEnable);
	void EnableMStringView(BOOL bEnable);
	void EnableStringView(BOOL bEnable);
	void EnableFSView(BOOL bEnable);

// Overrides
public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual BOOL OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext);

// Implementation
public:
	virtual ~CMainFrame();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:  // control bar embedded members
	CToolBar			m_wndToolBar;
	CCoolMenuManager	m_coolmenu;	
public:
	CExtStatusControlBar  m_wndStatusBar;

// Generated message map functions
protected:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnDestroy();
	afx_msg void OnCopyKeyValue();
	afx_msg void OnUpdateCopyKeyValue(CCmdUI *pCmdUI);
	afx_msg void OnCreateKey();
	afx_msg void OnUpdateCreateKey(CCmdUI *pCmdUI);
	afx_msg void OnCreateHiddenKey();
	afx_msg void OnUpdateCreateHiddenKey(CCmdUI *pCmdUI);
//	afx_msg void OnCreateValue();
//	afx_msg void OnUpdateCreateValue(CCmdUI *pCmdUI);
	afx_msg void OnSearch();
	afx_msg void OnUpdateSearch(CCmdUI *pCmdUI);
	afx_msg void OnDeleteKeyValue();
	afx_msg void OnUpdateDeleteKeyValue(CCmdUI *pCmdUI);
	afx_msg void OnRecursivelyKey();
	afx_msg void OnUpdateRecursivelyKey(CCmdUI *pCmdUI);
	afx_msg void OnKeysFindhiddenkeys();
	afx_msg void OnUpdateKeysFindhiddenkeys(CCmdUI *pCmdUI);
	afx_msg void OnRenameKeyValue();
	afx_msg void OnUpdateRenameKeyValue(CCmdUI *pCmdUI);
	afx_msg void OnKeysRefresh();
	afx_msg void OnUpdateKeysRefresh(CCmdUI *pCmdUI);
	afx_msg void OnNewBinary();
	afx_msg void OnUpdateNewBinary(CCmdUI *pCmdUI);
	afx_msg void OnNewDword();
	afx_msg void OnUpdateNewDword(CCmdUI *pCmdUI);
	afx_msg void OnNewSzValue();
	afx_msg void OnUpdateNewSzValue(CCmdUI *pCmdUI);
	afx_msg void OnNewSzeValue();
	afx_msg void OnUpdateNewSzeValue(CCmdUI *pCmdUI);
	afx_msg void OnNewSzmValue();
	afx_msg void OnUpdateNewSzmValue(CCmdUI *pCmdUI);
	afx_msg void OnFileExport();
	afx_msg void OnUpdateFileExport(CCmdUI *pCmdUI);
	afx_msg void OnFileImport();
	afx_msg void OnUpdateFileImport(CCmdUI *pCmdUI);
	afx_msg void OnEditPermissions();
	afx_msg void OnUpdateEditPermissions(CCmdUI *pCmdUI);
	afx_msg void OnAppSettings();
	afx_msg void OnUpdateAppSettings(CCmdUI *pCmdUI);
	afx_msg void OnNewQword();
	afx_msg void OnUpdateNewQwordValue(CCmdUI *pCmdUI);
public:
	afx_msg void OnNtregConnect();
public:
	afx_msg void OnUpdateNtregConnect(CCmdUI *pCmdUI);
public:
	afx_msg void OnNtregRefresh();
public:
	afx_msg void OnUpdateNtregRefresh(CCmdUI *pCmdUI);
public:
	afx_msg void OnNtregDisconnect();
public:
	afx_msg void OnUpdateNtregDisconnect(CCmdUI *pCmdUI);
};


