// NtRegEdit.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "MainFrm.h"

#include "NtRegEditDoc.h"
#include "NtRegEditView.h"

#include "NtRegistry.h"
#include "afxwin.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };
	CStatic	m_staVersion;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
public:
	CEdit m_edtSourceCode;
	virtual BOOL OnInitDialog();
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, EDT_SOURCE_CODE, m_edtSourceCode);
	DDX_Control(pDX, STA_VERSION, m_staVersion);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

// CAboutDlg message handlers
BOOL CAboutDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	CString csSource;
	csSource += _T("Source Code:\r\n\r\n");
	csSource += _T("    StatusBar\t-  FOSS Software, Inc.\r\n");
	csSource += _T("    MemDC\t-  Keith Rule\r\n");
	csSource += _T("    DumpCtrl\t-  JEugene Pustovoyt\r\n");
	csSource += _T("    StdioFile\t-  David Pritchard\r\n");
	csSource += _T("    Subclassing\t-  Paul DiLascia\r\n");
	csSource += _T("    Framework\t-  Zoran M.Todorovic\r\n");
	csSource += _T("    List Control\t-  Hans Dietrich\r\n");

	m_edtSourceCode.SetWindowTextA(csSource);

	CString csVersion;
	csVersion.Format(_T("NtRegEdit Version %i.%i.%i.%i"),MAJ_VER,MIN_VER,BLD_VER,PRI_VER);
	m_staVersion.SetWindowTextA(csVersion);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

// CNtRegEditApp
BEGIN_MESSAGE_MAP(CNtRegEditApp, CWinApp)
#if _MSC_VER >= 1400
	ON_COMMAND(ID_APP_ABOUT, &CNtRegEditApp::OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, &CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, &CWinApp::OnFileOpen)
#else
	ON_COMMAND(ID_APP_ABOUT, CNtRegEditApp::OnAppAbout)
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
#endif
END_MESSAGE_MAP()

// CNtRegEditApp construction
CNtRegEditApp::CNtRegEditApp()
{
#if _MSC_VER >= 1400
	EnableHtmlHelp();
#endif
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

// The one and only CNtRegEditApp object
CNtRegEditApp theApp;

// App command to run the dialog
void CNtRegEditApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

// CNtRegEditApp initialization
BOOL CNtRegEditApp::InitInstance()
{
	// InitCommonControlsEx() is required on Windows XP if an application
	// manifest specifies use of ComCtl32.dll version 6 or later to enable
	// visual styles.  Otherwise, any window creation will fail.
	INITCOMMONCONTROLSEX InitCtrls;
	InitCtrls.dwSize = sizeof(InitCtrls);

	// Set this to include all the common control classes you want to use
	// in your application.
	InitCtrls.dwICC = ICC_WIN95_CLASSES;
	InitCommonControlsEx(&InitCtrls);

	CWinApp::InitInstance();

	// Initialize OLE libraries
	if (!AfxOleInit()) {
		//
		AfxMessageBox(IDP_OLE_INIT_FAILED);
		return FALSE;
	}
	AfxEnableControlContainer();

	// Standard initialization
	CNtRegistry reg;
	if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings"),FALSE,TRUE))
	{
		m_bWindowOnTop = reg.ReadBool(_T("AlwaysOnTop"),FALSE);
		m_bSaveWindowPos = reg.ReadBool(_T("SaveWindowPos"),TRUE);
		m_bCheckOSType = reg.ReadBool(_T("CheckOSType"),TRUE);
		if (m_bCheckOSType) {
			if (!reg.IsW2KorBetter()) {
				MessageBox(NULL,_T("You MUST have Windows 2000 or greater to run this application!"),_T("Error: OS Type"),MB_OK|MB_ICONERROR);
				return FALSE;
			}
		}

		m_bCheckIsUserAdmin = reg.ReadBool(_T("CheckIsUserAdmin"),TRUE);
		if (m_bCheckIsUserAdmin) {
			if (!reg.IsAdministrorMember()) {
				MessageBox(NULL,_T("You MUST be an Administrator to run this application!"),_T("Error: Administrator"),MB_OK|MB_ICONERROR);
				return FALSE;
			}
		}
	}
	else {
		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software"),TRUE,TRUE))
			if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit"),TRUE,TRUE))
				reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings"),TRUE,TRUE);
	}

	// Needs to be set before it starts for the first time...
	if (!reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),FALSE,TRUE))
	{
		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE)) {
			CSize cs(0,380);
			reg.WriteSize(_T("VSize"),&cs);
		}
	}

	// Needs to be set before it starts for the first time...
	if (!reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\TreeCtrl"),FALSE,TRUE))
	{
		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\TreeCtrl"),TRUE,TRUE)) {
			CSize cs(175,0);
			reg.WriteSize(_T("VSize"),&cs);
		}
	}

	// Needs to be set before it starts for the first time...
	if (!reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ValueViews"),FALSE,TRUE))
	{
		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ValueViews"),TRUE,TRUE)) {
			CSize cs(0,0);
			reg.WriteSize(_T("VSize"),&cs);
		}
	}

	LoadStdProfileSettings(7);  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views
	CSingleDocTemplate* pDocTemplate;
	pDocTemplate = new CSingleDocTemplate(
		IDR_MAINFRAME,
		RUNTIME_CLASS(CNtRegEditDoc),
		RUNTIME_CLASS(CMainFrame),       // main SDI frame window
		RUNTIME_CLASS(CNtRegEditView));
	if (!pDocTemplate) {
		return FALSE;
	}
	AddDocTemplate(pDocTemplate);

	// Enable DDE Execute open
	EnableShellOpen();
	RegisterShellFileTypes(TRUE);

	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line.  Will return FALSE if
	// app was launched with /RegServer, /Register, /Unregserver or /Unregister.
	if (!ProcessShellCommand(cmdInfo)) {
		return FALSE;
	}

	m_clsTV->SelectRootItem();

	// If this is the firstime this app is ran,
	// then make it MAXIMIZED.  As soon as the user
	// closes the app for the first time, it will
	// save the placement of the mail window so when
	// it is ran the next time, it will show up exactly 
	// where it was before :-)
	//
	// Place the window where it was before...
	//
	if (!reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\WindowPlacement"),FALSE,TRUE))
	{
		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software"),TRUE,TRUE))
		{
			if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit"),TRUE,TRUE))
			{
				if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings"),TRUE,TRUE))
				{
					reg.WriteBool(_T("AlwaysOnTop"),m_bWindowOnTop);
					reg.WriteBool(_T("SaveWindowPos"),m_bSaveWindowPos);
					reg.WriteBool(_T("CheckOSType"),m_bCheckOSType);
					reg.WriteBool(_T("CheckIsUserAdmin"),m_bCheckIsUserAdmin);
					reg.WriteDword(_T("MaxLogFileSize"),250000);

					CString csCurDir = _T("");;
					char szCurDir[256];
					GetCurrentDirectory(256,szCurDir);
					csCurDir.Format(_T("%s"),szCurDir);

					reg.WriteString(_T("Path"),csCurDir);

					csCurDir.Format(_T("%s\\Logs"),szCurDir);
					reg.WriteString(_T("Logs"),csCurDir);

					csCurDir.Format(_T("%s\\Temp"),szCurDir);
					reg.WriteString(_T("Temp"),csCurDir);

					reg.WriteColor(_T("BGColor"),RGB(240,240,240));
					reg.WriteColor(_T("ShadowColor"),RGB(255,255,255));
					reg.WriteColor(_T("TextColor"),RGB(0,0,0));

					if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE))
					{
						reg.WriteBool(_T("UseTreeColors"),FALSE);
						if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl\\ItemColors"),TRUE,TRUE))
						{
							reg.WriteColor(_T("SZ"),RGB(0,0,0));
							reg.WriteColor(_T("EXPAND_SZ"),RGB(0,0,0));
							reg.WriteColor(_T("BINARY"),RGB(0,0,0));
							reg.WriteColor(_T("DWORD"),RGB(0,0,0));
							reg.WriteColor(_T("DWORD_BIG_ENDIAN"),RGB(0,0,0));
							reg.WriteColor(_T("LINK"),RGB(0,0,0));
							reg.WriteColor(_T("MULTI_SZ"),RGB(0,0,0));
							reg.WriteColor(_T("RESOURCE_LIST"),RGB(0,0,0));
							reg.WriteColor(_T("FULL_RESOURCE_DESCRIPTOR"),RGB(0,0,0));
							reg.WriteColor(_T("RESOURCE_REQUIREMENTS_LIST"),RGB(0,0,0));
							reg.WriteColor(_T("QWORD"),RGB(0,0,0));
						}
					}

					if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\TreeCtrl"),TRUE,TRUE))
					{
						reg.WriteBool(_T("UseBoldHidden"),TRUE);
						reg.WriteBool(_T("UseBold"),TRUE);
						reg.WriteBool(_T("UseColor"),TRUE);

						if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\TreeCtrl\\KeyColors"),TRUE,TRUE))
						{
							reg.WriteColor(_T("HKCR"), RGB(0,0,0));
							reg.WriteColor(_T("HKCU"), RGB(0,0,0));
							reg.WriteColor(_T("HKLM"), RGB(0,0,0));
							reg.WriteColor(_T("HKU"), RGB(0,0,0));
							reg.WriteColor(_T("HKCC"), RGB(0,0,0));
						}
					}

					if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\WindowPlacement"),TRUE,TRUE))
					{
						reg.WriteDword(_T("wp.bottom"),0);
						reg.WriteDword(_T("wp.flags"),0);
						reg.WriteDword(_T("wp.left"),0);
						reg.WriteDword(_T("wp.right"),0);
						reg.WriteDword(_T("wp.showCmd"),0);
						reg.WriteDword(_T("wp.top"),0);
						reg.WriteDword(_T("wp.ptMaxPosition.x"),0);
						reg.WriteDword(_T("wp.ptMaxPosition.y"),0);
						reg.WriteDword(_T("wp.ptMinPosition.x"),0);
						reg.WriteDword(_T("wp.ptMinPosition.y"),0);
					}
				}
			}
		}
		AfxGetMainWnd()->ShowWindow(SW_SHOWMAXIMIZED);
	}
	else
	{
		WINDOWPLACEMENT wp;
		wp.length = sizeof wp;

		wp.rcNormalPosition.bottom = reg.ReadDword(_T("wp.bottom"),0);
		wp.flags = reg.ReadDword(_T("wp.flags"),0);
		wp.rcNormalPosition.left = reg.ReadDword(_T("wp.left"),0);
		wp.rcNormalPosition.right = reg.ReadDword(_T("wp.right"),0);
		wp.showCmd = reg.ReadDword(_T("wp.showCmd"),0);
		wp.rcNormalPosition.top = reg.ReadDword(_T("wp.top"),0);
		wp.ptMaxPosition.x = reg.ReadDword(_T("wp.ptMaxPosition.x"),0);
		wp.ptMaxPosition.y = reg.ReadDword(_T("wp.ptMaxPosition.y"),0);
		wp.ptMinPosition.x = reg.ReadDword(_T("wp.ptMinPosition.x"),0);
		wp.ptMinPosition.y = reg.ReadDword(_T("wp.ptMinPosition.y"),0);

		AfxGetMainWnd()->SetWindowPlacement(&wp);
	}
	AfxGetMainWnd()->UpdateWindow();	

	//
	// Now do the window "AlwaysOnTop" piece
	//
	const CWnd* pWnd = &CWnd::wndTopMost;
	DWORD dwStyle = ::GetWindowLong(m_pMainWnd->m_hWnd, GWL_EXSTYLE);

	if (m_bWindowOnTop) {
		pWnd = &CWnd::wndTopMost;
	}
	else {
		pWnd = &CWnd::wndNoTopMost;
	}

	AfxGetMainWnd()->SetWindowPos(pWnd,0,0,0,0,SWP_NOSIZE|SWP_NOMOVE);

	// Enable drag/drop open
	m_pMainWnd->DragAcceptFiles();

	if (!cmdInfo.m_strFileName.IsEmpty())
	{
		m_clsMainFrm->m_csBinFile = cmdInfo.m_strFileName;
		m_clsLV->m_xList.SetRedraw(FALSE);
		m_clsLV->m_xList.DeleteAllItems();
		//
		// Do Something...??
		//
		m_clsLV->m_xList.SetRedraw(TRUE);
		CString csText = "NtRegEdit - ";
		csText += m_clsMainFrm->m_csBinFile;
		theApp.m_clsMainFrm->SetWindowText(csText);
	}

	return TRUE;
}

CString CNtRegEditApp::GetLocalMachineName(void)
{
	char szWkstaName[MAX_COMPUTERNAME_LENGTH+1];
	DWORD dwWSize = sizeof(szWkstaName);
	GetComputerName(szWkstaName, &dwWSize);
	CString csLocalMachine = _T("");
	csLocalMachine.Format(_T("%s"),szWkstaName);
	return csLocalMachine;
}

// CNtRegEditApp message handlers
BOOL CNtRegEditApp::OnOpenRecentFile(UINT nIDIndex) 
{
	ASSERT_VALID(this);
	ASSERT(m_pRecentFileList != NULL);

	ASSERT(nIDIndex >= ID_FILE_MRU_FILE1);
	ASSERT(nIDIndex < ID_FILE_MRU_FILE1 + (UINT)m_pRecentFileList->GetSize());

	CString csFileName, csText = _T("NtRegEdit - ");
	int nIndex = nIDIndex - ID_FILE_MRU_FILE1;
	ASSERT((*m_pRecentFileList)[nIndex].GetLength() != 0);

	csFileName.Format(_T("%s"), (LPCTSTR)(*m_pRecentFileList)[nIndex]);

	theApp.m_clsMainFrm->m_csNtRegEditFile = csFileName;
	theApp.m_clsLV->m_xList.SetRedraw(FALSE);
	theApp.m_clsLV->m_xList.DeleteAllItems();
	theApp.m_clsLV->m_xList.SetRedraw(TRUE);
	csText += theApp.m_clsMainFrm->m_csNtRegEditFile;
	theApp.m_clsMainFrm->SetWindowText(csText);

	return TRUE;
}

int CNtRegEditApp::Hex2Dec(CString csHex)
{
	int tot = 0;
	char hex[17] = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f','\0'};
	int num[16] = {0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15};

	int base = 1;
	int nCtr = csHex.GetLength()-1;
	for (int n=nCtr; n>=0; n--)
	{
		char lc = csHex[n];
		int vl = 0;
		for (int n=0; n<16; n++)
		{
			char cc = hex[n];
			if (lc == cc)
			{
				vl = num[n];
				break;
			}
		}
		tot = tot + (base * vl);
		base = base * 16;
	}
	return tot;
}

void CNtRegEditApp::SetAttributes(CString csFilename, BYTE btAttrib) 
{
	char* pFileName = csFilename.GetBuffer(csFilename.GetLength() + 1);
	CFileStatus status;

	// This is a MUST
	status.m_mtime = 0;

	// Set the file attribute member
	status.m_attribute = btAttrib;

	// Set the file attribute
	CFile::SetStatus( pFileName, status );
}

BYTE CNtRegEditApp::GetAttributes(CString csFilename) 
{
	char* pFileName = csFilename.GetBuffer(csFilename.GetLength() + 1);
	CFileStatus status;

	// Get the file attribute
	CFile::GetStatus( pFileName, status );

	// return the file attribute
	return status.m_attribute;
}

BOOL CNtRegEditApp::DoesFileExist(CString csFilename) 
{
	char* pFileName = csFilename.GetBuffer(csFilename.GetLength() + 1);
	CFileStatus status;

	// Return the existance of the file
	return (CFile::GetStatus( pFileName, status ));
}

////
//// This uses the Win32 version until I can figure
//// out a way to do it with Native API's
////
//// IN CString	= _T("\\\\MySystem01") 
//// IN HANDLE	= HKEY_LOCAL_MACHINE
////
//BOOL CNtRegEditApp::ConnectNtRegistry(
//						CString csMachineName,	// address/name of remote computer 
//						HKEY hKey)				// predefined registry handle
//{
//	if (hKey == NULL) {
//		return FALSE;
//	}
//
//	CString csUNCName = _T("");
//
//	LONG lReturn = 0;
//	if(csMachineName.IsEmpty()) {
//		lReturn = RegConnectRegistry(NULL, hKey, (PHKEY)&theApp.m_clsTV->m_ntReg.m_hMachineReg);
//	}
//	else if(csMachineName.CompareNoCase(GetLocalMachineName()) == 0) {
//		lReturn = RegConnectRegistry(NULL, hKey, (PHKEY)&theApp.m_clsTV->m_ntReg.m_hMachineReg);
//	}
//	else
//	{
//		if (csMachineName.Left(4) != _T("\\\\")) {
//			csUNCName = _T("\\\\") + csMachineName;
//		}
//		lReturn = RegConnectRegistry(csUNCName, hKey, (PHKEY)&theApp.m_clsTV->m_ntReg.m_hMachineReg);
//	}
//
//	if (lReturn != ERROR_SUCCESS) {
//		MessageBox(NULL,_T("Remote connection failed!!"),_T("Error: Remote"),MB_OK|MB_ICONERROR);
//		return FALSE;
//	}
//
//	theApp.m_clsTV->m_ntReg.m_csMachineName = csUNCName;
//
//	//
//	return TRUE;
//}
