/////////////////////////////////////////////////////////
// NtRegEditTreeView.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "NtRegEditTreeView.h"

#include "NtRegistry.h"

// CNtRegEditTreeView
IMPLEMENT_DYNCREATE(CNtRegEditTreeView, CTreeView)

BEGIN_MESSAGE_MAP(CNtRegEditTreeView, CTreeView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_PAINT()
#if _MSC_VER >= 1400
	ON_NOTIFY_REFLECT(NM_CLICK, &CNtRegEditTreeView::OnClick)
	ON_NOTIFY_REFLECT(NM_RCLICK, &CNtRegEditTreeView::OnRclick)
	ON_NOTIFY_REFLECT(TVN_KEYDOWN, &CNtRegEditTreeView::OnTvnKeydown)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, &CNtRegEditTreeView::OnTvnSelchanged)
	ON_NOTIFY_REFLECT(TVN_BEGINLABELEDIT, &CNtRegEditTreeView::OnTvnBeginlabeledit)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, &CNtRegEditTreeView::OnTvnEndlabeledit)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, &CNtRegEditTreeView::OnTvnItemexpanding)
	ON_NOTIFY_REFLECT(TVN_SELCHANGING, &CNtRegEditTreeView::OnTvnSelchanging)
#else
	ON_NOTIFY_REFLECT(NM_CLICK, CNtRegEditTreeView::OnClick)
	ON_NOTIFY_REFLECT(NM_RCLICK, CNtRegEditTreeView::OnRclick)
	ON_NOTIFY_REFLECT(TVN_KEYDOWN, CNtRegEditTreeView::OnTvnKeydown)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, CNtRegEditTreeView::OnTvnSelchanged)
	ON_NOTIFY_REFLECT(TVN_BEGINLABELEDIT, CNtRegEditTreeView::OnTvnBeginlabeledit)
	ON_NOTIFY_REFLECT(TVN_ENDLABELEDIT, CNtRegEditTreeView::OnTvnEndlabeledit)
	ON_NOTIFY_REFLECT(TVN_ITEMEXPANDING, CNtRegEditTreeView::OnTvnItemexpanding)
	ON_NOTIFY_REFLECT(TVN_SELCHANGING, CNtRegEditTreeView::OnTvnSelchanging)
#endif
END_MESSAGE_MAP()

CNtRegEditTreeView::CNtRegEditTreeView()
{
	m_cr3DFace			= ::GetSysColor(COLOR_3DFACE);
	m_cr3DHighLight		= ::GetSysColor(COLOR_3DHIGHLIGHT);
	m_cr3DShadow		= ::GetSysColor(COLOR_3DSHADOW);
	m_crBtnFace			= ::GetSysColor(COLOR_BTNFACE);
	m_crBtnShadow		= ::GetSysColor(COLOR_BTNSHADOW);
	m_crBtnText			= ::GetSysColor(COLOR_BTNTEXT);
	m_crGrayText		= ::GetSysColor(COLOR_GRAYTEXT);
	m_crHighLight		= ::GetSysColor(COLOR_HIGHLIGHT);
	m_crHighLightText	= ::GetSysColor(COLOR_HIGHLIGHTTEXT);
	m_crWindow			= ::GetSysColor(COLOR_WINDOW);
	m_crWindowText		= ::GetSysColor(COLOR_WINDOWTEXT);

	m_crColorWhite		= RGB(	255,	255,	255 );
	m_crColorBlack		= RGB(	0,		0,		0   );
	m_crColorBlue		= RGB(	0,		0,		123 );
	m_crColorGreen		= RGB(	0,		146,	0   );
	m_crColorLRed		= RGB(	255,	0,		0   );
	m_crColorBrown		= RGB(	128,	0,		0   );
	m_crColorPurple		= RGB(	128,	0,		128 );
	m_crColorOrange		= RGB(	128,	128,	0   );
	m_crColorYellow		= RGB(	255,	255,	0   );
	m_crColorLGreen		= RGB(	0,		255,	0   );
	m_crColorCyan		= RGB(	0,		146,	148 );
	m_crColorLCyan		= RGB(	0,		255,	255 );
	m_crColorLBlue		= RGB(	0,		0,		255 );
	m_crColorPink		= RGB(	255,	0,		255 );
	m_crColorGrey		= RGB(	123,	125,	123 );
	m_crColorLLGrey		= RGB(	214,	211,	214 );
	m_crColorLGrey		= RGB(	224,	224,	224 );

	CNtRegistry ntReg;
	if (ntReg.SetKey(HKEY_CURRENT_USER,"Software\\NtRegEdit\\Settings\\TreeCtrl",TRUE,TRUE))
	{
		m_bUseBold = ntReg.ReadBool(_T("UseBold"),FALSE);
		m_bUseBoldHidden = ntReg.ReadBool(_T("UseBoldHidden"),FALSE);
	}
}

CNtRegEditTreeView::~CNtRegEditTreeView()
{
}

BOOL CNtRegEditTreeView::PreCreateWindow(CREATESTRUCT& cs) 
{
	return CTreeView::PreCreateWindow(cs);
}

// CNtRegEditTreeView diagnostics
#ifdef _DEBUG
void CNtRegEditTreeView::AssertValid() const { CTreeView::AssertValid(); }
#ifndef _WIN32_WCE
void CNtRegEditTreeView::Dump(CDumpContext& dc) const { CTreeView::Dump(dc); }
#endif
#endif //_DEBUG

// CNtRegEditTreeView message handlers
void CNtRegEditTreeView::OnInitialUpdate() 
{
	CTreeView::OnInitialUpdate();
	
	//m_tcEx.InitializeCtrl();
	CTreeCtrl& tc = GetTreeCtrl();

	// Create the image list that is attached to the tree control
	// Loadup the image list
	VERIFY(m_pImageTree.Create(IDB_ICONS, 16, 1, RGB(255,0,255)));

	//Hook it up to the tree control
	tc.SetImageList(&m_pImageTree, TVSIL_NORMAL);

	theApp.m_clsTV = (CNtRegEditTreeView*)this;

	InitTree();
}

void CNtRegEditTreeView::InitTree(void)
{
	CString csMachineName = _T("");
	if (theApp.m_clsTV->m_ntReg.m_csMachineName == _T("")) {
		csMachineName = theApp.GetLocalMachineName();
	}
	else {
		csMachineName = theApp.m_clsTV->m_ntReg.m_csMachineName;
	}

	CTreeCtrl& tc = GetTreeCtrl();

	tc.SetRedraw(FALSE);

	tc.DeleteAllItems();

	m_hRoot = tc.InsertItem(csMachineName,0,0);
	m_hHKCR = tc.InsertItem(_T("HKEY_CLASSES_ROOT"),2,2,m_hRoot);
	tc.InsertItem(FAKEDITEM,5,5,m_hHKCR,TVI_LAST);
	SetItemColor(m_hHKCR,theApp.m_clsMainFrm->m_crHKCRColors);
	SetItemBold(m_hHKCR,m_bUseBold);

	m_hHKCU = tc.InsertItem(_T("HKEY_CURRENT_USER"),2,2,m_hRoot);
	tc.InsertItem(FAKEDITEM,5,5,m_hHKCU,TVI_LAST);
	SetItemColor(m_hHKCU,theApp.m_clsMainFrm->m_crHKCUColors);
	SetItemBold(m_hHKCU,m_bUseBold);

	m_hHKLM = tc.InsertItem(_T("HKEY_LOCAL_MACHINE"),2,2,m_hRoot);
	tc.InsertItem(FAKEDITEM,5,5,m_hHKLM,TVI_LAST);
	SetItemColor(m_hHKLM,theApp.m_clsMainFrm->m_crHKLMColors);
	SetItemBold(m_hHKLM,m_bUseBold);

	m_hHKU = tc.InsertItem(_T("HKEY_USERS"),2,2,m_hRoot);
	tc.InsertItem(FAKEDITEM,5,5,m_hHKU,TVI_LAST);
	SetItemColor(m_hHKU,theApp.m_clsMainFrm->m_crHKUColors);
	SetItemBold(m_hHKU,m_bUseBold);

	m_hHKCC = tc.InsertItem(_T("HKEY_CURRENT_CONFIG"),2,2,m_hRoot);
	tc.InsertItem(FAKEDITEM,5,5,m_hHKCC,TVI_LAST);
	SetItemColor(m_hHKCC,theApp.m_clsMainFrm->m_crHKCCColors);
	SetItemBold(m_hHKCC,m_bUseBold);

	m_ntReg.LookupSID(m_csSID);
	m_csSID.Insert(0,_T("\\Registry\\User\\"));

	tc.Expand(m_hRoot,TVE_EXPAND);

	tc.SetRedraw(TRUE);
}

int CNtRegEditTreeView::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CView::OnCreate(lpCreateStruct) == -1) {
		return -1;
	}
	
	// Set tree control styles
	long style = GetWindowLong(this->m_hWnd,GWL_STYLE);
	style |= (TVS_HASLINES|TVS_LINESATROOT|TVS_HASBUTTONS|TVS_SHOWSELALWAYS|TVS_EDITLABELS);
	SetWindowLong(this->m_hWnd,GWL_STYLE,style);

	return 0;
}

///////////////////////////////////////////////////////////////////////////////
BOOL CNtRegEditTreeView::PreTranslateMessage(MSG* pMsg)
{
	//
	if (pMsg->message == WM_KEYDOWN) {
		//
		if (pMsg->wParam == VK_ESCAPE) {
			//
			CEdit* edit = GetTreeCtrl().GetEditControl();
			if (edit) {
				//
				pMsg->wParam = VK_RETURN;
				edit->SetWindowTextA(m_csBeforeEditLable);
				edit->SendMessage(WM_KEYDOWN, pMsg->wParam, pMsg->lParam);
				return TRUE;
			}
		}
		//else if (pMsg->wParam == VK_RETURN) {
		//}
	}

	return CTreeView::PreTranslateMessage(pMsg);
}


void CNtRegEditTreeView::OnSize(UINT nType, int cx, int cy)
{
	CView::OnSize(nType, cx, cy);
}

////////////////////////////////////////////

void CNtRegEditTreeView::SelectRootItem(void)
{
	CTreeCtrl& tc = GetTreeCtrl();
	tc.SelectItem(m_hRoot);
	m_hItem = m_hRoot;
	CurrentSubKeyRefresh();
}

void CNtRegEditTreeView::LoadTreeView(HKEY hKey, CString csFullKey, HTREEITEM hItem)
{
	//
	if (hItem == m_hRoot) {
		return;
	}

	if (!m_bRootKeySet) {
		m_ntReg.SetRootKey(hKey);
		m_bRootKeySet = TRUE;
	}

	CTreeCtrl& tc = GetTreeCtrl();
	//
	COLORREF crTextColor;
	if (hKey == HKCR) {
		crTextColor = theApp.m_clsMainFrm->m_crHKCRColors;
	}
	else if (hKey == HKCU) {
		crTextColor = theApp.m_clsMainFrm->m_crHKCUColors;
	}
	else if (hKey == HKLM) {
		crTextColor = theApp.m_clsMainFrm->m_crHKLMColors;
	}
	else if (hKey == HKU) {
		crTextColor = theApp.m_clsMainFrm->m_crHKUColors;
	}
	else {
		crTextColor = theApp.m_clsMainFrm->m_crHKCCColors;
	}

	// Set the key so we can go through the subkeys
	if (m_ntReg.SetKey(csFullKey,FALSE,TRUE)) {
		// Holds the subkeys of the current key
		CStringArray csaKeys;

		if (hItem == NULL) {
			hItem = m_hRoot;
		}

		BOOL bOk = FALSE;
		m_ntReg.GetSubKeyList(csaKeys);
		for (int n=0; n<csaKeys.GetSize(); n++) {
			//
			CString csKey(csFullKey);
			csKey += _T("\\");
			csKey += csaKeys.GetAt(n);

			bOk = m_ntReg.SetKey(csKey,FALSE,TRUE);

			int nIcon = 5;
			if (m_ntReg.m_bHidden) { nIcon = 0; }

			HTREEITEM hNewItem = tc.InsertItem(csaKeys.GetAt(n),nIcon,nIcon,hItem);
			SetItemColor(hNewItem,crTextColor);
			if (m_ntReg.m_bHidden && theApp.m_clsMainFrm->m_bBoldHidden) {
				SetItemBold(hNewItem,TRUE); 
			}

			if (bOk && m_ntReg.GetSubKeyCount() > 0) {
				tc.InsertItem(FAKEDITEM,5,5,hNewItem,TVI_LAST);
			}
			tc.SortChildren(hNewItem);
		}
	}
}

void CNtRegEditTreeView::OnTvnItemexpanding(NMHDR *pNMHDR, LRESULT *pResult)
{
	//
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	UINT uiAction = pNMTreeView->action;

	HTREEITEM hItem = pNMTreeView->itemNew.hItem;

	if (hItem == m_hRoot) {
		*pResult = 0;
		return;
	}

	CTreeCtrl &tc=GetTreeCtrl();

	if (uiAction==TVE_EXPAND) // is being expanded
	{
		tc.SetItemImage(hItem,6,6);
		
		HTREEITEM hChildItem = tc.GetChildItem(hItem);
		if (hChildItem)
		{
			CString csChildName = tc.GetItemText(hChildItem);
			if ( csChildName.CompareNoCase(FAKEDITEM)==0  ) // there is 
			{
				// remove this child
				tc.DeleteItem(hChildItem);
				
				if (hItem && tc.GetParentItem(hItem))
				{

					LockWindowUpdate(); // CWnd member

					SetCursor(LoadCursor(NULL, IDC_WAIT)); // hourglass

					//CPoint pt;
					//GetCursorPos(&pt);

					//CPoint MousePosition = pt;
					//tc.ScreenToClient ( &MousePosition );

					//TVHITTESTINFO HitInfo;
					//HitInfo.pt = MousePosition;

					//m_hItem = tc.HitTest(&HitInfo);
					m_hItem = hItem;
					CString csKeyPath = GetTreePath(m_hItem);

					CString csKey(csKeyPath);
					CString csRoot = m_ntReg.GetRootPath();
					csKey = csKeyPath.Right((csKeyPath.GetLength() - csRoot.GetLength()) - 1);

					HKEY hKey=NULL;
					CString csKey1;
					if (csRoot == m_csSID)
					{
						csKey1 = _T("HKEY_CURRENT_USER\\");
						hKey = HKEY_CURRENT_USER;
					}
					else if (csRoot == _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current"))
					{
						csKey1 = _T("HKEY_CURRENT_CONFIG\\");
						hKey = HKEY_CURRENT_CONFIG;
					}
					else if (csRoot == _T("\\Registry\\Machine\\Software\\Classes"))
					{
						csKey1 = _T("HKEY_CLASSES_ROOT\\");
						hKey = HKEY_CLASSES_ROOT;
					}
					else if (csRoot == _T("\\Registry\\Machine"))
					{
						csKey1 = _T("HKEY_LOCAL_MACHINE\\");
						hKey = HKEY_LOCAL_MACHINE;
					}
					else if (csRoot == _T("\\Registry\\User"))
					{
						csKey1 = _T("HKEY_USERS\\");
						hKey = HKEY_USERS;
					}

					if (csKeyPath != _T(""))
					{
						LoadTreeView(hKey, csKeyPath, m_hItem);
						tc.SortChildren(m_hItem);
						tc.Expand(m_hItem, TVE_EXPAND);
						tc.SelectItem(m_hItem);
					}

					SetCursor(LoadCursor (NULL, IDC_ARROW)); // back to normal cursor

					UnlockWindowUpdate();  // CWnd member
				}
			}
		}
	}
	else {
		tc.SetItemImage(hItem,5,5);
	}

	// Make sure we have the "Clicked" on path
	CString csKeyPath = GetTreePath(hItem);
	m_ntReg.SetKey(csKeyPath,FALSE,TRUE);

	*pResult = 0;
}


void CNtRegEditTreeView::OnRclick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CTreeCtrl &tc=GetTreeCtrl();

	CPoint pt;
	GetCursorPos(&pt);

	CPoint MousePosition = pt;
	tc.ScreenToClient ( &MousePosition );

	TVHITTESTINFO HitInfo;
	HitInfo.pt = MousePosition;

	int Mask = TVHT_ONITEM | TVHT_ONITEMRIGHT;
	
	m_hItem = tc.HitTest(&HitInfo);

	theApp.m_clsMainFrm->m_bKeyPressed = TRUE;
	theApp.m_clsMainFrm->m_bValuePressed = FALSE;

	CurrentSubKeyRefresh();

	if (m_hItem != NULL) {
		//
		theApp.m_clsMainFrm->m_bKeyPressed = TRUE;
		theApp.m_clsMainFrm->m_bValuePressed = FALSE;

		CMenu menu; 
		VERIFY(menu.LoadMenu(IDR_MAINFRAME));
		CMenu* pPopup = menu.GetSubMenu(1); 
		ASSERT(pPopup != NULL); 
		pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, pt.x, pt.y, AfxGetMainWnd());
		pPopup->Detach();
	}
	else {
		theApp.m_clsMainFrm->m_bKeyPressed = FALSE;
		theApp.m_clsMainFrm->m_bValuePressed = FALSE;
	}

	*pResult = 0;
}

void CNtRegEditTreeView::OnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	//CTreeCtrl &tc=GetTreeCtrl();

	//CPoint pt;
	//GetCursorPos(&pt);

	//CPoint MousePosition = pt;
	//tc.ScreenToClient ( &MousePosition );

	//TVHITTESTINFO HitInfo;
	//HitInfo.pt = MousePosition;

	//int Mask = TVHT_ONITEM | TVHT_ONITEMRIGHT;
	//
	//m_hItem = tc.HitTest(&HitInfo);

	//theApp.m_clsMainFrm->m_bKeyPressed = TRUE;
	//theApp.m_clsMainFrm->m_bValuePressed = FALSE;

	//CurrentSubKeyRefresh();

	*pResult = 0;
}

void CNtRegEditTreeView::CurrentSubKeyRefresh(void)
{
	CTreeCtrl &tc=GetTreeCtrl();

	CString csKeyPath = GetTreePath(m_hItem);

	if (csKeyPath != _T("")) {
		//
		if (csKeyPath == _T("CNtRegistry")) {
			theApp.m_clsLV->m_xList.DeleteAllItems();
			return;
		}

		CString csRoot = _T("");
		CString csKey1 = _T("");

		HKEY hKey = m_ntReg.GetRootKey();
		if (hKey == HKCC) {
			csRoot = _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current");
			m_csKeyPath = _T("HKCC\\");
		}
		else if (hKey == HKCR) {
			csRoot = _T("\\Registry\\Machine\\Software\\Classes");
			m_csKeyPath = _T("HKCR\\");
		}
		else if (hKey == HKLM) {
			csRoot = _T("\\Registry\\Machine");
			m_csKeyPath = _T("HKLM\\");
		}
		else if (hKey == HKU) {
			csRoot = _T("\\Registry\\User");
			m_csKeyPath = _T("HKU\\");
		}
		else {
			csRoot = m_csSID;
			m_csKeyPath = _T("HKCU\\");
		}

		CString csKey = csKeyPath.Right((csKeyPath.GetLength() - csRoot.GetLength()) - 1);

		// This means we are at one of the HKEY_... keys
		//if (csKey == _T("")) {
		//	theApp.m_clsLV->m_xList.DeleteAllItems();
		//	return;
		//}

		//
		m_csKeyPath += csKey;
		theApp.m_clsMainFrm->m_wndStatusBar.SetPaneText(1,m_csKeyPath);

		//CString csAcct,csDomain,csDomainAcct;
		//m_ntReg.GetObjAcctDomainInfo(SE_REGISTRY_KEY,csKeyPath,csAcct,csDomain);
		//csDomainAcct.Format("%s\\%s",csDomain,csAcct);
		//theApp.m_clsMainFrm->m_wndStatusBar.SetPaneText(2,csDomainAcct);

		//
		if (m_ntReg.SetKey(csKeyPath,FALSE,TRUE)) {
			//
			ShowValues();
			//
			if (IsExpanded(m_hItem) && m_ntReg.m_bHidden) {
				tc.SetItemImage(m_hItem,0,0);
			}
			else if (m_ntReg.m_bHidden) {
				tc.SetItemImage(m_hItem,0,0);
			}
			else if (IsExpanded(m_hItem)) {
				tc.SetItemImage(m_hItem,6,6);
			}
			else {
				tc.SetItemImage(m_hItem,5,5);
			}
		}
	}
}

CString CNtRegEditTreeView::GetTreePath(HTREEITEM hItem)
{
	CTreeCtrl &tc = GetTreeCtrl();

	CString csReturn(tc.GetItemText(hItem));

	if (csReturn == _T("CNtRegistry")) {
		return csReturn;
	}

	CString csRoots = _T("");
	if (csReturn == _T("HKEY_CLASSES_ROOT")) {
		m_ntReg.SetRootKey(HKCR);
	}
	else if (csReturn == _T("HKEY_CURRENT_USER")) {
		m_ntReg.SetRootKey(HKCU);
	}
	else if (csReturn == _T("HKEY_LOCAL_MACHINE")) {
		m_ntReg.SetRootKey(HKLM);
	}
	else if (csReturn == _T("HKEY_USERS")) {
		m_ntReg.SetRootKey(HKU);
	}
	else if (csReturn == _T("HKEY_CURRENT_CONFIG")) {
		m_ntReg.SetRootKey(HKCC);
	}

	csRoots = m_ntReg.GetRootPath();
	if (csReturn.Left(5) == _T("HKEY_")) {
		return csRoots;
	}

	// Ok, we have a real path...
	HTREEITEM hParent = tc.GetParentItem(hItem);
	for (;;)
	{
		CString csParent = tc.GetItemText(hParent);
		if (csParent.Left(5) == _T("HKEY_")) {
			csReturn.Insert(0,_T("\\"));
			csReturn.Insert(0,csRoots);
			break;
		}
		else {
			csReturn.Insert(0,_T("\\"));
			csReturn.Insert(0,csParent);
		}
		HTREEITEM hNewParent = tc.GetParentItem(hParent);
		hParent = hNewParent;
		if (hParent == NULL) {
			break;
		}
	}

	return csReturn;
}


BOOL CNtRegEditTreeView::IsExpanded(HTREEITEM hItem)
{
	BOOL bResult = FALSE;
	CTreeCtrl &tc=GetTreeCtrl();

	TVITEM dragItem;
	dragItem.mask=TVIF_HANDLE | TVIF_STATE;
	dragItem.hItem=hItem;
	dragItem.pszText=NULL;
	if (tc.GetItem(&dragItem)) {
		bResult=dragItem.state & TVIS_EXPANDED;
	}
	return bResult;
}

//BOOL CNtRegEditTreeView::IsItemExpanded(HTREEITEM hItem)
//{
//	CTreeCtrl &tc = GetTreeCtrl();
//	return (BOOL)tc.GetItemState(hItem, TVIS_EXPANDED) & TVIS_EXPANDED;
//}

void CNtRegEditTreeView::TraverseTree(CString csKeyPath)
{
	CTreeCtrl &tc = GetTreeCtrl();

	HTREEITEM hRoot = tc.GetRootItem();
	HTREEITEM hItem = NULL;

	CString csSID = _T("");
	m_ntReg.LookupSID(csSID);

	CString csRootPath = _T("");
	csRootPath.Format(_T("\\Registry\\User\\%s"), csSID);

	HKEY hKey=NULL;
	CString csRootKey = _T("");
	if (csKeyPath.Left(csRootPath.GetLength()) == csRootPath) {
		hKey = HKEY_CURRENT_USER;
		hItem = m_hHKCU;
	}
	else if (csKeyPath.Left(14) == _T("\\Registry\\User")) {
		csRootPath = _T("\\Registry\\User");
		hKey = HKEY_USERS;
		hItem = m_hHKU;
	}
	else if (csKeyPath.Left(68) == _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current")) {
		csRootPath = _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current");
		hKey = HKEY_CURRENT_CONFIG;
		hItem = m_hHKCC;
	}
	else if (csKeyPath.Left(34) == _T("\\Registry\\Machine\\SOFTWARE\\Classes")) {
		csRootPath = _T("\\Registry\\Machine\\SOFTWARE\\Classes");
		hKey = HKEY_CLASSES_ROOT;
		hItem = theApp.m_clsTV->m_hHKCR;
	}
	else if (csKeyPath.Left(17) == _T("\\Registry\\Machine")) {
		csRootPath = _T("\\Registry\\Machine");
		hKey = HKEY_LOCAL_MACHINE;
		hItem = theApp.m_clsTV->m_hHKLM;
	}

	if (csKeyPath == csRootPath) {
		tc.Expand(hRoot, TVE_EXPAND);
		tc.EnsureVisible(hRoot);
		tc.SelectItem(hRoot);
		return;
	}

	CString csPath = _T("");
	if (csKeyPath.GetLength() > csRootPath.GetLength()) {
		csPath = csKeyPath.Mid(csRootPath.GetLength()+1);
	}
	else {
		csPath = csKeyPath;
	}

	tc.SetRedraw(FALSE);

	tc.Expand(hRoot, TVE_EXPAND);

	CTokenEx tok;
	tok.Split(csPath,_T("\\"));

	hItem = OpenSubKeyItem(hItem, csRootPath, tok.m_csaAddIt.GetAt(0));
	for (int n=0; n<tok.m_csaAddIt.GetSize()-1; n++) {
		csRootPath += _T("\\");
		csRootPath += tok.m_csaAddIt.GetAt(n);
		hItem = OpenSubKeyItem(hItem, csRootPath, tok.m_csaAddIt.GetAt(n+1));

		tc.EnsureVisible(hItem);
		tc.SelectItem(hItem);
		theApp.m_clsMainFrm->OnKeysRefresh();
	}
	tc.SetRedraw(TRUE);
}

HTREEITEM CNtRegEditTreeView::OpenSubKeyItem(HTREEITEM hItem, CString csSubKey, CString csLook4)
{
	CTreeCtrl &tc = GetTreeCtrl();
	HTREEITEM hReturnItem = NULL;
	tc.SetItemImage(hItem,6,6);

	HTREEITEM hParent = tc.GetParentItem(hItem);

	COLORREF crTextColor;
	if (hParent == tc.GetRootItem()) {
		crTextColor = theApp.m_clsTV->GetItemColor(hItem);
	}
	else {
		crTextColor = theApp.m_clsTV->GetItemColor(hParent);
	}


	CString csName = tc.GetItemText(hItem);
	HTREEITEM hChildItem = tc.GetChildItem(hItem);
	if (hChildItem) {
		//
		CString csChildName = tc.GetItemText(hChildItem);
		if ( csChildName.CompareNoCase(FAKEDITEM)==0  ) {
			//
			// there is 
			//
			// remove this child
			tc.DeleteItem(hChildItem);
			
			if (hItem && tc.GetParentItem(hItem))
			{
				LockWindowUpdate(); // CWnd member

				SetCursor(LoadCursor(NULL, IDC_WAIT)); // hourglass

				//
				if (m_ntReg.SetKey(csSubKey,FALSE,TRUE)) {
					//
					CStringArray csaKeys;

					BOOL bOk = FALSE;
					m_ntReg.GetSubKeyList(csaKeys);
					for (int n=0; n<csaKeys.GetSize(); n++) {
						//
						CString csKey(csSubKey);
						csKey += _T("\\");
						csKey += csaKeys.GetAt(n);

						bOk = m_ntReg.SetKey(csKey,FALSE,TRUE);

						int nIcon = 5;
						if (m_ntReg.m_bHidden) { nIcon = 0; }

						HTREEITEM hNewItem = tc.InsertItem(csaKeys.GetAt(n),nIcon,nIcon,hItem);
						theApp.m_clsTV->SetItemColor(hNewItem,crTextColor);
						if (csLook4 == csaKeys.GetAt(n)) {
							hReturnItem = hNewItem;
						}
						if (bOk && m_ntReg.GetSubKeyCount() > 0) {
							tc.InsertItem(FAKEDITEM,5,5,hNewItem,TVI_LAST);
						}
					}
					tc.SortChildren(hItem);
					tc.Expand(hItem, TVE_EXPAND);
					tc.SelectItem(hItem);
					theApp.m_clsMainFrm->OnKeysRefresh();
				}
				SetCursor(LoadCursor (NULL, IDC_ARROW)); // back to normal cursor

				UnlockWindowUpdate();  // CWnd member
			}
		}
		else {
			//
			if (csLook4 == csChildName) {
				hReturnItem = hItem;
			}
			else {
				// The SubKey is already EXPANDED
				HTREEITEM hSibling = tc.GetNextSiblingItem(hChildItem);
				// Go through all of siblings.
				while (hSibling != NULL) {
					//
					CString csSibling = tc.GetItemText(hSibling);
					if (csLook4 == csSibling) {
						hReturnItem = hSibling;
						break;
					}
					hSibling = tc.GetNextSiblingItem(hSibling);
				} // WHILE
			}
		}
	}

	return hReturnItem;
}

void CNtRegEditTreeView::ShowValues(void)
{
	CTreeCtrl &tc=GetTreeCtrl();

	theApp.m_clsLV->m_xList.DeleteAllItems();

	UINT uiLen=0;
	UCHAR* pValue = NULL;

	CStringArray csaValues;
	if (m_ntReg.GetValueList(csaValues))
	{
		COLORREF crItemColor = GetItemColor(tc.GetSelectedItem());
//		if (theApp.m_clsMainFrm->m_bUseTreeColors) {
//			crItemColor = GetItemColor(tc.GetSelectedItem());
//		}

		int i=0;
		int nImage=0;
		BOOL bDefaultUsed = FALSE;
		for (int n=0; n<csaValues.GetSize(); n++)
		{
//			crItemColor = RGB(0,0,0);

			nImage=8;
			int nSize = 0;
			DWORD dw = 0;
			CString csValueName = csaValues.GetAt(n);
			DWORD dwValueType = m_ntReg.GetValueInfo(csValueName, nSize);
			CString csValue = _T("ERR"), csValueType;

			switch(dwValueType)
			{
			case REG_SZ:
				csValueType = _T("REG_SZ");
				csValue = m_ntReg.ReadString(csValueName,_T("ERR"));
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crSZ;
				}
				nImage=7;
				break;
			case REG_EXPAND_SZ:
				csValueType = _T("REG_EXPAND_SZ");
				csValue = m_ntReg.ReadString(csValueName,_T("ERR"));
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crEXPAND_SZ;
				}
				nImage=12;
				break;
			case REG_MULTI_SZ:
				csValueType = _T("REG_MULTI_SZ");
				m_ntReg.ReadMultiString(csValueName,m_csaNewString);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crMULTI_SZ;
				}
				csValue = _T("");
				for (i=0; i<m_csaNewString.GetSize(); i++)
				{
					csValue += m_csaNewString.GetAt(i);
					csValue += _T(" ");
				}
				nImage=13;
				break;
			case REG_DWORD:
				csValueType = _T("REG_DWORD");
				dw = m_ntReg.ReadDword(csValueName,0);
				csValue.Format(_T("%u"), dw, dw);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crDWORD;
				}
				nImage=11;
				break;
			case REG_DWORD_BIG_ENDIAN:
				csValueType = _T("REG_DWORD_BIG_ENDIAN");
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crDWORD_BIG_ENDIAN;
				}
				nImage=11;
				break;
			case REG_QWORD:
				csValueType = _T("REG_QWORD");
				pValue = m_ntReg.ReadBinary(csValueName,uiLen);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crQWORD;
				}
				nImage=14;
				break;
			case REG_BINARY:
				csValueType = _T("REG_BINARY");
				pValue = m_ntReg.ReadBinary(csValueName,uiLen);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crBINARY;
				}
				break;
			case REG_LINK:
				csValueType = _T("REG_LINK");
				pValue = m_ntReg.ReadBinary(csValueName,uiLen);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crLINK;
				}
				break;
			case REG_RESOURCE_LIST:
				csValueType = _T("REG_RESOURCE_LIST");
				pValue = m_ntReg.ReadBinary(csValueName,uiLen);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crRESOURCE_LIST;
				}
				break;
			case REG_RESOURCE_REQUIREMENTS_LIST:
				csValueType = _T("REG_RESOURCE_REQUIREMENTS_LIST");
				pValue = m_ntReg.ReadBinary(csValueName,uiLen);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crRESOURCE_REQUIREMENTS_LIST;
				}
				break;
			case REG_FULL_RESOURCE_DESCRIPTOR:
				csValueType = _T("REG_FULL_RESOURCE_DESCRIPTOR");
				pValue = m_ntReg.ReadBinary(csValueName,uiLen);
				if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
					crItemColor = theApp.m_clsMainFrm->m_crFULL_RESOURCE_DESCRIPTOR;
				}
				break;
			case REG_NONE:
				csValueType = _T("REG_NONE");
				pValue = m_ntReg.ReadBinary(csValueName,uiLen);
				crItemColor = RGB(0,0,0);
				break;
			default:
				csValueType.Format(_T("REG_UNKNOWN (%u)"), dwValueType);
				csValue = _T("ERR");
				crItemColor = RGB(0,0,0);
				break;
			}

			if (csValueName == _T("")) {
				csValueName = _T("(Default)");
				bDefaultUsed = TRUE;
				//if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
				//	crItemColor = theApp.m_clsMainFrm->m_crSZ;
				//}
			}

			int nItem = theApp.m_clsLV->m_xList.InsertItem(theApp.m_clsLV->m_xList.GetItemCount(),csValueName,crItemColor,RGB(255,255,255));
			theApp.m_clsLV->m_xList.SetItemImage(nItem,0,nImage);
			theApp.m_clsLV->m_xList.SetItemText(nItem,1,csValueType);
			if (dwValueType == REG_BINARY || dwValueType == REG_QWORD ||
				dwValueType == REG_LINK ||
				dwValueType == REG_RESOURCE_LIST ||
				dwValueType == REG_RESOURCE_REQUIREMENTS_LIST ||
				dwValueType == REG_FULL_RESOURCE_DESCRIPTOR) {
				//
				csValue = _T("");
				CString csTmp = _T("");

				if (uiLen == 0) {
					csValue = _T("00 00 00 00");
				}
				else {
					//
					for (int n=0; n<(int)uiLen; n++) {
						csTmp.Format("%02x ",pValue[n]);
						csValue += csTmp;
					}
				}
				csValue.TrimRight(" ");
			}
			theApp.m_clsLV->m_xList.SetItemText(nItem,2,csValue);
		}

		if (!bDefaultUsed) {
			int nItem = 0;
			if (!theApp.m_clsMainFrm->m_bUseTreeColors) {
				nItem = theApp.m_clsLV->m_xList.InsertItem(0,_T("(Default)"),theApp.m_clsMainFrm->m_crSZ,RGB(255,255,255));
			}
			else {
				nItem = theApp.m_clsLV->m_xList.InsertItem(0,_T("(Default)"),GetItemColor(tc.GetSelectedItem()),RGB(255,255,255));
			}
			theApp.m_clsLV->m_xList.SetItemImage(nItem,0,7);
			theApp.m_clsLV->m_xList.SetItemText(nItem,1,_T("REG_SZ"));
			theApp.m_clsLV->m_xList.SetItemText(nItem,2,_T("(value not set)"));
		}
	}
}


void CNtRegEditTreeView::OnTvnKeydown(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVKEYDOWN pTVKeyDown = reinterpret_cast<LPNMTVKEYDOWN>(pNMHDR);

	CTreeCtrl &tc=GetTreeCtrl();

	switch (pTVKeyDown->wVKey)	
	{
		case VK_F5:
			theApp.m_clsMainFrm->OnKeysRefresh();
			break;
			
		case VK_DELETE:
			{
				if (m_ntReg.GetSubKeyCount() > 0) {
					theApp.m_clsMainFrm->OnRecursivelyKey();
				}
				else {
					theApp.m_clsMainFrm->OnDeleteKeyValue();
				}
			}
			break;

		case VK_RETURN:
			m_hItem = tc.GetSelectedItem();
			if (m_hItem != tc.GetRootItem() && m_hItem != NULL) {
				tc.Expand(m_hItem, TVE_EXPAND);
			}
			break;

	}
	*pResult = 0;
}

void CNtRegEditTreeView::OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	
	CTreeCtrl &tc=GetTreeCtrl();

	m_hItem = pNMTreeView->itemNew.hItem;
	if (m_hItem != tc.GetRootItem() && m_hItem != NULL) {
		theApp.m_clsMainFrm->m_bKeyPressed = TRUE;
		theApp.m_clsMainFrm->m_bValuePressed = FALSE;
		CurrentSubKeyRefresh();
	}
	*pResult = 0;
}

void CNtRegEditTreeView::OnTvnSelchanging(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);
	CTreeCtrl &tc=GetTreeCtrl();
	//
	if (m_bEditingItem) {
		tc.SetItemText(m_hBeforeEditItem, m_csBeforeEditLable);
	}
	*pResult = 0;
}

void CNtRegEditTreeView::OnTvnBeginlabeledit(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);

	CTreeCtrl &tc=GetTreeCtrl();
	m_hBeforeEditItem = pTVDispInfo->item.hItem;

	m_csBeforeEditLable = _T("");
	m_csFullPathOld = _T("");
	if (m_hBeforeEditItem != NULL && 
		m_hBeforeEditItem != tc.GetRootItem() && 
		tc.GetParentItem(m_hBeforeEditItem) != tc.GetRootItem()) 
	{
		m_csBeforeEditLable = tc.GetItemText(m_hBeforeEditItem);
		m_csFullPathOld = GetTreePath(m_hBeforeEditItem);
		m_bEditingItem = TRUE;
	}
	else {
		TreeView_EndEditLabelNow(tc.m_hWnd,TRUE);
		m_bEditingItem = FALSE;
	}
	*pResult = 0;
}

void CNtRegEditTreeView::OnTvnEndlabeledit(NMHDR *pNMHDR, LRESULT *pResult)
{
	LPNMTVDISPINFO pTVDispInfo = reinterpret_cast<LPNMTVDISPINFO>(pNMHDR);

	CTreeCtrl &tc=GetTreeCtrl();
	m_hAfterEditItem = pTVDispInfo->item.hItem;

	m_bEditingItem = FALSE;

	m_csAfterEditLable = _T("");
	if (m_hAfterEditItem != NULL && 
		m_hAfterEditItem != tc.GetRootItem() && 
		tc.GetParentItem(m_hAfterEditItem) != tc.GetRootItem()) 
	{
		if (m_hAfterEditItem == m_hBeforeEditItem) 
		{
			m_csAfterEditLable = pTVDispInfo->item.pszText;
			if (m_csBeforeEditLable.CompareNoCase(m_csAfterEditLable) != 0) 
			{
				if (m_ntReg.RenameKey(m_csFullPathOld, m_csAfterEditLable)) {
					tc.SetItemText(m_hAfterEditItem, m_csAfterEditLable);
				}
				else {
					tc.SetItemText(m_hAfterEditItem, m_csBeforeEditLable);
				}
			}
		}
	}
	*pResult = 0;
}






//////////////////////////////////////////////////////////////////////
void CNtRegEditTreeView::SetItemFont(HTREEITEM hItem, LOGFONT& logfont)
{
	Color_Font cf;
	if( !m_mapColorFont.Lookup( hItem, cf ) )
		cf.color = (COLORREF)-1;
	cf.logfont = logfont;
	m_mapColorFont[hItem] = cf;
}

//////////////////////////////////////////////////////////////////////
void CNtRegEditTreeView::SetItemBold(HTREEITEM hItem, BOOL bBold)
{
	CTreeCtrl &tc=GetTreeCtrl();
	tc.SetItemState(hItem, bBold ? TVIS_BOLD : 0, TVIS_BOLD);
}

//////////////////////////////////////////////////////////////////////
void CNtRegEditTreeView::SetItemColor(HTREEITEM hItem, COLORREF color)
{
	Color_Font cf;
	if(!m_mapColorFont.Lookup(hItem, cf))
		cf.logfont.lfFaceName[0] = '\0';
	cf.color = color;
	m_mapColorFont[hItem] = cf;
}

//////////////////////////////////////////////////////////////////////
BOOL CNtRegEditTreeView::GetItemFont(HTREEITEM hItem, LOGFONT * plogfont)
{
	Color_Font cf;
	if(!m_mapColorFont.Lookup(hItem, cf))
		return FALSE;
	if(cf.logfont.lfFaceName[0] == '\0') 
		return FALSE;
	*plogfont = cf.logfont;
	return TRUE;

}

//////////////////////////////////////////////////////////////////////
BOOL CNtRegEditTreeView::GetItemBold(HTREEITEM hItem)
{
	CTreeCtrl &tc=GetTreeCtrl();
	return tc.GetItemState(hItem, TVIS_BOLD) & TVIS_BOLD;
}

//////////////////////////////////////////////////////////////////////
COLORREF CNtRegEditTreeView::GetItemColor(HTREEITEM hItem)
{
	// Returns (COLORREF)-1 if color was not set
	Color_Font cf;
	if(!m_mapColorFont.Lookup(hItem, cf))
		return (COLORREF) - 1;
	return cf.color;

}

//////////////////////////////////////////////////////////////////////
void CNtRegEditTreeView::OnPaint()
{
	CPaintDC dc(this); // device context for painting

	// Create a memory DC compatible with the paint DC
	CDC memDC;
	memDC.CreateCompatibleDC(&dc);

	CRect rcClip, rcClient;
	dc.GetClipBox( &rcClip );
	GetClientRect(&rcClient);

	// Select a compatible bitmap into the memory DC
	CBitmap bitmap;
	bitmap.CreateCompatibleBitmap( &dc, rcClient.Width(), rcClient.Height() );
	memDC.SelectObject( &bitmap );
	
	// Set clip region to be same as that in paint DC
	CRgn rgn;
	rgn.CreateRectRgnIndirect( &rcClip );
	memDC.SelectClipRgn(&rgn);
	rgn.DeleteObject();
	
	// First let the control do its default drawing.
	CWnd::DefWindowProc(WM_PAINT, (WPARAM)memDC.m_hDC, 0);

	CTreeCtrl &tc=GetTreeCtrl();
	HTREEITEM hItem = tc.GetFirstVisibleItem();

	int iItemCount = tc.GetVisibleCount() + 1;
	while(hItem && iItemCount--)
	{		
		CRect rect;

		// Do not meddle with selected items or drop highlighted items
		UINT selflag = TVIS_DROPHILITED | TVIS_SELECTED;
		Color_Font cf;
	
		//if ( !(GetTreeCtrl().GetItemState( hItem, selflag ) & selflag ) 
		//	&& m_mapColorFont.Lookup( hItem, cf ))
		
		if ((tc.GetItemState(hItem, selflag) & selflag) 
			&& ::GetFocus() == m_hWnd)
			;
		else if (m_mapColorFont.Lookup(hItem, cf))
		{
			CFont *pFontDC;
			CFont fontDC;
			LOGFONT logfont;

			if(cf.logfont.lfFaceName[0] != '\0') 
				logfont = cf.logfont;
			else {
				// No font specified, so use window font
				CFont *pFont = GetFont();
				pFont->GetLogFont( &logfont );
			}

			if(GetItemBold(hItem))
				logfont.lfWeight = 700;

			fontDC.CreateFontIndirect(&logfont);
			pFontDC = memDC.SelectObject(&fontDC );

			if(cf.color != (COLORREF) - 1)
				memDC.SetTextColor(cf.color);
			else
				memDC.SetTextColor(GetSysColor(COLOR_WINDOWTEXT));


			CString sItem = tc.GetItemText(hItem);

			tc.GetItemRect(hItem, &rect, TRUE);
			memDC.SetBkColor( GetSysColor(COLOR_WINDOW));
			memDC.TextOut(rect.left + 2, rect.top + 1, sItem);
			
			memDC.SelectObject(pFontDC);
		}
		hItem = tc.GetNextVisibleItem(hItem);
	}


	dc.BitBlt(rcClip.left, rcClip.top, rcClip.Width(), rcClip.Height(), &memDC, 
				rcClip.left, rcClip.top, SRCCOPY);

	memDC.DeleteDC();
}
