#pragma once

#ifndef _NT_REG_TREEVIEW_H
#define _NT_REG_TREEVIEW_H

#include <afxcview.h>
#include <afxtempl.h>

#include "TreeCtrlEx.h"

#include "NtRegistry.h"
#include "TokenEx.h"

#define FAKEDITEM "faked item"

// CNtRegEditTreeView view
class CNtRegEditTreeView : public CTreeView
{
protected:
	CNtRegEditTreeView();           // protected constructor used by dynamic creation
	DECLARE_DYNCREATE(CNtRegEditTreeView)

	virtual ~CNtRegEditTreeView();

public:

	CNtRegistry m_ntReg;

	HTREEITEM	m_hRoot;
	HTREEITEM	m_hHKLM;
	HTREEITEM	m_hHKCU;
	HTREEITEM	m_hHKU;
	HTREEITEM	m_hHKCR;
	HTREEITEM	m_hHKCC;

	HTREEITEM	m_hItem;
	HTREEITEM	m_hBeforeEditItem;
	HTREEITEM	m_hAfterEditItem;

	BOOL		m_bEditingItem;

	CImageList  m_pImageTree;

	CStringArray	m_csaNewString;

	CString		m_csSID;
	BOOL		m_bRootKeySet;

	BOOL		m_bUseBold;
	BOOL		m_bUseBoldHidden;

	CString		m_csKeyPath;

	CString		m_csBeforeEditLable;
	CString		m_csAfterEditLable;
	CString		m_csFullPathOld;

	COLORREF	m_cr3DFace;
	COLORREF	m_cr3DHighLight;
	COLORREF	m_cr3DShadow;
	COLORREF	m_crBtnFace;
	COLORREF	m_crBtnShadow;
	COLORREF	m_crBtnText;
	COLORREF	m_crGrayText;
	COLORREF	m_crHighLight;
	COLORREF	m_crHighLightText;
	COLORREF	m_crWindow;
	COLORREF	m_crWindowText;

	COLORREF 	m_crColorWhite;
	COLORREF 	m_crColorBlack;
	COLORREF 	m_crColorBlue;
	COLORREF 	m_crColorGreen;
	COLORREF 	m_crColorLRed;
	COLORREF 	m_crColorBrown;
	COLORREF 	m_crColorPurple;
	COLORREF 	m_crColorOrange;
	COLORREF 	m_crColorYellow;
	COLORREF 	m_crColorLGreen;
	COLORREF 	m_crColorCyan;
	COLORREF	m_crColorLCyan;
	COLORREF 	m_crColorLBlue;
	COLORREF 	m_crColorPink;
	COLORREF 	m_crColorGrey;
	COLORREF 	m_crColorLLGrey;
	COLORREF 	m_crColorLGrey;

	CEdit		m_EditCtrl;

//////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////

	CString	GetTreePath(HTREEITEM hItem);
	void	InitTree(void);
	void	LoadTreeView (HKEY hKey, CString csFullKey, HTREEITEM hItem);
	void	ShowValues(void);
	BOOL	IsExpanded(HTREEITEM hItem);
	void	CurrentSubKeyRefresh(void);
	void	SelectRootItem(void);

	void	TraverseTree(CString csPathName);
	HTREEITEM OpenSubKeyItem(HTREEITEM hItem, CString csSubKey, CString csLook4);


	void			SetItemFont(HTREEITEM, LOGFONT&);
	void			SetItemBold(HTREEITEM, BOOL);
	void			SetItemColor(HTREEITEM, COLORREF);
	BOOL			GetItemFont(HTREEITEM, LOGFONT *);
	BOOL			GetItemBold(HTREEITEM);
	COLORREF		GetItemColor(HTREEITEM);


public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
	virtual void OnInitialUpdate();


#ifdef _DEBUG
	virtual void AssertValid() const;
#ifndef _WIN32_WCE
	virtual void Dump(CDumpContext& dc) const;
#endif
#endif

protected:

	struct Color_Font {
		COLORREF color;
		LOGFONT  logfont;
	};

	CMap <void*, void*, Color_Font, Color_Font&> m_mapColorFont;

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	afx_msg void OnClick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnRclick(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnTvnItemexpanding(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnKeydown(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnSelchanged(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnBeginlabeledit(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnTvnEndlabeledit(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnPaint();
public:
	afx_msg void OnTvnSelchanging(NMHDR *pNMHDR, LRESULT *pResult);
};

#endif // _NT_REG_TREEVIEW_H

