// NtRegKeysDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "NtRegKeysDlg.h"


// CNtRegKeysDlg dialog
IMPLEMENT_DYNAMIC(CNtRegKeysDlg, CDialog)

CNtRegKeysDlg::CNtRegKeysDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CNtRegKeysDlg::IDD, pParent)
{

}

CNtRegKeysDlg::~CNtRegKeysDlg()
{
	m_hKey = NULL;
}

void CNtRegKeysDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, TC_KEYS, m_tcRegKeys);
}


BEGIN_MESSAGE_MAP(CNtRegKeysDlg, CDialog)
	ON_NOTIFY(NM_CLICK, TC_KEYS, OnClickRegKeys)
	ON_NOTIFY(TVN_ITEMEXPANDING, TC_KEYS, OnItemexpandingRegKeys)
#if _MSC_VER >= 1400
	ON_BN_CLICKED(IDOK, &CNtRegKeysDlg::OnBnClickedOk)
#else
	ON_BN_CLICKED(IDOK, CNtRegKeysDlg::OnBnClickedOk)
#endif
END_MESSAGE_MAP()


// CNtRegKeysDlg message handlers
BOOL CNtRegKeysDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Create the image list that is attached to the tree control
	// Loadup the image list
	VERIFY(m_pImageTree.Create(IDB_ICONS, 16, 1, RGB(255,0,255)));

	//Hook it up to the tree control
	m_tcRegKeys.SetImageList(&m_pImageTree, TVSIL_NORMAL);

	m_hRoot = m_tcRegKeys.InsertItem(_T("CNtRegistry"),0,0);
	m_hHKCR = m_tcRegKeys.InsertItem(_T("HKEY_CLASSES_ROOT"),2,2,m_hRoot);
	m_tcRegKeys.InsertItem(FAKEDITEM,5,5,m_hHKCR,TVI_LAST);

	m_hHKCU = m_tcRegKeys.InsertItem(_T("HKEY_CURRENT_USER"),2,2,m_hRoot);
	m_tcRegKeys.InsertItem(FAKEDITEM,5,5,m_hHKCU,TVI_LAST);

	m_hHKLM = m_tcRegKeys.InsertItem(_T("HKEY_LOCAL_MACHINE"),2,2,m_hRoot);
	m_tcRegKeys.InsertItem(FAKEDITEM,5,5,m_hHKLM,TVI_LAST);

	m_hHKU = m_tcRegKeys.InsertItem(_T("HKEY_USERS"),2,2,m_hRoot);
	m_tcRegKeys.InsertItem(FAKEDITEM,5,5,m_hHKU,TVI_LAST);

	m_hHKCC = m_tcRegKeys.InsertItem(_T("HKEY_CURRENT_CONFIG"),2,2,m_hRoot);
	m_tcRegKeys.InsertItem(FAKEDITEM,5,5,m_hHKCC,TVI_LAST);

	m_ntReg.LookupSID(m_csSID);
	m_csSID.Insert(0,_T("\\Registry\\User\\"));

	m_tcRegKeys.Expand(m_hRoot,TVE_EXPAND);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CNtRegKeysDlg::OnClickRegKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CPoint pt;
	GetCursorPos(&pt);

	CPoint MousePosition = pt;
	m_tcRegKeys.ScreenToClient ( &MousePosition );

	TVHITTESTINFO HitInfo;
	HitInfo.pt = MousePosition;

	m_hItem = m_tcRegKeys.HitTest(&HitInfo);

	CurrentSubKeyRefresh();

	*pResult = 0;
}

//void CNtRegKeysDlg::OnSelchangedRegKeys(NMHDR* pNMHDR, LRESULT* pResult) 
//{
//	OnClickRegKeys(pNMHDR, pResult);
//	*pResult = 0;
//}


void CNtRegKeysDlg::LoadTreeView (HKEY hKey, CString csFullKey, HTREEITEM hItem)
{
	//
	if (hItem == m_hRoot) {
		return;
	}

	//
	if (hItem == m_hHKCR) {
		csFullKey = m_ntReg.GetRootPathFor(HKCR);
	}
	else if (hItem == m_hHKCU) {
		csFullKey = m_ntReg.GetRootPathFor(HKCU);
	}
	else if (hItem == m_hHKLM) {
		csFullKey = m_ntReg.GetRootPathFor(HKLM);
	}
	else if (hItem == m_hHKU) {
		csFullKey = m_ntReg.GetRootPathFor(HKU);
	}
	else if (hItem == m_hHKCC) {
		csFullKey = m_ntReg.GetRootPathFor(HKCC);
	}

	//
	if (m_ntReg.SetKey(csFullKey,FALSE,TRUE)) {
		//
		CStringArray csaKeys;

		if (hItem == NULL) {
			hItem = m_hRoot;
		}

		BOOL bOk = FALSE;
		m_ntReg.GetSubKeyList(csaKeys);
		for (int n=0; n<csaKeys.GetSize(); n++) {
			//
			CString csKey(csFullKey);
			csKey += _T("\\");
			csKey += csaKeys.GetAt(n);

			bOk = m_ntReg.SetKey(csKey,FALSE,TRUE);

			int nIcon = 5;
			if (m_ntReg.m_bHidden) { nIcon = 0; }

			HTREEITEM hNewItem = m_tcRegKeys.InsertItem(csaKeys.GetAt(n),nIcon,nIcon,hItem);
			if (bOk && m_ntReg.GetSubKeyCount() > 0) {
				m_tcRegKeys.InsertItem(FAKEDITEM,5,5,hNewItem,TVI_LAST);
			}
			m_tcRegKeys.SortChildren(hNewItem);
		}
	}
}

void CNtRegKeysDlg::OnItemexpandingRegKeys(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LPNMTREEVIEW pNMTreeView = reinterpret_cast<LPNMTREEVIEW>(pNMHDR);

	UINT uiAction = pNMTreeView->action;

	HTREEITEM hItem = pNMTreeView->itemNew.hItem;

	if (hItem == m_hRoot) {
		*pResult = 0;
		return;
	}

	if (uiAction==TVE_EXPAND) // is being expanded
	{
		m_tcRegKeys.SetItemImage(hItem,6,6);
		
		HTREEITEM hChildItem = m_tcRegKeys.GetChildItem(hItem);
		if (hChildItem)
		{
			CString csChildName = m_tcRegKeys.GetItemText(hChildItem);
			if ( csChildName.CompareNoCase(FAKEDITEM)==0  ) // there is 
			{
				// remove this child
				m_tcRegKeys.DeleteItem(hChildItem);
				
				if (hItem && m_tcRegKeys.GetParentItem(hItem))
				{

					LockWindowUpdate(); // CWnd member

					SetCursor(LoadCursor(NULL, IDC_WAIT)); // hourglass

					CPoint pt;
					GetCursorPos(&pt);

					CPoint MousePosition = pt;
					m_tcRegKeys.ScreenToClient ( &MousePosition );

					TVHITTESTINFO HitInfo;
					HitInfo.pt = MousePosition;

					m_hItem = m_tcRegKeys.HitTest(&HitInfo);
					CString csKeyPath = GetTreePath(m_hItem);

					CString csKey(csKeyPath);
					CString csRoot = m_ntReg.GetRootPath();
					csKey = csKeyPath.Mid(csRoot.GetLength()+1);

					HKEY hKey=NULL;
					CString csKey1;
					if (csRoot == m_csSID) {
						hKey = HKEY_CURRENT_USER;
					}
					else if (csRoot == _T("\\Registry\\Machine\\System\\CurrentControlSet\\Hardware Profiles\\Current")) {
						hKey = HKEY_CURRENT_CONFIG;
					}
					else if (csRoot == _T("\\Registry\\Machine\\Software\\Classes")) {
						hKey = HKEY_CLASSES_ROOT;
					}
					else if (csRoot == _T("\\Registry\\Machine")) {
						hKey = HKEY_LOCAL_MACHINE;
					}
					else if (csRoot == _T("\\Registry\\User")) {
						hKey = HKEY_USERS;
					}

					if (csKeyPath != _T(""))
					{
						LoadTreeView(hKey, csKeyPath, m_hItem);
						m_tcRegKeys.SortChildren(m_hItem);
						m_tcRegKeys.Expand(m_hItem, TVE_EXPAND);
						m_tcRegKeys.SelectItem(m_hItem);
					}

					SetCursor(LoadCursor (NULL, IDC_ARROW)); // back to normal cursor

					UnlockWindowUpdate();  // CWnd member
				}
			}
		}
	}
	else {
		m_tcRegKeys.SetItemImage(hItem,5,5);
	}

	// Make sure we have the "Clicked" on path
	CString csKeyPath = GetTreePath(hItem);
	m_ntReg.SetKey(csKeyPath,FALSE,TRUE);

	*pResult = 0;
}

void CNtRegKeysDlg::CurrentSubKeyRefresh(void)
{
	CString csKeyPath = GetTreePath(m_hItem);

	if (csKeyPath != _T("")) {
		//
		if (csKeyPath == _T("CNtRegistry")) {
			return;
		}

		if (m_ntReg.SetKey(csKeyPath,FALSE,TRUE)) {
			//
			if (IsExpanded(m_hItem) && m_ntReg.m_bHidden) {
				m_tcRegKeys.SetItemImage(m_hItem,0,0);
			}
			else if (m_ntReg.m_bHidden) {
				m_tcRegKeys.SetItemImage(m_hItem,0,0);
			}
			else if (IsExpanded(m_hItem)) {
				m_tcRegKeys.SetItemImage(m_hItem,6,6);
			}
			else {
				m_tcRegKeys.SetItemImage(m_hItem,5,5);
			}
		}
	}
}

BOOL CNtRegKeysDlg::IsExpanded(HTREEITEM hItem)
{
	BOOL bResult = FALSE;

	TVITEM dragItem;
	dragItem.mask=TVIF_HANDLE | TVIF_STATE;
	dragItem.hItem=hItem;
	dragItem.pszText=NULL;
	if (m_tcRegKeys.GetItem(&dragItem)) {
		bResult=dragItem.state & TVIS_EXPANDED;
	}
	return bResult;
}

CString CNtRegKeysDlg::GetTreePath(HTREEITEM hItem)
{
	CString csReturn(m_tcRegKeys.GetItemText(hItem));

	if (csReturn == _T("CNtRegistry")) {
		return csReturn;
	}

	CString csRoots = _T("");
	if (csReturn == _T("HKEY_CLASSES_ROOT")) {
		m_ntReg.SetRootKey(HKCR);
	}
	else if (csReturn == _T("HKEY_CURRENT_USER")) {
		m_ntReg.SetRootKey(HKCU);
	}
	else if (csReturn == _T("HKEY_LOCAL_MACHINE")) {
		m_ntReg.SetRootKey(HKLM);
	}
	else if (csReturn == _T("HKEY_USERS")) {
		m_ntReg.SetRootKey(HKU);
	}
	else if (csReturn == _T("HKEY_CURRENT_CONFIG")) {
		m_ntReg.SetRootKey(HKCC);
	}

	csRoots = m_ntReg.GetRootPath();
	if (csReturn.Left(5) == _T("HKEY_")) {
		return csRoots;
	}

	// Ok, we have a real path...
	HTREEITEM hParent = m_tcRegKeys.GetParentItem(hItem);
	for (;;)
	{
		CString csParent = m_tcRegKeys.GetItemText(hParent);
		if (csParent.Left(5) == _T("HKEY_")) {
			csReturn.Insert(0,_T("\\"));
			csReturn.Insert(0,csRoots);
			break;
		}
		else {
			csReturn.Insert(0,_T("\\"));
			csReturn.Insert(0,csParent);
		}
		HTREEITEM hNewParent = m_tcRegKeys.GetParentItem(hParent);
		hParent = hNewParent;
		if (hParent == NULL) {
			break;
		}
	}

	return csReturn;
}


void CNtRegKeysDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}
