// OptListDlg.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "OptListDlg.h"

#include "SelColorDlg.h"


// COptListDlg dialog
IMPLEMENT_DYNAMIC(COptListDlg, CSAPrefsSubDlg)

COptListDlg::COptListDlg(CWnd* pParent /*=NULL*/)
	: CSAPrefsSubDlg(COptListDlg::IDD, pParent)
{
	m_bUseTreeColors = TRUE;
}

COptListDlg::~COptListDlg()
{
}

void COptListDlg::DoDataExchange(CDataExchange* pDX)
{
	CSAPrefsSubDlg::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST1, m_xLC);
	DDX_Control(pDX, BTN_APPLY_CHGS_LIST, m_btnApply);
	DDX_Control(pDX, CHK_USE_TREE_COLORS, m_chkUseTreeColors);
}


BEGIN_MESSAGE_MAP(COptListDlg, CSAPrefsSubDlg)
	ON_BN_CLICKED(BTN_APPLY_CHGS_LIST, OnApply)
#if _MSC_VER >= 1400
	ON_NOTIFY(NM_CLICK, IDC_LIST1, &COptListDlg::OnNMClickList1)
	ON_BN_CLICKED(CHK_USE_TREE_COLORS, &COptListDlg::OnBnClickedUseTreeColors)
#else
	ON_NOTIFY(NM_CLICK, IDC_LIST1, COptListDlg::OnNMClickList1)
	ON_BN_CLICKED(CHK_USE_TREE_COLORS, COptListDlg::OnBnClickedUseTreeColors)
#endif
END_MESSAGE_MAP()


// COptListDlg message handlers
BOOL COptListDlg::OnInitDialog() 
{
	CSAPrefsSubDlg::OnInitDialog();

	m_xLC.InsertColumn(0,_T("Name"),LVCFMT_LEFT,60);
	m_xLC.InsertColumn(1,_T("Type"),LVCFMT_LEFT,210);
	m_xLC.InsertColumn(2,_T("Data"),LVCFMT_LEFT,120);

	CNtRegistry reg;
	if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE)) {
		//
		m_bUseTreeColors = theApp.m_clsMainFrm->m_bUseTreeColors = reg.ReadBool(_T("UseTreeColors"),TRUE);
	}

	m_chkUseTreeColors.SetCheck(m_bUseTreeColors);

	m_bItemsModified = FALSE;
	m_btnApply.EnableWindow(FALSE);

	m_xLC.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT|LVS_EX_INFOTIP);

	RefreshList();

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void COptListDlg::RefreshList(void)
{

	m_xLC.DeleteAllItems();

	COLORREF crText = RGB(0,0,0);
	COLORREF crBG = RGB(255,255,255);

	int nItem = 0;

	CNtRegistry reg;
	reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE);
	if (!m_bUseTreeColors) {
		reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl\\ItemColors"),TRUE,TRUE);
	}

	CString csItem = _T("");
	for (int n=1; n<12; n++) {
		//
		if (!m_bUseTreeColors) {
			switch(n)
			{
			case 1:
				crText = theApp.m_clsMainFrm->m_crSZ = reg.ReadColor(_T("SZ"),RGB(0,0,0)); break;
			case 2:
				crText = theApp.m_clsMainFrm->m_crEXPAND_SZ = reg.ReadColor(_T("EXPAND_SZ"),RGB(0,0,0)); break;
			case 3:
				crText = theApp.m_clsMainFrm->m_crBINARY = reg.ReadColor(_T("BINARY"),RGB(0,0,0)); break;
			case 4:
				crText = theApp.m_clsMainFrm->m_crDWORD = reg.ReadColor(_T("DWORD"),RGB(0,0,0)); break;
			case 5:
				crText = theApp.m_clsMainFrm->m_crDWORD_BIG_ENDIAN = reg.ReadColor(_T("DWORD_BIG_ENDIAN"),RGB(0,0,0)); break;
			case 6:
				crText = theApp.m_clsMainFrm->m_crLINK = reg.ReadColor(_T("LINK"),RGB(0,0,0)); break;
			case 7:
				crText = theApp.m_clsMainFrm->m_crMULTI_SZ = reg.ReadColor(_T("MULTI_SZ"),RGB(0,0,0)); break;
			case 8:
				crText = theApp.m_clsMainFrm->m_crRESOURCE_LIST = reg.ReadColor(_T("RESOURCE_LIST"),RGB(0,0,0)); break;
			case 9:
				crText = theApp.m_clsMainFrm->m_crFULL_RESOURCE_DESCRIPTOR = reg.ReadColor(_T("FULL_RESOURCE_DESCRIPTOR"),RGB(0,0,0)); break;
			case 10:
				crText = theApp.m_clsMainFrm->m_crRESOURCE_REQUIREMENTS_LIST = reg.ReadColor(_T("RESOURCE_REQUIREMENTS_LIST"),RGB(0,0,0)); break;
			case 11:
				crText = theApp.m_clsMainFrm->m_crQWORD = reg.ReadColor(_T("QWORD"),RGB(0,0,0)); break;
			}
		}
		else {
			crText = RGB(0,0,0);
		}

		csItem.Format(_T("Item #%02i"),n);
		nItem = m_xLC.InsertItem(m_xLC.GetItemCount(),csItem,crText,crBG);
		switch(n)
		{
		case 1:
			m_xLC.SetItemText(nItem,1,"REG_SZ");
			m_xLC.SetItemText(nItem,2,"String");
			break;
		case 2:
			m_xLC.SetItemText(nItem,1,"REG_EXPAND_SZ");
			m_xLC.SetItemText(nItem,2,"%Expand% String");
			break;
		case 3:
			m_xLC.SetItemText(nItem,1,"REG_BINARY");
			m_xLC.SetItemText(nItem,2,"00 2a 3b 44 21 00");
			break;
		case 4:
			m_xLC.SetItemText(nItem,1,"REG_DWORD");
			m_xLC.SetItemText(nItem,2,"0x00000001 (1)");
			break;
		case 5:
			m_xLC.SetItemText(nItem,1,"REG_DWORD_BIG_ENDIAN");
			m_xLC.SetItemText(nItem,2,"0x00000001 (1)");
			break;
		case 6:
			m_xLC.SetItemText(nItem,1,"REG_LINK");
			m_xLC.SetItemText(nItem,2,"00 2a 3b 44 21 00");
			break;
		case 7:
			m_xLC.SetItemText(nItem,1,"REG_MULTI_SZ");
			m_xLC.SetItemText(nItem,2,"Multi String");
			break;
		case 8:
			m_xLC.SetItemText(nItem,1,"REG_RESOURCE_LIST");
			m_xLC.SetItemText(nItem,2,"00 2a 3b 44 21 00");
			break;
		case 9:
			m_xLC.SetItemText(nItem,1,"REG_FULL_RESOURCE_DESCRIPTOR");
			m_xLC.SetItemText(nItem,2,"00 2a 3b 44 21 00");
			break;
		case 10:
			m_xLC.SetItemText(nItem,1,"REG_RESOURCE_REQUIREMENTS_LIST");
			m_xLC.SetItemText(nItem,2,"00 2a 3b 44 21 00");
			break;
		case 11:
			m_xLC.SetItemText(nItem,1,"REG_QWORD");
			m_xLC.SetItemText(nItem,2,"00 2a 3b 44 21 00");
			break;
		}
	}
}

void COptListDlg::OnApply() 
{
	CNtRegistry reg;
	if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE))
	{
		reg.WriteBool(_T("UseTreeColors"),theApp.m_clsMainFrm->m_bUseTreeColors);
		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl\\ItemColors"),TRUE,TRUE))
		{
			reg.WriteColor(_T("SZ"),theApp.m_clsMainFrm->m_crSZ);
			reg.WriteColor(_T("EXPAND_SZ"),theApp.m_clsMainFrm->m_crEXPAND_SZ);
			reg.WriteColor(_T("BINARY"),theApp.m_clsMainFrm->m_crBINARY);
			reg.WriteColor(_T("DWORD"),theApp.m_clsMainFrm->m_crDWORD);
			reg.WriteColor(_T("DWORD_BIG_ENDIAN"),theApp.m_clsMainFrm->m_crDWORD_BIG_ENDIAN);
			reg.WriteColor(_T("LINK"),theApp.m_clsMainFrm->m_crLINK);
			reg.WriteColor(_T("MULTI_SZ"),theApp.m_clsMainFrm->m_crMULTI_SZ);
			reg.WriteColor(_T("RESOURCE_LIST"),theApp.m_clsMainFrm->m_crRESOURCE_LIST);
			reg.WriteColor(_T("FULL_RESOURCE_DESCRIPTOR"),theApp.m_clsMainFrm->m_crFULL_RESOURCE_DESCRIPTOR);
			reg.WriteColor(_T("RESOURCE_REQUIREMENTS_LIST"),theApp.m_clsMainFrm->m_crRESOURCE_REQUIREMENTS_LIST);
			reg.WriteColor(_T("QWORD"),theApp.m_clsMainFrm->m_crQWORD);
		}
		m_bItemsModified = FALSE;
		m_btnApply.EnableWindow(FALSE);
	}
	RefreshList();
	theApp.m_clsTV->ShowValues();
}

void COptListDlg::OnNMClickList1(NMHDR *pNMHDR, LRESULT *pResult)
{
	CPoint pt;
	GetCursorPos(&pt);

	CPoint MousePosition = pt;
	m_xLC.ScreenToClient (&MousePosition);

	// Used to find the sub-item below
	CRect rect;

	// Flags for where the user clicked on.
	UINT uFlags=0;
	int nItem = m_xLC.HitTest(MousePosition, &uFlags);
	if (nItem != -1) {
		//
		COLORREF rgbColor = RGB(0,0,0);

		CString csItem = m_xLC.GetItemText(nItem,1);

		// create an instance of the color selector
		CSelColorDlg dlgSelColor(GetRValue(rgbColor),GetGValue(rgbColor),GetBValue(rgbColor));
		// display the color changing dialog box
		if(dlgSelColor.DoModal() == IDOK)
		{
			m_xLC.SetRedraw(FALSE);
			// select the new colour
			rgbColor = dlgSelColor.GetColor();

			CNtRegistry reg;
			reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl\\ItemColors"),TRUE,TRUE);
			if (csItem == _T("REG_SZ")) {
				theApp.m_clsMainFrm->m_crSZ = rgbColor;
			}
			else if (csItem == _T("REG_EXPAND_SZ")) {
				theApp.m_clsMainFrm->m_crEXPAND_SZ = rgbColor;
			}
			else if (csItem == _T("REG_BINARY")) {
				theApp.m_clsMainFrm->m_crBINARY = rgbColor;
			}
			else if (csItem == _T("REG_DWORD")) {
				theApp.m_clsMainFrm->m_crDWORD = rgbColor;
			}
			else if (csItem == _T("REG_DWORD_BIG_ENDIAN")) {
				theApp.m_clsMainFrm->m_crDWORD_BIG_ENDIAN = rgbColor;
			}
			else if (csItem == _T("REG_LINK")) {
				theApp.m_clsMainFrm->m_crLINK = rgbColor;
			}
			else if (csItem == _T("REG_MULTI_SZ")) {
				theApp.m_clsMainFrm->m_crMULTI_SZ = rgbColor;
			}
			else if (csItem == _T("REG_RESOURCE_LIST")) {
				theApp.m_clsMainFrm->m_crRESOURCE_LIST = rgbColor;
			}
			else if (csItem == _T("REG_FULL_RESOURCE_DESCRIPTOR")) {
				theApp.m_clsMainFrm->m_crFULL_RESOURCE_DESCRIPTOR = rgbColor;
			}
			else if (csItem == _T("REG_RESOURCE_REQUIREMENTS_LIST")) {
				theApp.m_clsMainFrm->m_crRESOURCE_REQUIREMENTS_LIST = rgbColor;
			}
			else if (csItem == _T("REG_QWORD")) {
				theApp.m_clsMainFrm->m_crQWORD = rgbColor;
			}

			m_bItemsModified = TRUE;
			m_btnApply.EnableWindow(m_bItemsModified);

			// Paint it...
			m_xLC.SetRedraw(TRUE);
		}
	}
	*pResult = 0;
}

void COptListDlg::OnBnClickedUseTreeColors()
{
	m_bUseTreeColors = (BOOL)m_chkUseTreeColors.GetCheck();
	theApp.m_clsMainFrm->m_bUseTreeColors = m_bUseTreeColors;
	m_bItemsModified = TRUE;
	m_btnApply.EnableWindow(m_bItemsModified);
	RefreshList();
}


/*
	CNtRegistry reg;
	if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE))
	{
		reg.WriteBool(_T("UseTreeColors"),FALSE);
		if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl\\ItemColors"),TRUE,TRUE))
		{
			reg.WriteColor(_T("SZ"),RGB(0,0,0));
			reg.WriteColor(_T("EXPAND_SZ"),RGB(0,0,0));
			reg.WriteColor(_T("BINARY"),RGB(0,0,0));
			reg.WriteColor(_T("DWORD"),RGB(0,0,0));
			reg.WriteColor(_T("DWORD_BIG_ENDIAN"),RGB(0,0,0));
			reg.WriteColor(_T("LINK"),RGB(0,0,0));
			reg.WriteColor(_T("MULTI_SZ"),RGB(0,0,0));
			reg.WriteColor(_T("RESOURCE_LIST"),RGB(0,0,0));
			reg.WriteColor(_T("FULL_RESOURCE_DESCRIPTOR"),RGB(0,0,0));
			reg.WriteColor(_T("RESOURCE_REQUIREMENTS_LIST"),RGB(0,0,0));
			reg.WriteColor(_T("QWORD"),RGB(0,0,0));
		}
	}


	m_crSZ = RGB(0,0,0);
	m_crEXPAND_SZ = RGB(0,0,0);
	m_crBINARY = RGB(0,0,0);
	m_crDWORD = RGB(0,0,0);
	m_crDWORD_BIG_ENDIAN = RGB(0,0,0);
	m_crLINK = RGB(0,0,0);
	m_crMULTI_SZ = RGB(0,0,0);
	m_crRESOURCE_LIST = RGB(0,0,0);
	m_crFULL_RESOURCE_DESCRIPTOR = RGB(0,0,0);
	m_crRESOURCE_REQUIREMENTS_LIST = RGB(0,0,0);
	m_crQWORD = RGB(0,0,0);

	m_bUseTreeColors = FALSE;

	CNtRegistry reg;
	if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl"),TRUE,TRUE))
	{
		m_bUseTreeColors = reg.ReadBool(_T("UseTreeColors"),FALSE);
		if (m_bUseTreeColors) {
			//
			if (reg.SetKey(HKEY_CURRENT_USER,_T("Software\\NtRegEdit\\Settings\\ListCtrl\\ItemColors"),TRUE,TRUE))
			{
				m_crSZ = reg.ReadColor(_T("SZ"),RGB(0,0,0));
				m_crEXPAND_SZ = reg.ReadColor(_T("EXPAND_SZ"),RGB(0,0,0));
				m_crBINARY = reg.ReadColor(_T("BINARY"),RGB(0,0,0));
				m_crDWORD = reg.ReadColor(_T("DWORD"),RGB(0,0,0));
				m_crDWORD_BIG_ENDIAN = reg.ReadColor(_T("DWORD_BIG_ENDIAN"),RGB(0,0,0));
				m_crLINK = reg.ReadColor(_T("LINK"),RGB(0,0,0));
				m_crMULTI_SZ = reg.ReadColor(_T("MULTI_SZ"),RGB(0,0,0));
				m_crRESOURCE_LIST = reg.ReadColor(_T("RESOURCE_LIST"),RGB(0,0,0));
				m_crFULL_RESOURCE_DESCRIPTOR = reg.ReadColor(_T("FULL_RESOURCE_DESCRIPTOR"),RGB(0,0,0));
				m_crRESOURCE_REQUIREMENTS_LIST = reg.ReadColor(_T("RESOURCE_REQUIREMENTS_LIST"),RGB(0,0,0));
				m_crQWORD = reg.ReadColor(_T("QWORD"),RGB(0,0,0));
			}
		}
	}
*/

