#pragma once


#include "SAPrefsDialog.h"
#include "TreeCtrlEx.h"

// COptTreeDlg dialog
class COptTreeDlg : public CSAPrefsSubDlg
{
	DECLARE_DYNAMIC(COptTreeDlg)

	HTREEITEM	m_hRoot;
	HTREEITEM	m_hHKLM;
	HTREEITEM	m_hHKCU;
	HTREEITEM	m_hHKU;
	HTREEITEM	m_hHKCR;
	HTREEITEM	m_hHKCC;

	COLORREF	m_crHKCRColors;
	COLORREF	m_crHKCUColors;
	COLORREF	m_crHKLMColors;
	COLORREF	m_crHKUColors;
	COLORREF	m_crHKCCColors;

	BOOL		m_bBold;
	BOOL		m_bBoldHidden;
	BOOL		m_bColors;

	volatile BOOL m_bItemsModified;

	void RefreshItems(void);
	void ModifyAll(void);
	void ChangeFont(void);

public:
	COptTreeDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~COptTreeDlg();

// Dialog Data
	enum { IDD = IDD_OPTTREE_DLG };
	CTreeCtrlEx	m_tcTree;
	CButton	m_chkBold;
	CButton	m_chkBoldHidden;
	CButton	m_btnApplyChgs;
	CButton	m_chkColor;

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
	virtual BOOL OnInitDialog();
	virtual void OnOK();
	afx_msg void OnColors();
	afx_msg void OnClickTree(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnApplyChgsTree();
	afx_msg void OnBold();
	afx_msg void OnBoldHidden();
};
