// StringView.cpp : implementation file
//

#include "stdafx.h"
#include "NtRegEdit.h"
#include "StringView.h"

// CStringView
IMPLEMENT_DYNCREATE(CStringView, CFormView)

CStringView::CStringView()
	: CFormView(CStringView::IDD)
{
}

CStringView::~CStringView()
{
}

void CStringView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	DDX_Control(pDX, EDT_STRING_DATA, m_edtString);
	DDX_Control(pDX, BTN_UPDATE, m_btnUpdate);
	DDX_Control(pDX, EDT_CREATE_NAME, m_edtCreateName);
	DDX_Control(pDX, CBO_STRING_TYPE, m_cboStringType);
}

BEGIN_MESSAGE_MAP(CStringView, CFormView)
#if _MSC_VER >= 1400
	ON_EN_CHANGE(EDT_STRING_DATA, &CStringView::OnEnChangeSData)
	ON_BN_CLICKED(BTN_UPDATE, &CStringView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, &CStringView::OnEnChangeCreateName)
	ON_EN_UPDATE(EDT_STRING_DATA, &CStringView::OnEnUpdateStringData)
	ON_CBN_SELCHANGE(CBO_STRING_TYPE, &CStringView::OnCbnSelchangeStringType)
#else
	ON_EN_CHANGE(EDT_STRING_DATA, CStringView::OnEnChangeSData)
	ON_BN_CLICKED(BTN_UPDATE, CStringView::OnBnClickedUpdate)
	ON_EN_CHANGE(EDT_CREATE_NAME, CStringView::OnEnChangeCreateName)
	ON_EN_UPDATE(EDT_STRING_DATA, CStringView::OnEnUpdateStringData)
	ON_CBN_SELCHANGE(CBO_STRING_TYPE, CStringView::OnCbnSelchangeStringType)
#endif
END_MESSAGE_MAP()


// CStringView diagnostics
#ifdef _DEBUG
void CStringView::AssertValid() const { CFormView::AssertValid(); }
#ifndef _WIN32_WCE
	void CStringView::Dump(CDumpContext& dc) const { CFormView::Dump(dc); }
#endif
#endif //_DEBUG


// CStringView message handlers
void CStringView::OnInitialUpdate()
{
	CFormView::OnInitialUpdate();

	m_btnUpdate.EnableWindow(FALSE);

	m_nRegExStr = m_cboStringType.AddString(_T("REG_EXPAND_SZ"));
	m_nRegStr = m_cboStringType.AddString(_T("REG_SZ"));
	m_btnUpdate.SetWindowTextA(_T("Update"));
	m_bCreating = FALSE;

	m_cboStringType.EnableWindow(FALSE);

	theApp.m_clsString = (CStringView*)this;
}

void CStringView::OnEnChangeSData()
{
	CString csData = _T("");
	m_edtString.GetWindowText(csData);
	if (m_csOriginalData == csData) {
		CString csValueName = _T("");
		m_edtCreateName.GetWindowTextA(csValueName);
		if (csValueName.IsEmpty()) {
			m_btnUpdate.EnableWindow(FALSE);
		}
		else {
			m_btnUpdate.EnableWindow(TRUE);
		}
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
	}

	if (m_bCreating) {
		m_btnUpdate.SetWindowTextA(_T("Create"));
	}
	else {
		m_btnUpdate.SetWindowTextA(_T("Update"));
	}
}

void CStringView::OnEnChangeCreateName()
{
	//m_btnCreate.EnableWindow(TRUE);
	m_cboStringType.EnableWindow(TRUE);

	CString csValueName = _T("");
	m_edtCreateName.GetWindowTextA(csValueName);
	if (csValueName.IsEmpty()) {
		CString csData = _T("");
		m_edtString.GetWindowText(csData);
		if (m_csOriginalData == csData) {
			m_btnUpdate.EnableWindow(FALSE);
		}
		else {
			m_btnUpdate.EnableWindow(TRUE);
		}
		m_btnUpdate.SetWindowTextA(_T("Update"));
		m_bCreating = FALSE;
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
		m_btnUpdate.SetWindowTextA(_T("Create"));
		m_bCreating = TRUE;
	}
}

void CStringView::OnBnClickedUpdate()
{
	CString csData = _T("");
	m_edtString.GetWindowText(csData);

	BOOL bOKContinue = FALSE;
	if (m_bCreating) {
		//
		m_edtCreateName.GetWindowTextA(m_csValueName);
		if (m_cboStringType.GetCurSel() == m_nRegExStr) {
			//
			bOKContinue = theApp.m_clsTV->m_ntReg.WriteExpandString(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName,
													csData);
		}
		else {
			bOKContinue = theApp.m_clsTV->m_ntReg.WriteString(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
													m_csValueName,
													csData);
		}
	}
	else {
		if (m_cboStringType.GetCurSel() == REG_EXPAND_SZ) {
			bOKContinue = theApp.m_clsTV->m_ntReg.WriteExpandString(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
															m_csValueName,
															csData);
		}
		else {
			bOKContinue = theApp.m_clsTV->m_ntReg.WriteString(theApp.m_clsTV->m_ntReg.GetCurrentPath(),
														m_csValueName,
														csData);
		}
	}

	if (bOKContinue) {
		//
		theApp.m_clsLV->m_xList.SetRedraw(FALSE);
		theApp.m_clsTV->ShowValues();
		for (int n=0; n<theApp.m_clsLV->m_xList.GetItemCount(); n++) {
			CString csText = theApp.m_clsLV->m_xList.GetItemText(n,0);
			if (csText == m_csValueName) {
				theApp.m_clsLV->m_xList.SetCurSel(n);
			}
		}
		m_edtCreateName.SetWindowTextA(_T(""));
		m_btnUpdate.EnableWindow(FALSE);
		m_cboStringType.EnableWindow(FALSE);
		theApp.m_clsLV->m_xList.SetRedraw(TRUE);
	}
}

void CStringView::OnEnUpdateStringData()
{
	CString csData = _T("");
	m_edtString.GetWindowText(csData);
	if (m_csOriginalData == csData) {
		m_btnUpdate.EnableWindow(FALSE);
	}
	else {
		m_btnUpdate.EnableWindow(TRUE);
	}
}

void CStringView::OnCbnSelchangeStringType()
{
	//m_dwRegType = m_cboStringType.GetCurSel();
}
